/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2014 ohD(yasushi@tanaka.net)
 *	Copyright (C) 2001-2014 Ryu Takegami
 *	Copyright (C) 2010-2014 Toma
 *
 *	[ foCXˑ ]
 */

#ifndef _device_h_
#define _device_h_

/*
 *	萔`
 */
#define OPEN_R		1					/* ǂݍ݃[h */
#define OPEN_W		2					/* ݃[h */
#define OPEN_RW		3					/* ǂݏ[h */

#define SOUND_STOP			255			/* TEh~ */
#define SOUND_CMTMOTORON	0			/* CMT[^䃊[ON */
#define SOUND_CMTMOTOROFF	1			/* CMT[^䃊[OFF */
#define SOUND_FDDSEEK		2			/* FDDwbhV[N */
#define SOUND_FDDHEADUP		3			/* FDDwbhAbv(gp) */
#define SOUND_FDDHEADDOWN	4			/* FDDwbh_E(gp) */

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */

/* ` */
void FASTCALL vram_notify(WORD addr, BYTE dat);
										/* VRAMݒʒm */
void FASTCALL tvram_notify(WORD addr, BYTE dat);
										/* eLXgVRAMݒʒm */
void FASTCALL ttlpalet_notify(void);
										/* fW^pbgύXʒm */
void FASTCALL apalet_notify(void);
										/* AiOpbgύXʒm */
void FASTCALL display_notify(void);
										/* ʖʒm(OtBbN) */
void FASTCALL tvram_redraw_notify(void);
										/* ʖʒm(eLXg) */
void FASTCALL digitize_notify(void);
										/* fBW^CYʒm */
void FASTCALL vsync_notify(void);
										/* VSYNCʒm */
void FASTCALL vblankperiod_notify(void);
										/* VBLANKIʒm */
void FASTCALL hblank_notify(void);
										/* HBLANKʒm */
void FASTCALL window_notify(void);
										/* n[hEFAEBhEύXʒm */

/* TEh */
#if defined(XM7DASH) && defined(OPNAMODE)
void FASTCALL opn_notify(WORD reg, BYTE dat);
										/* OPNo͒ʒm */
void FASTCALL whg_notify(WORD reg, BYTE dat);
										/* WHGo͒ʒm */
void FASTCALL thg_notify(WORD reg, BYTE dat);
										/* THGo͒ʒm */
#else
void FASTCALL opn_notify(BYTE reg, BYTE dat);
										/* OPNo͒ʒm */
void FASTCALL whg_notify(BYTE reg, BYTE dat);
										/* WHGo͒ʒm */
void FASTCALL thg_notify(BYTE reg, BYTE dat);
										/* THGo͒ʒm */
#endif
void FASTCALL beep_notify(void);
										/* BEEPo͒ʒm */
void FASTCALL tape_notify(BOOL flag);
										/* e[vo͒ʒm */
void FASTCALL midi_notify(BYTE mes);
										/* MIDIo͒ʒm */
void FASTCALL midi_reset_notify(void);
										/* MIDIZbgʒm */
void FASTCALL wav_notify(BYTE no);
										/* eʉo͒ʒm */
void FASTCALL dac_notify(BYTE dat);
										/* DACo͒ʒm */

/* WCXeBbNE}EX */
BYTE FASTCALL joy_request(BYTE port);
										/* WCXeBbNv */
void FASTCALL mospos_request(BYTE *move_x, BYTE *move_y);
										/* }EXړv */
BYTE FASTCALL mosbtn_request(void);
										/* }EX{^ԗv */

/* VA */
void FASTCALL rs232c_reset_notify(void);
										/* RS-232CZbgʒm */
void FASTCALL rs232c_senddata(BYTE dat);
										/* RS-232Cf[^M */
BYTE FASTCALL rs232c_receivedata(void);
										/* RS-232Cf[^M */
BYTE FASTCALL rs232c_readstatus(void);
										/* Xe[^XWX^[h */
void FASTCALL rs232c_writemodecmd(BYTE dat);
										/* [hR}hWX^Cg */
void FASTCALL rs232c_writecommand(BYTE dat);
										/* R}hWX^Cg */
void FASTCALL rs232c_setbaudrate(BYTE dat);
										/* {[[gWX^Cg */

/* t@C */
BOOL FASTCALL file_load(char *fname, BYTE *buf, int size);
										/* t@C[h(ROMp) */
BOOL FASTCALL file_load2(char *fname, BYTE *buf, int ptr, int size);
										/* Cӈʒũt@C[h */
BOOL FASTCALL file_save(char *fname, BYTE *buf, int size);
										/* t@CZ[u(wKRAMp) */
#ifdef XM7DASH
BOOL FASTCALL file_rename(char *fname);
										/* t@Cl[(Xe[gp) */
#endif
int FASTCALL file_open(char *fname, int mode);
										/* t@CI[v */
void FASTCALL file_close(int handle);
										/* t@CN[Y */
DWORD FASTCALL file_getsize(int handle);
										/* t@COX擾 */
BOOL FASTCALL file_seek(int handle, DWORD offset);
										/* t@CV[N */
BOOL FASTCALL file_read(int handle, BYTE *ptr, DWORD size);
										/* t@Cǂݍ */
BOOL FASTCALL file_write(int handle, BYTE *ptr, DWORD size);
										/* t@C */

/* t@CTu(vbgtH[ˑB̂system.cɂ) */
BOOL FASTCALL file_byte_read(int handle, BYTE *dat);
										/* oCgǂݍ */
BOOL FASTCALL file_word_read(int handle, WORD *dat);
										/* [hǂݍ */
BOOL FASTCALL file_dword_read(int handle, DWORD *dat);
										/* _u[hǂݍ */
BOOL FASTCALL file_bool_read(int handle, BOOL *dat);
										/* u[ǂݍ */
BOOL FASTCALL file_byte_write(int handle, BYTE dat);
										/* oCg */
BOOL FASTCALL file_word_write(int handle, WORD dat);
										/* [h */
BOOL FASTCALL file_dword_write(int handle, DWORD dat);
										/* _u[h */
BOOL FASTCALL file_bool_write(int handle, BOOL dat);
										/* u[ */
#ifdef __cplusplus
}
#endif

#endif	/* _device_h_ */
