/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2014 ohD(yasushi@tanaka.net)
 *	Copyright (C) 2001-2014 Ryu Takegami
 *	Copyright (C) 2010-2014 Toma
 *
 *	[ tbs[fBXN Rg[(MB8877A) ]
 */

#ifndef _fdc_h_
#define _fdc_h_

/*
 *	萔`
 */
#define FDC_DRIVES			4			/* T|[ghCu */
#define FDC_MEDIAS			16			/* D77t@CɊ܂܂ő喇 */

#define FDC_ST_BUSY			0x01		/* BUSY */
#define FDC_ST_INDEX		0x02		/* INDEXz[o */
#define FDC_ST_DRQ			0x02		/* f[^v */
#define FDC_ST_TRACK00		0x04		/* gbN0 */
#define FDC_ST_LOSTDATA		0x04		/* f[^Xg */
#define FDC_ST_CRCERR		0x08		/* CRCG[ */
#define FDC_ST_SEEKERR		0x10		/* V[NG[ */
#define FDC_ST_RECNFND		0x10		/* ZN^s */
#define FDC_ST_HEADENG		0x20		/* wbht */
#define FDC_ST_RECTYPE		0x20		/* R[h^Cvُ */
#define FDC_ST_WRITEFAULT	0x20		/* ݎs */
#define FDC_ST_WRITEP		0x40		/* ݕی */
#define FDC_ST_NOTREADY		0x80		/* fBA} */

#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
#define IFDC_ST_FDD_ERR		0x01		/* FDD ERROR */
#define IFDC_ST_CMD_ERR		0x02		/* COMMAND ERROR */
#define IFDC_ST_DAT_ERR		0x04		/* DATA ERROR */
#define IFDC_ST_DMA_ERR		0x08		/* DMA ERROR */
#define IFDC_ST_TFR_ACK		0x10		/* TRANSFER ACKNOWLEDE */
#define IFDC_ST_RESERVED1	0x20		/* RESERVED */
#define IFDC_ST_RESERVED2	0x40		/* RESERVED */
#define IFDC_ST_READY		0x80		/* READY */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

#define FDC_TYPE_NOTREADY	0			/* t@CȂ */
#define FDC_TYPE_2D			1			/* 2Dt@C}Eg */
#define FDC_TYPE_D77		2			/* D77t@C}Eg */
#define FDC_TYPE_VFD		3			/* VFDt@C}Eg */
#define FDC_TYPE_2DD		4			/* 2DDt@C}Eg */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
#define FDC_TYPE_2HD		5			/* 2HDt@C}Eg */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

#define FDC_ACCESS_READY	0			/* ANZXȂ */
#define FDC_ACCESS_SEEK		1			/* V[NnANZX */
#define FDC_ACCESS_READ		2			/* ǂݍ݌nANZX */
#define FDC_ACCESS_WRITE	3			/* ݌nANZX */
#define FDC_ACCESS_NOTREADY	4			/* hCȕłĂȂ */
#ifdef XM7DASH
#define FDC_ACCESS_TEJECT	5			/* hCuꎞCWFNg */
#endif

#define FDC_LOST_TIME		48			/* waitLOST DATA܂ł̎ */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
#define FDC_LOST_TIME_S		40			/* waitLOST DATA܂ł̎(SFD) */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
#define FDC_M				0			/* MFDC(320KB FDC) */
#define FDC_S				1			/* SFDC(1MB FDC) */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL fdc_init(void);
										/*  */
void FASTCALL fdc_cleanup(void);
										/* N[Abv */
void FASTCALL fdc_reset(void);
										/* Zbg */
BOOL FASTCALL fdc_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL fdc_writeb(WORD addr, BYTE dat);
										/*  */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
BOOL FASTCALL ifdc_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL ifdc_writeb(WORD addr, BYTE dat);
										/*  */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
BOOL FASTCALL fdc_save(int fileh);
										/* Z[u */
BOOL FASTCALL fdc_load(int fileh, int ver);
										/* [h */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
BOOL FASTCALL ifdc_save(int fileh);
										/* Z[u */
BOOL FASTCALL ifdc_load(int fileh, int ver);
										/* [h */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
int FASTCALL fdc_setdisk(int type, int drive, char *fname);
										/* fBXNZbg */
BOOL FASTCALL fdc_setmedia(int type, int drive, int index);
										/* fBXNt@CfBAw */
BOOL FASTCALL fdc_setwritep(int type, int drive, BOOL writep);
										/* CgveNgw */
#else	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
int FASTCALL fdc_setdisk(int drive, char *fname);
										/* fBXNZbg */
BOOL FASTCALL fdc_setmedia(int drive, int index);
										/* fBXNt@CfBAw */
BOOL FASTCALL fdc_setwritep(int drive, BOOL writep);
										/* CgveNgw */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

/*
 *	v[N
 */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
extern BYTE fdc_command[2];
										/* $FD18 FDCR}h */
extern BYTE fdc_status[2];
										/* $FD18 FDCXe[^X */
extern BYTE fdc_trkreg[2];
										/* $FD19 gbNWX^ */
extern BYTE fdc_secreg[2];
										/* $FD1A ZN^WX^ */
extern BYTE fdc_datareg[2];
										/* $FD1B f[^WX^ */
extern BYTE fdc_sidereg[2];
										/* $FD1C TChWX^ */
extern BYTE fdc_motor[2];
										/* $FD1D [^(on:0x80 off:0x00) */
extern BYTE fdc_drvreg[2];
										/* $FD1D hCu(0-3) */
extern BYTE fdc_drqirq[2];
										/* $FD1F DRQ, IRQ, ̑tO */

extern BYTE fdc_cmdtype[2];
										/* R}h^Cv */
extern WORD fdc_totalcnt[2];
										/* g[^JE^ */
extern WORD fdc_nowcnt[2];
										/* JgJE^ */
extern BYTE fdc_ready[2][FDC_DRIVES];
										/* fB */
extern BOOL fdc_teject[2][FDC_DRIVES];
										/* ꎞCWFNg */
extern BOOL fdc_writep[2][FDC_DRIVES];
										/* ݋֎~ */
extern BYTE fdc_track[2][FDC_DRIVES];
										/* gbN */

extern char fdc_fname[2][FDC_DRIVES][256+1];
										/* t@Cl[ */
extern char fdc_name[2][FDC_DRIVES][FDC_MEDIAS][17];
										/* fBAƂ̖O */
extern BOOL fdc_fwritep[2][FDC_DRIVES];
										/* ݋֎~(t@CP) */
extern BYTE fdc_header[2][FDC_DRIVES][0x2b0];
										/* D77t@Cwb_ */
extern BYTE fdc_medias[2][FDC_DRIVES];
										/* fBA */
extern BYTE fdc_media[2][FDC_DRIVES];
										/* fBAZNg */
extern BYTE fdc_access[2][FDC_DRIVES];
										/* ANZXLED */
extern BYTE fdc_doorlock[FDC_DRIVES];
										/* hAbN */
#else	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
extern BYTE fdc_command;
										/* $FD18 FDCR}h */
extern BYTE fdc_status;
										/* $FD18 FDCXe[^X */
extern BYTE fdc_trkreg;
										/* $FD19 gbNWX^ */
extern BYTE fdc_secreg;
										/* $FD1A ZN^WX^ */
extern BYTE fdc_datareg;
										/* $FD1B f[^WX^ */
extern BYTE fdc_sidereg;
										/* $FD1C TChWX^ */
extern BYTE fdc_motor;
										/* $FD1D [^(on:0x80 off:0x00) */
extern BYTE fdc_drvreg;
										/* $FD1D hCu(0-3) */
extern BYTE fdc_drqirq;
										/* $FD1F DRQ, IRQ, ̑tO */


#if XM7_VER >= 3
extern BYTE fdc_logidrv;
										/* $FD1E _hCuԍ */
extern BYTE fdc_physdrv[FDC_DRIVES];
										/* $FD1E _/hCȗΉ */
extern BYTE fdc_2ddmode;
										/* $FD1E 2DD[hZNg */
#endif

extern BYTE fdc_cmdtype;
										/* R}h^Cv */
extern WORD fdc_totalcnt;
										/* g[^JE^ */
extern WORD fdc_nowcnt;
										/* JgJE^ */
extern BYTE fdc_ready[FDC_DRIVES];
										/* fB */
extern BOOL fdc_teject[FDC_DRIVES];
										/* ꎞCWFNg */
extern BOOL fdc_writep[FDC_DRIVES];
										/* ݋֎~ */
extern BYTE fdc_track[FDC_DRIVES];
										/* gbN */

extern char fdc_fname[FDC_DRIVES][256+1];
										/* t@Cl[ */
extern char fdc_name[FDC_DRIVES][FDC_MEDIAS][17];
										/* fBAƂ̖O */
extern BOOL fdc_fwritep[FDC_DRIVES];
										/* ݋֎~(t@CP) */
extern BYTE fdc_header[FDC_DRIVES][0x2b0];
										/* D77t@Cwb_ */
extern BYTE fdc_medias[FDC_DRIVES];
										/* fBA */
extern BYTE fdc_media[FDC_DRIVES];
										/* fBAZNg */
extern BYTE fdc_access[FDC_DRIVES];
										/* ANZXLED */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

#ifdef FDDSND
extern BOOL fdc_waitmode;
										/* FDCANZXEFCg */
extern BOOL fdc_sound;
										/* FDDV[NtO */
#endif

#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
extern BOOL sfdc_enable;
										/* SFDCLEtO */
extern BOOL sfdc_use;
										/* SFDCgptO */
extern BYTE sfdc_mode;
										/* SFDC[htO */
extern BYTE sfdc_density;
										/* $FD1C SFDCPx/{xtO */
extern DWORD sfdc_irq_time;
										/* SFDCG[荞݂܂ł̎ */
extern DWORD sfdc_eod_time;
										/* SFDCf[^]荞݂܂ł̎ */

extern BYTE ifdc_ssr;
										/* IFDC VXeXe[^XWX^(SSR) */
extern BYTE ifdc_fsr;
										/* IFDC FDCXe[^XWX^(FSR) */
extern BYTE ifdc_rrr;
										/* IFDC WX^U[uWX^(RRR) */
extern BYTE ifdc_rdr;
										/* IFDC WX^f[^WX^(RDR) */

extern BYTE ifdc_cmdreg;
										/* IFDC R}hWX^(CMDREG) */
extern BYTE ifdc_trkreg;
										/* IFDC gbNWX^(TRKREG) */
extern BYTE ifdc_ssreg;
										/* IFDC ZN^X^[gWX^(SSREG) */
extern BYTE ifdc_sereg;
										/* IFDC ZN^GhWX^(SEREG) */
extern BYTE ifdc_sidreg;
										/* IFDC TChWX^(SIDREG) */
extern BYTE ifdc_dnsreg;
										/* IFDC xWX^(DNSREG) */
extern BYTE ifdc_drvreg;
										/* IFDC hCuWX^(DRVREG) */
extern BYTE ifdc_dlcreg;
										/* IFDC hAbNWX^(DLCREG) */
extern BYTE ifdc_sformt;
										/* IFDC ZN^tH[}bg(SFORMT) */
extern BYTE ifdc_secdat;
										/* IFDC ZN^OX(SECDAT) */
extern BYTE ifdc_modreg;
										/* IFDC [hZbgWX^(MODREG) */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

#ifdef __cplusplus
}
#endif

#endif	/* _fdc_h_ */
