/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2014 ohD(yasushi@tanaka.net)
 *	Copyright (C) 2001-2014 Ryu Takegami
 *	Copyright (C) 2010-2014 Toma
 *
 *	[ MMR,TWR / I/O^RAMfBXN ]
 */

#ifndef _mmr_h_
#define _mmr_h_

#if XM7_VER == 1 && defined(XM7DASH)
/*
 *	^`
 */
enum {
	EXRAM_OFF = 0,						/* gRAM OFF[h */
	EXRAM_64KB,							/* gRAM 64KB[h+oNZNg */
	EXRAM_192KB,						/* gRAM 192KB[h */
	EXRAM_960KB,						/* gRAM 960KB[h+gMMR/MSR */
};
#endif

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL mmr_init(void);
										/*  */
void FASTCALL mmr_cleanup(void);
										/* N[Abv */
void FASTCALL mmr_reset(void);
										/* Zbg */
BOOL FASTCALL mmr_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL mmr_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL mmr_extrb(WORD *addr, BYTE *dat);
										/* MMRoRǂݏo */
BOOL FASTCALL mmr_extbnio(WORD *addr, BYTE *dat);
										/* MMRoRǂݏo(I/OȂ) */
BOOL FASTCALL mmr_extwb(WORD *addr, BYTE dat);
										/* MMRoR */
#ifdef XM7DASH
BOOL FASTCALL mmr_extrbsegnio(WORD *addr, BYTE *dat, BYTE seg, int mode);
										/* MMRoRǂݏo(MSRw,I/OȂ) */
BOOL FASTCALL mmr_extwbseg(WORD *addr, BYTE dat, BYTE seg, int mode);
										/* MMRoR(MSRw) */
#endif
BOOL FASTCALL mmr_save(int fileh);
										/* Z[u */
BOOL FASTCALL mmr_load(int fileh, int ver);
										/* [h */

/*
 *	v[N
 */
extern BOOL mmr_flag;
										/* MMRLtO */
extern BYTE mmr_seg;
										/* MMRZOg */
extern BOOL mmr_modify;
										/* MMRԕύXtO */
#if XM7_VER >= 3
extern BYTE mmr_reg[0x80];
										/* MMRWX^ */
extern BOOL mmr_ext;
										/* gMMRLtO */
extern BOOL mmr_fastmode;
										/* MMRtO */
extern BOOL mmr_extram;
										/* gRAMLtO */
extern BOOL mmr_fast_refresh;
										/* tbVtO */
#else
#if XM7_VER == 1 && defined(XM7DASH)
extern BYTE mmr_reg[0x400];
										/* MMRWX^ */
extern BYTE mmr_extrmw;
										/* gRAM/MMR/WBR[h */
#else
extern BYTE mmr_reg[0x40];
										/* MMRWX^ */
#endif
#endif
extern BOOL twr_flag;
										/* TWRLtO */
extern BYTE twr_reg;
										/* TWRWX^ */
#ifdef XM7DASH
extern BYTE wbr_reg;
										/* WBRWX^ */
extern BYTE bsr_reg;
										/* gRAMoNZNgWX^ */
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _mmr_h_ */
