/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2014 ohD(yasushi@tanaka.net)
 *	Copyright (C) 2001-2014 Ryu Takegami
 *	Copyright (C) 2010-2014 Toma
 *
 *	[ CeWFg}EX ]
 */

#ifdef MOUSE

#include <assert.h>
#include <string.h>
#include "xm7.h"
#include "device.h"
#include "mainetc.h"
#include "event.h"
#include "mouse.h"

/*
 *	O[o [N
 */
BYTE mos_port;							/* }EXڑ|[g */
BOOL mos_capture;						/* }EXLv`tO */

/*
 *	X^eBbN [N
 */
static BYTE mos_x;						/* wړ (:+ E:-) */
static BYTE mos_y;						/* xړ (:+ :-) */
static BYTE mos_phase;					/* tF[YJE^ */
static BOOL mos_strobe;					/* Xg[uM(ۑp) */


/*
 *	CeWFg}EX
 *	
 */
BOOL FASTCALL mos_init(void)
{
	/* }EXLv`~ */
	mos_port = 1;
	mos_capture = FALSE;

	return TRUE;
}

/*
 *	CeWFg}EX
 *	N[Abv
 */
void FASTCALL mos_cleanup(void)
{
}

/*
 *	CeWFg}EX
 *	Zbg
 */
void FASTCALL mos_reset(void)
{
	/* [NGA */
	mos_x = 0;
	mos_y = 0;
	mos_phase = 0;
	mos_strobe = FALSE;
}

/*
 *	CeWFg}EX
 *	^CAEg
 */
static BOOL FASTCALL mos_timeout(void)
{
	/* ^CAEgCxg폜 */
	schedule_delevent(EVENT_MOUSE);

	/* Xg[uMEtF[YJE^Zbg */
	mos_phase = 0;
	mos_strobe = FALSE;

	return TRUE;
}

/*
 *	CeWFg}EX
 *	Xg[uM
 */
void FASTCALL mos_strobe_signal(BOOL strb)
{
	/* Xg[uM̏Ԃω`FbN */
	if (strb != mos_strobe) {
		/* Xg[uM̏Ԃۑ */
		mos_strobe = strb;

		if (mos_phase == 0) {
			/* tF[Y0̎Ɉړ荞 */
			mospos_request(&mos_x, &mos_y);

			/* ^CAEgCxg̓o^ */
			schedule_setevent(EVENT_MOUSE, 2000 , mos_timeout);
		}

		/* tF[YJE^XV */
		mos_phase = (BYTE)((mos_phase + 1) & 0x03);
	}
}

/*
 *	CeWFg}EX
 *	f[^ǂݍ
 */
BYTE FASTCALL mos_readdata(BYTE trigger)
{
	BYTE ret;

	/* tF[YJE^ɏ]ăf[^쐬 */
	switch (mos_phase) {
		case 1 :	/* wʃju */
					ret = (BYTE)((mos_x >> 4) & 0x0f);
					break;
		case 2 :	/* wʃju */
					ret = (BYTE)(mos_x & 0x0f);
					break;
		case 3 :	/* xʃju */
					ret = (BYTE)((mos_y >> 4) & 0x0f);
					break;
		case 0 :	/* xʃju */
					ret = (BYTE)(mos_y & 0x0f);
					break;
	}

	/* {^ԃf[^ */
	ret |= (BYTE)((mosbtn_request() & (trigger << 4)) & 0x30);

	return ret;
}

/*
 *	CeWFg}EX
 *	Z[u
 */
BOOL FASTCALL mos_save(int fileh)
{
	if (!file_byte_write(fileh, mos_x)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, mos_y)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, mos_phase)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, mos_strobe)) {
		return FALSE;
	}

	return TRUE;
}

/*
 *	CeWFg}EX
 *	[h
 */
BOOL FASTCALL mos_load(int fileh, int ver)
{
	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	/* 񃊃Zbg */
	mos_reset();

#if XM7_VER >= 3
	if ((ver >= 900) || ((ver >= 700) && (ver <= 799))) {
#elif XM7_VER >= 2
	if (ver >= 700) {
#elif defined(XM7DASH)
	if (ver >= 302) {	/* o[WV1.1L21̓o[Wɍ킹 */
#else
	if ((ver >= 302) && (ver <= 399)) {
#endif
		if (!file_byte_read(fileh, &mos_x)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &mos_y)) {
			return FALSE;
		}
		if (!file_byte_read(fileh, &mos_phase)) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &mos_strobe)) {
			return FALSE;
		}
	}

	/* Cxg */
	schedule_handle(EVENT_MOUSE, mos_timeout);

	return TRUE;
}

#endif	/* MOUSE */
