/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2014 ohD(yasushi@tanaka.net)
 *	Copyright (C) 2001-2014 Ryu Takegami
 *	Copyright (C) 2010-2014 Toma
 *
 *	[ OPN/WHG/THG (YM2203) / OPNA (YM2608) ]
 */

#ifndef _opn_h_
#define _opn_h_

/*
 *	萔`
 */
#define OPN_STD				0				/* WOPN */
#define OPN_WHG				1				/* WHG OPN */
#define OPN_THG				2				/* THG OPN */

#define OPN_INACTIVE		0x00			/* CANeBuR}h */
#define OPN_READDAT			0x01			/* [hf[^R}h */
#define OPN_WRITEDAT		0x02			/* Cgf[^R}h */
#define OPN_ADDRESS			0x03			/* b`AhXR}h */
#define OPN_READSTAT		0x04			/* [hXe[^XR}h */
#define OPN_JOYSTICK		0x09			/* WCXeBbNR}h */

#define	OPN_CLOCK			12288			/* OPNNbN(1.2288MHz) */

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL opn_init(void);
										/*  */
void FASTCALL opn_cleanup(void);
										/* N[Abv */
void FASTCALL opn_reset(void);
										/* Zbg */
BOOL FASTCALL opn_readb(WORD addr, BYTE *dat);
										/* OPN ǂݏo */
BOOL FASTCALL opn_writeb(WORD addr, BYTE dat);
										/* OPN  */
BOOL FASTCALL opn_save(int fileh);
										/* OPN Z[u */
#if defined(XM7DASH) && defined(OPNAMODE)
BOOL FASTCALL opn_load(int fileh, int ver, BOOL bflag);
										/* OPN [h */
#else
BOOL FASTCALL opn_load(int fileh, int ver);
										/* OPN [h */
#endif

BOOL FASTCALL whg_init(void);
										/* WHG  */
void FASTCALL whg_cleanup(void);
										/* WHG N[Abv */
void FASTCALL whg_reset(void);
										/* WHG Zbg */
BOOL FASTCALL whg_readb(WORD addr, BYTE *dat);
										/* WHG ǂݏo */
BOOL FASTCALL whg_writeb(WORD addr, BYTE dat);
										/* WHG  */
BOOL FASTCALL whg_save(int fileh);
										/* WHG Z[u */
#if defined(XM7DASH) && defined(OPNAMODE)
BOOL FASTCALL whg_load(int fileh, int ver, BOOL bflag);
										/* WHG [h */
#else
BOOL FASTCALL whg_load(int fileh, int ver);
										/* WHG [h */
#endif

BOOL FASTCALL thg_init(void);
										/* THG  */
void FASTCALL thg_cleanup(void);
										/* THG N[Abv */
void FASTCALL thg_reset(void);
										/* THG Zbg */
BOOL FASTCALL thg_readb(WORD addr, BYTE *dat);
										/* THG ǂݏo */
BOOL FASTCALL thg_writeb(WORD addr, BYTE dat);
										/* THG  */
BOOL FASTCALL thg_save(int fileh);
										/* THG Z[u */
#if defined(XM7DASH) && defined(OPNAMODE)
BOOL FASTCALL thg_load(int fileh, int ver, BOOL bflag);
										/* THG [h */
#else
BOOL FASTCALL thg_load(int fileh, int ver);
										/* THG [h */
#endif

/*
 *	v[N
 */
extern BOOL opn_enable;
										/* OPNLEtO(7 only) */
extern BOOL opn_use;
										/* OPNgptO */
extern BOOL whg_enable;
										/* WHGLEtO */
extern BOOL whg_use;
										/* WHGgptO */
extern BOOL thg_enable;
										/* THGLEtO */
extern BOOL thg_use;
										/* THGgptO */
#if defined(XM7DASH) && defined(OPNAMODE)
extern BOOL opna_enable[3];
										/* OPNALEtO */
extern BOOL opna_use[3];
										/* OPNAgptO */
#endif

#if defined(XM7DASH) && defined(OPNAMODE)
extern BYTE opn_reg[3][512];
										/* OPNWX^ */
extern BOOL opn_key[3][6];
										/* OPNL[ItO */
#else
extern BYTE opn_reg[3][256];
										/* OPNWX^ */
extern BOOL opn_key[3][4];
										/* OPNL[ItO */
#endif
extern BOOL opn_timera[3];
										/* ^C}[AtO */
extern BOOL opn_timerb[3];
										/* ^C}[BtO */
extern DWORD opn_timera_tick[3];
										/* ^C}[AԊu(us) */
extern DWORD opn_timerb_tick[3];
										/* ^C}[BԊu(us) */
extern BYTE opn_scale[3];
										/* vXP[ */
#ifdef __cplusplus
}
#endif

#endif	/* _opn_h_ */
