/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2014 ohD(yasushi@tanaka.net)
 *	Copyright (C) 2001-2014 Ryu Takegami
 *	Copyright (C) 2010-2014 Toma
 *
 *	[ Win32API ]
 */

#ifdef _WIN32

#ifndef _w32_h_
#define _w32_h_

#ifndef __STDLIB_H
#include <stdlib.h>
#endif

/*
 *	萔A^`
 */
#ifndef WM_THEMECHANGED
#define WM_THEMECHANGED		0x031A		/* WindowsXP e[}KpbZ[W */
#endif
#ifndef	WM_MOUSEWHEEL
#define	WM_MOUSEWHEEL		0x020a		/* VS2005p(_WIN32_WINDOWS̑) */
#endif

#ifdef XM7DASH
enum {
	DISK_IMAGE_DIR,
	TAPE_IMAGE_DIR,
	STATE_FILE_DIR,
	BMP_FILE_DIR,
	WAV_FILE_DIR,
#if XM7_VER == 1 && defined(BUBBLE)
	BUBBLE_IMAGE_DIR,
#endif	/* XM7_VER == 1 && defined(BUBBLE) */
	INITIAL_DIRS,						/* fBNg */
};

enum {
	FILE_MENU,
#if XM7_VER == 1 && defined(SFDC)
	SFD_MENU,
#endif	/* XM7_VER == 1 && defined(SFDC) */
	MFD_MENU,
#if XM7_VER == 1 && defined(BUBBLE)
	CASETTE_MENU,
#else	/* XM7_VER == 1 && defined(BUBBLE) */
	TAPE_MENU,
#endif	/* XM7_VER == 1 && defined(BUBBLE) */
	VIEW_MENU,
	DEBUG_MENU,
	TOOL_MENU,
	WINDOW_MENU,
	HELP_MENU,
};

enum {
	MRU_STATE = 0,
	MRU_TAPE,
	MRU_MFD0,
	MRU_MFD1,
	MRU_MFD2,
	MRU_MFD3,
#if XM7_VER == 1 && defined(SFDC)
	MRU_SFD0,
	MRU_SFD1,
	MRU_SFD2,
	MRU_SFD3,
#endif	/* XM7_VER == 1 && defined(SFDC) */
#if XM7_VER == 1 && defined(BUBBLE)
	MRU_BBL0,
	MRU_BBL1,
	MRU_BBL128_0,
	MRU_BBL128_1,
#endif	/* XM7_VER == 1 && defined(BUBBLE) */
	MRU_TYPES							/* MRU */
};
#define	MRU_FILES	9

enum {
	XDL_SND = 0,
	XDL_FLT,
	XDL_TYPES							/* ODLL */
};
#define	XDL_FILES	9
#endif

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
HFONT FASTCALL CreateTextFont(void);
										/* eLXgtHg쐬 */
void FASTCALL LockVM(void);
										/* VMbN */
void FASTCALL UnlockVM(void);
										/* VMAbN */
void FASTCALL OnSize(HWND hWnd, WORD cx, WORD cy);
										/* TCYύX */
void FASTCALL OnCommand(HWND hWnd, WORD wID);
										/* WM_COMMAND */
void FASTCALL OnMenuPopup(HWND hWnd, HMENU hMenu, UINT uPos);
										/* WM_INITMENUPOPUP */
void FASTCALL OnDropFiles(HANDLE hDrop);
										/* WM_DROPFILES */
void FASTCALL OnCmdLine(LPSTR lpCmdLine);
										/* R}hC */
void FASTCALL OnAbout(HWND hWnd);
										/* o[W */
#ifdef XM7DASH
BOOL FASTCALL FileSelectSub(BOOL bOpen, UINT uFilterID, char *path, char *defext, BYTE IniDirNo);
#endif
void FASTCALL EnableMenuSub(HMENU hMenu, UINT uID, BOOL bEnable);
										/* j[Enable */
#ifdef XM7DASH
void FASTCALL EnableMenuPos(HMENU hMenu, UINT uPos, BOOL bEnable);
										/* j[Enable (ʒuw) */
#endif
void FASTCALL CheckMenuSub(HMENU hMenu, UINT uID, BOOL bCheck);
										/* j[Check */
void FASTCALL InitIMEDLL(void);
										/* IMEL/API DLL */
void FASTCALL CleanIMEDLL(void);
										/* IMEL/API DLLN[Abv */
BOOL FASTCALL EnableIME(HWND hWnd, BOOL flag);
										/* IMEL/؂芷 */
#ifdef MOUSE
void FASTCALL MouseModeChange(BOOL flag);
										/* }EXLv`؂ւ */
#endif
#ifdef XM7DASH
void FASTCALL OnContextualMenu(HWND hWnd, WORD wID, int x, int y);
										/* ReLXgj[ */
#endif

/*
 *	v[N
 */
#ifdef XM7DASH
extern char InitialDir[INITIAL_DIRS][_MAX_DRIVE + _MAX_PATH];
										/* fBNg */
extern char StatePath[_MAX_PATH];
										/* Xe[gpX */
extern char QuickPath[_MAX_PATH];
										/* NCbNXe[gpX */
extern BOOL bResumeState;
										/* Xe[gW[ */
extern BOOL bBackupState;
										/* Xe[gobNAbv */
#ifdef RSTATE
extern BOOL bStateSave;
										/* Xe[gۑ@\ */
#endif
#else
#if XM7_VER == 1 && defined(BUBBLE)
extern char InitialDir[6][_MAX_DRIVE + _MAX_PATH];
										/* fBNg */
#else
extern char InitialDir[5][_MAX_DRIVE + _MAX_PATH];
										/* fBNg */
#endif
#endif
extern HINSTANCE hAppInstance;
										/* AvP[V CX^X */
extern HINSTANCE hResInstance;
										/* \[X CX^X */
extern HWND hMainWnd;
										/* CEChE */
extern HWND hDrawWnd;
										/* `EChE */
extern int nErrorCode;
										/* G[R[h */
extern BOOL bMenuLoop;
										/* j[[v */
extern BOOL bMenuExit;
										/* j[otO */
extern BOOL bCloseReq;
										/* IvtO */
extern LONG lCharWidth;
										/* LN^ */
extern LONG lCharHeight;
										/* LN^c */
extern BOOL bSync;
										/* sɓ */
extern BOOL bSyncDisasm[3];
										/* tAZuPCɓ */
extern BOOL bMinimize;
										/* ŏtO */
extern BOOL bActivate;
										/* ANeBx[gtO */
#ifndef XM7DASH
extern BOOL bHideStatus;
										/* Xe[^Xo[B */
#endif
extern HICON hAppIcon;
										/* ACRnh */
extern int nAppIcon;
										/* ACRԍ(1`3) */
extern BOOL bNTflag;
										/* OS^Cv1(NT) */
extern BOOL bXPflag;
										/* OS^Cv2(XP) */
extern BOOL bVistaflag;
										/* OS^Cv3(Vista/7) */
extern BOOL bWin8flag;
										/* OS^Cv4(Windows 8) */
extern BOOL bMMXflag;
										/* MMXΉtO */
extern BOOL bCMOVflag;
										/* CMOVΉtO */
extern BOOL bHighPriority;
										/* nCvCIeBtO */
extern POINT WinPos;
										/* EBhEʒu */
#ifdef ROMEO
extern BOOL bRomeo;
										/* ROMEOFtO */
#endif
#if ((XM7_VER <= 2) && defined(FMTV151))
extern BOOL bFMTV151;
										/* `lR[G~[V */
#endif
extern HFONT hFont;
										/* TuEBhEptHgnh */
#if XM7_VER >= 3
extern BOOL bGravestone;
										/* !? */
#endif
#ifdef XM7DASH
extern HINSTANCE hInstRes;
										/* DLL̃nh */
extern BOOL bUseLanguageMode;
										/* ꃂ[h؂ւ */
extern BOOL bLanguageMode;
										/* ꃂ[h */
extern BOOL bExistResourceDll;
										/* \[XDLL݃tO */
extern BOOL bFilterRedrawScreen;
										/* j[ۂɉʂĕ` */
extern HMENU hMediaMenu;
										/* fBAj[nh */
extern HMENU hHistoryMenu;
										/* qXgj[nh */
extern HMENU hAspectMenu;
										/* AXyNgݒ胁j[nh */
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _w32_h_ */
#endif	/* _WIN32 */
