/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2014 ohD(yasushi@tanaka.net)
 *	Copyright (C) 2001-2014 Ryu Takegami
 *	Copyright (C) 2010-2014 Toma
 *
 *	[ Win32API Rg[o[ ]
 *
 *	RHG
 *	  2003.05.25		ResizeStatus֐ǉ
 *	  2004.05.03		WinXPΉDLLǂݍ݃`FbN̈S
 *	  2004.08.31		2D/2DD/VFD/^CgȂD77̕\ύX
 *	  2010.08.05		CWP[^XM6ɍ킹dlɕύX
 *	  2010.10.03		2{g\[hɑΉ
 *	  2012.06.03		Xe[^Xo[̕\Ԃ̏lSW_HIDEɕύX
 *	  2012.08.01		CAP//INSL[\bZ[W\[Xǂނ悤
 *						ύX
 *	  2012.10.10		LvṼobt@TCY256oCgɑ
 */

#ifdef _WIN32

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <winbase.h>
#include <commctrl.h>
#include <stdlib.h>
#include <assert.h>
#include "xm7.h"
#include "keyboard.h"
#include "tapelp.h"
#include "display.h"
#include "ttlpalet.h"
#include "apalet.h"
#include "subctrl.h"
#include "fdc.h"
#include "bubble.h"
#ifdef XM7DASH
#include "opn.h"
#include "tools.h"
#endif
#include "w32.h"
#include "w32_bar.h"
#include "w32_sch.h"
#include "w32_draw.h"
#include "w32_res.h"

/*
 *	O[o [N
 */
HWND hStatusBar;						/* Xe[^Xo[ */
BOOL bStatusMessage;					/* Xe[^XbZ[W\ */
#ifdef XM7DASH
BOOL bStatusBar;						/* Xe[^Xo[\ */
BOOL bMountFileName;					/* ^Cgo[Ƀ}Egt@C */
 #if XM7_VER == 1 && defined(SFDC)
int uPaneX[9];							/* Drag&DroppyCʒu */
 #else	/* XM7_VER == 1 && defined(SFDC) */
int uPaneX[5];							/* Drag&DroppyCʒu */
 #endif	/* XM7_VER == 1 && defined(SFDC) */
#else
int uPaneX[3];							/* Drag&DroppyCʒu */
#endif

/*
 *	X^eBbN [N
 */
static char szIdleMessage[128];			/* AChbZ[W */
static char szStatusMessage[128];		/* Xe[^XbZ[W */
static char szRunMessage[128];			/* RUNbZ[W */
static char szStopMessage[128];			/* STOPbZ[W */
static char szCaption[256];				/* LvV */
static char szCAPMessage[16];			/* CAPL[bZ[W */
static char szKANAMessage[16];			/* ȃL[bZ[W */
static char szINSMessage[16];			/* INSL[bZ[W */
static int nCAP;						/* CAPL[ */
static int nKANA;						/* ȃL[ */
static int nINS;						/* INSL[ */
#ifdef XM7DASH
 #if XM7_VER == 1 && defined(SFDC)
static int nDrive[2][4];				/* tbs[hCu */
static char szDrive[2][4][128];			/* tbs[hCu */
 #else	/* XM7_VER == 1 && defined(SFDC) */
static int nDrive[4];					/* tbs[hCu */
static char szDrive[4][128];			/* tbs[hCu */
 #endif	/* XM7_VER == 1 && defined(SFDC) */
static UINT nDcw;						/* hCu\\ */
#else
static int nDrive[2];					/* tbs[hCu */
static char szDrive[2][128];			/* tbs[hCu */
#endif
static int nTape;						/* e[v */
static UINT uResID;						/* \[XIDۑ */
static int nStatusBorder;				/* Xe[^Xo[̃{[_[` */
static BOOL (*IsAppThemed)(void);		/* e[}KpmF֐(uxtheme.dll) */
static HINSTANCE hInstTheme;			/* uxtheme.dll̃nh */
static BOOL bThemed;					/* e[}Kp */

/*-[ Xe[^Xo[ ]-------------------------------------------------------*/

/*
 *	ANZX}N
 */
#define Status_SetParts(hwnd, nParts, aWidths) \
	SendMessage((hwnd), SB_SETPARTS, (WPARAM) nParts, (LPARAM) (LPINT) aWidths)

#define Status_SetText(hwnd, iPart, uType, szText) \
	SendMessage((hwnd), SB_SETTEXT, (WPARAM) (iPart | uType), (LPARAM) (LPSTR) szText)

/*
 *	yC`
 */
#ifdef XM7DASH
enum {
		PANE_DEFAULT = 0,
#if XM7_VER == 1 && defined(SFDC)
		PANE_SDRIVE3,
		PANE_SDRIVE2,
		PANE_SDRIVE1,
		PANE_SDRIVE0,
#endif	/* XM7_VER == 1 && defined(SFDC) */
		PANE_DRIVE3,
		PANE_DRIVE2,
		PANE_DRIVE1,
		PANE_DRIVE0,
		PANE_TAPE,
		PANE_CAP,
		PANE_KANA,
		PANE_INS,
		PANE_MAX
};
#else
#define PANE_DEFAULT	0
#define PANE_DRIVE1		1
#define PANE_DRIVE0		2
#define PANE_TAPE		3
#define PANE_CAP		4
#define PANE_KANA		5
#define PANE_INS		6
#endif

#ifdef XM7DASH
/*
 *	Xe[^Xo[p̃bZ[W[h
 */
void FASTCALL LoadMessageStatusBar(void)
{
	/* bZ[W[h */
	if (LoadString(hResInstance, IDS_IDLEMESSAGE,
					szIdleMessage, sizeof(szIdleMessage)) == 0) {
		szIdleMessage[0] = '\0';
	}
	if (LoadString(hResInstance, IDS_RUNCAPTION,
					szRunMessage, sizeof(szRunMessage)) == 0) {
		szRunMessage[0] = '\0';
	}
	if (LoadString(hResInstance, IDS_STOPCAPTION,
					szStopMessage, sizeof(szStopMessage)) == 0) {
		szStopMessage[0] = '\0';
	}
	if (LoadString(hResInstance, IDS_BAR_CAP,
					szCAPMessage, sizeof(szCAPMessage)) == 0) {
		strncpy(szCAPMessage, "CAP", 16);
	}
	if (LoadString(hResInstance, IDS_BAR_KANA,
					szKANAMessage, sizeof(szKANAMessage)) == 0) {
#if XM7_VER == 1
		strncpy(szKANAMessage, "Ji", 16);
#else
		strncpy(szKANAMessage, "", 16);
#endif
	}
	if (LoadString(hResInstance, IDS_BAR_INS,
					szINSMessage, sizeof(szINSMessage)) == 0) {
		strncpy(szINSMessage, "INS", 16);
	}
}
#endif

/*
 *	Xe[^Xo[쐬
 */
HWND FASTCALL CreateStatus(HWND hParent)
{
	HWND hWnd;

	ASSERT(hParent);

	/* e[}KptO */
	bThemed = FALSE;

	/* bZ[W[h */
#ifdef XM7DASH
	LoadMessageStatusBar();
#else
	if (LoadString(hResInstance, IDS_IDLEMESSAGE,
					szIdleMessage, sizeof(szIdleMessage)) == 0) {
		szIdleMessage[0] = '\0';
	}
	if (LoadString(hResInstance, IDS_RUNCAPTION,
					szRunMessage, sizeof(szRunMessage)) == 0) {
		szRunMessage[0] = '\0';
	}
	if (LoadString(hResInstance, IDS_STOPCAPTION,
					szStopMessage, sizeof(szStopMessage)) == 0) {
		szStopMessage[0] = '\0';
	}
	if (LoadString(hResInstance, IDS_BAR_CAP,
					szCAPMessage, sizeof(szCAPMessage)) == 0) {
		strncpy(szCAPMessage, "CAP", 16);
	}
	if (LoadString(hResInstance, IDS_BAR_KANA,
					szKANAMessage, sizeof(szKANAMessage)) == 0) {
#if XM7_VER == 1
		strncpy(szKANAMessage, "Ji", 16);
#else
		strncpy(szKANAMessage, "", 16);
#endif
	}
	if (LoadString(hResInstance, IDS_BAR_INS,
					szINSMessage, sizeof(szINSMessage)) == 0) {
		strncpy(szINSMessage, "INS", 16);
	}
#endif

	/* Xe[^XbZ[W */
	szStatusMessage[0] = '\0';
	bStatusMessage = FALSE;
	uResID = 0;
#ifdef XM7DASH
	nDcw = 16;
#endif

	/* Xe[^Xo[쐬 */
	hWnd = CreateStatusWindow(WS_CHILD | CCS_BOTTOM | CCS_NORESIZE,
								"", hParent, ID_STATUS_BAR);
	ChangeStatusBorder(hWnd);
	ResizeStatus(hParent, hWnd);
#ifdef XM7DASH
	ShowWindow(hWnd, SW_SHOW);
#else
	ShowWindow(hWnd, SW_HIDE);
#endif

#ifdef XM7DASH
	bMountFileName = TRUE;
#endif

	return hWnd;
}

/*
 *	LvV`
 */
static void FASTCALL DrawMainCaption(void)
{
	char string[256];
	char tmp[256];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];

	/* 󋵂ɉāARs[ */
	if (run_flag) {
		strncpy(string, szRunMessage, 256);
	}
	else {
		strncpy(string, szStopMessage, 256);
	}
#ifdef XM7DASH
	strncat(string, " ", sizeof(string)-strlen(string)-1);
#else
	strncat(string, " ", 256 - sizeof(string) - 1);
#endif

	/* CPUx䗦 */
	if (bAutoSpeedAdjust) {
		_snprintf(tmp, 256, "(%3d%%) ", speed_ratio / 100);
#ifdef XM7DASH
		strncat(string, tmp, sizeof(string)-strlen(string)-1);
#else
		strncat(string, tmp, 256 - strlen(string) - 1);
#endif
	}

#ifdef XM7DASH
	/* Xe[g */
	if ((get_file_size(StatePath) > 0) &&
		(strncmp(StatePath, QuickPath, _MAX_PATH))) {
		/* t@Cl[{gq̂ݎo */
		_splitpath(StatePath, NULL, NULL, fname, ext);
		_snprintf(tmp, sizeof(tmp), "- [%s%s] ", fname, ext);
		strncat(string, tmp, sizeof(string)-strlen(string)-1);
	}

	/* ݃hCu(#2/#3)}Eg̓LvV\Ȃ */
#if 0
#if XM7_VER == 1 && defined(SFDC)
	if (((fdc_ready[FDC_M][2] != FDC_TYPE_NOTREADY ||
		  fdc_ready[FDC_M][3] != FDC_TYPE_NOTREADY)) ||
		((fdc_ready[FDC_S][2] != FDC_TYPE_NOTREADY ||
		  fdc_ready[FDC_S][3] != FDC_TYPE_NOTREADY) && sfdc_enable)) {
#else	/* XM7_VER == 1 && defined(SFDC) */
	if (fdc_ready[2] != FDC_TYPE_NOTREADY ||
		fdc_ready[3] != FDC_TYPE_NOTREADY) {
#endif	/* XM7_VER == 1 && defined(SFDC) */
#else
	if (!bMountFileName) {
#endif
		/* r */
		string[sizeof(string) - 1] = '\0';
		if (strncmp(szCaption, string, strlen(string) + 1) != 0) {
			memset(szCaption, 0, sizeof(szCaption));
			strncpy(szCaption, string, sizeof(szCaption) - 1);
			SetWindowText(hMainWnd, szCaption);
		}
		return;
	}
#endif

#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
	if (sfdc_enable && (fm_subtype != FMSUB_FM7)) {
		/* 1MBtbs[fBXNhCu 0 */
		if (fdc_ready[FDC_S][0] != FDC_TYPE_NOTREADY) {
			/* t@Cl[{gq̂ݎo */
			_splitpath(fdc_fname[FDC_S][0], drive, dir, fname, ext);
			_snprintf(tmp, sizeof(tmp), "- %s%s ", fname, ext);
			strncat(string, tmp, sizeof(string)-strlen(string)-1);
		}

		/* 1MBtbs[fBXNhCu 1 */
		if (fdc_ready[FDC_S][1] != FDC_TYPE_NOTREADY) {
			if ((strcmp(fdc_fname[FDC_S][0], fdc_fname[FDC_S][1]) != 0) ||
				(fdc_ready[FDC_S][0] == FDC_TYPE_NOTREADY)) {
				/* t@Cl[{gq̂ݎo */
				_splitpath(fdc_fname[FDC_S][1], drive, dir, fname, ext);
				if (fdc_ready[FDC_S][0] == FDC_TYPE_NOTREADY) {
					_snprintf(tmp, sizeof(tmp), "- (%s%s) ", fname, ext);
				}
				else {
					_snprintf(tmp, sizeof(tmp), "(%s%s) ", fname, ext);
				}
				strncat(string, tmp, sizeof(string)-strlen(string)-1);
			}
		}
	}

	/* tbs[fBXNhCu 0 */
	if (fdc_ready[FDC_M][0] != FDC_TYPE_NOTREADY) {
		/* t@Cl[{gq̂ݎo */
		_splitpath(fdc_fname[FDC_M][0], drive, dir, fname, ext);
		_snprintf(tmp, sizeof(tmp), "- %s%s ", fname, ext);
		strncat(string, tmp, sizeof(string)-strlen(string)-1);
	}

	/* tbs[fBXNhCu 1 */
	if (fdc_ready[FDC_M][1] != FDC_TYPE_NOTREADY) {
		if ((strcmp(fdc_fname[FDC_M][0], fdc_fname[FDC_M][1]) != 0) ||
			(fdc_ready[FDC_M][0] == FDC_TYPE_NOTREADY)) {
			/* t@Cl[{gq̂ݎo */
			_splitpath(fdc_fname[FDC_M][1], drive, dir, fname, ext);
			if (fdc_ready[FDC_M][0] == FDC_TYPE_NOTREADY) {
				_snprintf(tmp, sizeof(tmp), "- (%s%s) ", fname, ext);
			}
			else {
				_snprintf(tmp, sizeof(tmp), "(%s%s) ", fname, ext);
			}
			strncat(string, tmp, sizeof(string)-strlen(string)-1);
		}
	}
#else	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
	/* tbs[fBXNhCu 0 */
	if (fdc_ready[0] != FDC_TYPE_NOTREADY) {
		/* t@Cl[{gq̂ݎo */
		_splitpath(fdc_fname[0], drive, dir, fname, ext);
		_snprintf(tmp, 256, "- %s%s ", fname, ext);
#ifdef XM7DASH
		strncat(string, tmp, sizeof(string)-strlen(string)-1);
#else
		strncat(string, tmp, 256 - strlen(string) - 1);
#endif
	}

	/* tbs[fBXNhCu 1 */
	if (fdc_ready[1] != FDC_TYPE_NOTREADY) {
		if ((strcmp(fdc_fname[0], fdc_fname[1]) != 0) ||
			(fdc_ready[0] == FDC_TYPE_NOTREADY)) {
			/* t@Cl[{gq̂ݎo */
			_splitpath(fdc_fname[1], drive, dir, fname, ext);
			if (fdc_ready[0] == FDC_TYPE_NOTREADY) {
				_snprintf(tmp, 256, "- (%s%s) ", fname, ext);
			}
			else {
				_snprintf(tmp, 256, "(%s%s) ", fname, ext);
			}
#ifdef XM7DASH
			strncat(string, tmp, sizeof(string)-strlen(string)-1);
#else
			strncat(string, tmp, 256 - strlen(string) - 1);
#endif
		}
	}
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

	/* e[v */
	if (tape_fileh != -1) {
		/* t@Cl[{gq̂ݎo */
		_splitpath(tape_fname, drive, dir, fname, ext);
		_snprintf(tmp, 256, "- %s%s ", fname, ext);
#ifdef XM7DASH
		strncat(string, tmp, sizeof(string)-strlen(string)-1);
#else
		strncat(string, tmp, 256 - strlen(string) - 1);
#endif
	}

#if XM7_VER == 1 && defined(BUBBLE)
	/* ou */
#ifdef XM7DASH
	if (bmc_enable[BMC_32] &&
		((fm_subtype == FMSUB_FM8) || !opn_enable)) {
		/* 32KBouz_ 0 */
		if (bmc_ready[0][0] != BMC_TYPE_NOTREADY) {
			/* t@Cl[{gq̂ݎo */
			_splitpath(bmc_fname[0][0], drive, dir, fname, ext);
			_snprintf(tmp, sizeof(tmp), "- %s%s ", fname, ext);
			strncat(string, tmp, sizeof(string)-strlen(string)-1);
		}

		/* 32KBouz_ 1 */
		if (bmc_ready[0][1] != BMC_TYPE_NOTREADY) {
			if ((strcmp(bmc_fname[0][0], bmc_fname[0][1]) != 0) ||
				(bmc_ready[0][0] == BMC_TYPE_NOTREADY)) {
				/* t@Cl[{gq̂ݎo */
				_splitpath(bmc_fname[0][1], drive, dir, fname, ext);
				if (bmc_ready[0][0] == BMC_TYPE_NOTREADY) {
					_snprintf(tmp, sizeof(tmp), "- (%s%s) ", fname, ext);
				}
				else {
					_snprintf(tmp, sizeof(tmp), "(%s%s) ", fname, ext);
				}
				strncat(string, tmp, sizeof(string)-strlen(string)-1);
			}
		}
	}

	if (bmc_enable[BMC_128]) {
		/* 128KBouz_ 0 */
		if (bmc_ready[1][0] != BMC_TYPE_NOTREADY) {
			/* t@Cl[{gq̂ݎo */
			_splitpath(bmc_fname[1][0], drive, dir, fname, ext);
			_snprintf(tmp, sizeof(tmp), "- %s%s ", fname, ext);
			strncat(string, tmp, sizeof(string)-strlen(string)-1);
		}

		/* 128KBouz_ 1 */
		if (bmc_ready[1][1] != BMC_TYPE_NOTREADY) {
			if ((strcmp(bmc_fname[1][0], bmc_fname[1][1]) != 0) ||
				(bmc_ready[1][0] == BMC_TYPE_NOTREADY)) {
				/* t@Cl[{gq̂ݎo */
				_splitpath(bmc_fname[1][1], drive, dir, fname, ext);
				if (bmc_ready[1][0] == BMC_TYPE_NOTREADY) {
					_snprintf(tmp, sizeof(tmp), "- (%s%s) ", fname, ext);
				}
				else {
					_snprintf(tmp, sizeof(tmp), "(%s%s) ", fname, ext);
				}
				strncat(string, tmp, sizeof(string)-strlen(string)-1);
			}
		}
	}
#else
	if (fm_subtype == FMSUB_FM8) {
		if (bmc_ready[0] != BMC_TYPE_NOTREADY) {
			/* t@Cl[{gq̂ݎo */
			_splitpath(bmc_fname[0], drive, dir, fname, ext);
			_snprintf(tmp, 256, "- %s%s ", fname, ext);
			strncat(string, tmp, 256 - strlen(string) - 1);
		}

		if (bmc_ready[1] != BMC_TYPE_NOTREADY) {
			/* t@Cl[{gq̂ݎo */
			_splitpath(bmc_fname[1], drive, dir, fname, ext);
			if (bmc_ready[0] == BMC_TYPE_NOTREADY) {
				_snprintf(tmp, 256, "- (%s%s) ", fname, ext);
			}
			else {
				_snprintf(tmp, 256, "(%s%s) ", fname, ext);
			}
			strncat(string, tmp, 256 - strlen(string) - 1);
		}
	}
#endif
#endif

	/* r` */
	string[255] = '\0';
	if (memcmp(szCaption, string, strlen(string) + 1) != 0) {
		strncpy(szCaption, string, 256);
		SetWindowText(hMainWnd, szCaption);
	}
}

/*
 *	ACR`FbNAύX
 */
static void FASTCALL CheckIcon(void)
{
	HICON hIcon;

#if XM7_VER == 1
	/* v`FbN */
	if (fm_subtype == nAppIcon) {
		return;
	}

	/* VACR[hAZbg */
	switch (fm_subtype) {
		case FMSUB_FM8:
			hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_FM8ICON));
			break;
		case FMSUB_FM7:
			hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_FM7ICON));
			break;
		case FMSUB_FM77:
			hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_FM77ICON));
			break;
		default:
			hIcon = NULL;
			ASSERT(FALSE);
			break;
	}
	SendMessage(hMainWnd, WM_SETICON, ICON_BIG, (LPARAM)hIcon);
	SendMessage(hMainWnd, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);

	/* ACR폜 */
	DestroyIcon(hAppIcon);

	/* L */
	hAppIcon = hIcon;
	nAppIcon = fm_subtype;
#else
	/* v`FbN */
	if (fm7_ver == nAppIcon) {
		return;
	}

	/* VACR[hAZbg */
	switch (fm7_ver) {
		case 1:
			hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_FM7ICON));
			break;
		case 2:
			hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_77AVICON));
			break;
#if XM7_VER >= 3
		case 3:
#ifdef XM7DASH
			if (bDownGradeMode) {
				hIcon = LoadIcon(hAppInstance,
					 MAKEINTRESOURCE(IDI_40EXICON2));
			}
			else if (bGravestone) {
				hIcon = LoadIcon(hAppInstance,
					 MAKEINTRESOURCE(IDI_40SXICON));
			}
			else {
				hIcon = LoadIcon(hAppInstance,
					 MAKEINTRESOURCE(IDI_40EXICON));
			}
#else
			hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_40EXICON2));
#endif
			break;
#endif
		default:
			hIcon = NULL;
			ASSERT(FALSE);
			break;
	}
	SendMessage(hMainWnd, WM_SETICON, ICON_BIG, (LPARAM)hIcon);
	SendMessage(hMainWnd, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);

	/* ACR폜 */
	DestroyIcon(hAppIcon);

	/* L */
	hAppIcon = hIcon;
	nAppIcon = fm7_ver;
#endif
}

/*
 *	CAPL[`
 */
static void FASTCALL DrawCAP(void)
{
	int num;

	/* ԍ */
	if (caps_flag) {
		num = 1;
	}
	else {
		num = 0;
	}

	/* Ȃ牽Ȃ */
	if (nCAP == num) {
		return;
	}

	/* `A[NXV */
	nCAP = num;
	Status_SetText(hStatusBar, PANE_CAP, SBT_OWNERDRAW, PANE_CAP);
}

/*
 *	ȃL[`
 */
static void FASTCALL DrawKANA(void)
{
	int num;

	/* ԍ */
	if (kana_flag) {
		num = 1;
	}
	else {
		num = 0;
	}

	/* Ȃ牽Ȃ */
	if (nKANA == num) {
		return;
	}

	/* `A[NXV */
	nKANA = num;
	Status_SetText(hStatusBar, PANE_KANA, SBT_OWNERDRAW, PANE_KANA);
}

/*
 *	INSL[`
 */
static void FASTCALL DrawINS(void)
{
	int num;

	/* ԍ */
	if (ins_flag) {
		num = 1;
	}
	else {
		num = 0;
	}

	/* Ȃ牽Ȃ */
	if (nINS == num) {
		return;
	}

	/* `A[NXV */
	nINS = num;
	Status_SetText(hStatusBar, PANE_INS, SBT_OWNERDRAW, PANE_INS);
}

/*
 *	hCu`
 */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
static void FASTCALL DrawDrive(int type, int drive, UINT nID)
#else	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
static void FASTCALL DrawDrive(int drive, UINT nID)
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
{
	char string[_MAX_FNAME + _MAX_EXT];
	char buffer[_MAX_FNAME + _MAX_EXT + 4];
	char drive_[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	int num;
	char *name;
#ifdef XM7DASH
	BOOL exdrv;
#endif

#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
	ASSERT((type == FDC_M) || (type == FDC_S));
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
#ifdef XM7DASH
	ASSERT((drive >= 0) && (drive <= 3));
#else
	ASSERT((drive >= 0) && (drive <= 1));
#endif

#ifdef XM7DASH
#if XM7_VER == 1 && defined(SFDC)
	/* L`FbN */
	if (type == FDC_S && (!sfdc_enable || (fm_subtype == FMSUB_FM7))) {
		return;
	}
	exdrv = ((	fdc_ready[FDC_M][2] != FDC_TYPE_NOTREADY ||
				fdc_ready[FDC_M][3] != FDC_TYPE_NOTREADY) ||
			 ((	fdc_ready[FDC_S][2] != FDC_TYPE_NOTREADY ||
				fdc_ready[FDC_S][3] != FDC_TYPE_NOTREADY) &&
				(sfdc_enable && (fm_subtype != FMSUB_FM7))));
#else	/* XM7_VER == 1 && defined(SFDC) */
	exdrv = (	fdc_ready[2] != FDC_TYPE_NOTREADY ||
				fdc_ready[3] != FDC_TYPE_NOTREADY);
#endif	/* XM7_VER == 1 && defined(SFDC) */
	/* ݃hCu(#2/#3)}Eg\ */
	if (drive >= 2 && !exdrv) {
		return;
	}
#endif

	/* ԍZbg */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
	if (fdc_ready[type][drive] == FDC_TYPE_NOTREADY) {
		num = FDC_ACCESS_NOTREADY;
	}
	else if (fdc_teject[type][drive]) {
		num = FDC_ACCESS_TEJECT;
	}
	else {
		num = fdc_access[type][drive];
		if (num == FDC_ACCESS_SEEK) {
			num = FDC_ACCESS_READY;
		}
	}
#else	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
 #ifdef XM7DASH
	if (fdc_ready[drive] == FDC_TYPE_NOTREADY) {
		num = FDC_ACCESS_NOTREADY;
	}
	else if (fdc_teject[drive]) {
		num = FDC_ACCESS_TEJECT;
	}
 #else
	if ((fdc_ready[drive] == FDC_TYPE_NOTREADY) || (fdc_teject[drive])) {
		num = FDC_ACCESS_NOTREADY;
	}
 #endif
	else {
		num = fdc_access[drive];
		if (num == FDC_ACCESS_SEEK) {
			num = FDC_ACCESS_READY;
		}
	}
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

	/* O擾 */
	name = "";
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
	if ((fdc_ready[type][drive] == FDC_TYPE_D77) &&
		(strlen(fdc_name[type][drive][ fdc_media[type][drive] ]) > 0)) {
		name = fdc_name[type][drive][ fdc_media[type][drive] ];
	}
	else if (fdc_ready[type][drive] != FDC_TYPE_NOTREADY) {
		/* t@Cl[{gq̂ݎo */
		_splitpath(fdc_fname[type][drive], NULL, NULL, fname, ext);
		strncpy(string, fname, sizeof(string));
		strncat(string, ext, sizeof(string) - strlen(string) - 1);
		if ((fdc_ready[type][drive] == FDC_TYPE_D77) && (fdc_medias[type][drive] > 1)) {
			_snprintf(buffer, sizeof(buffer), "%s #%02d", string, fdc_media[type][drive] + 1);
			name = buffer;
		}
		else {
			name = string;
		}
	}
#else
	if ((fdc_ready[drive] == FDC_TYPE_D77) &&
		(strlen(fdc_name[drive][ fdc_media[drive] ]) > 0)) {
		name = fdc_name[drive][ fdc_media[drive] ];
	}
	else if (fdc_ready[drive] != FDC_TYPE_NOTREADY) {
		/* t@Cl[{gq̂ݎo */
		_splitpath(fdc_fname[drive], drive_, dir, fname, ext);
		strncpy(string, fname, sizeof(string));
#ifdef XM7DASH
		strncat(string, ext, sizeof(string) - strlen(string) - 1);
#else
		strncat(string, ext, sizeof(string) - strlen(ext) - 1);
#endif
		if ((fdc_ready[drive] == FDC_TYPE_D77) && (fdc_medias[drive] > 1)) {
			_snprintf(buffer, sizeof(buffer), "%s #%02d", string,
					  fdc_media[drive] + 1);
			name = buffer;
		}
		else {
			name = string;
		}
	}
#endif

#ifdef XM7DASH
	/* fBAI[o[͊gqŕ\ */
	if (strlen(name) > nDcw) {
		if (nDcw < 16) {
			/* gq̂ݎo */
#if XM7_VER == 1 && defined(SFDC)
			_splitpath(fdc_fname[type][drive], NULL, NULL, NULL, ext);
#else
			_splitpath(fdc_fname[drive], NULL, NULL, NULL, ext);
#endif
			strncpy(string, ext, sizeof(string));
			for (name = string; *name != '\0'; name ++) {
				*name = toupper(*name);
			}
			if (strlen(ext) > 1) {
				name = string + 1;
			}
			else {
				name = string;
			}
			if (nDcw >= 7) {
				/* fBAԍݒ */
#if XM7_VER == 1 && defined(SFDC)
				if ((fdc_ready[type][drive] == FDC_TYPE_D77) && (fdc_medias[type][drive] > 1)) {
					_snprintf(buffer, sizeof(buffer), "%s #%02d", name, fdc_media[type][drive] + 1);
					name = buffer;
				}
#else
				if ((fdc_ready[drive] == FDC_TYPE_D77) && (fdc_medias[drive] > 1)) {
					_snprintf(buffer, sizeof(buffer), "%s #%02d", name, fdc_media[drive] + 1);
					name = buffer;
				}
#endif
				else {
					_snprintf(buffer, sizeof(buffer), "%s File", name);
					name = buffer;
				}
			}
		}
	}
#endif

	/* ԍr */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
	if (nDrive[type][drive] == num) {
		if (strcmp(szDrive[type][drive], name) == 0) {
			return;
		}
	}
#else	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
	if (nDrive[drive] == num) {
		if (strcmp(szDrive[drive], name) == 0) {
			return;
		}
	}
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */

	/* ` */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
	nDrive[type][drive] = num;
	strncpy(szDrive[type][drive], name, sizeof(szDrive[type][drive]));
#else	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
	nDrive[drive] = num;
	strncpy(szDrive[drive], name, 128);
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
	Status_SetText(hStatusBar, nID, SBT_OWNERDRAW, nID);
}

/*
 *	e[v`
 */
static void FASTCALL DrawTape(void)
{
	int num;

	/* io[vZ */
	num = 30000;
	if (tape_fileh != -1) {
		num = (int)((tape_offset >> 8) % 10000);
		if (tape_motor) {
			if (tape_rec) {
				num += 20000;
			}
			else {
				num += 10000;
			}
		}
	}

	/* ԍr */
	if (nTape == num) {
		return;
	}

	/* ` */
	nTape = num;
	Status_SetText(hStatusBar, PANE_TAPE, SBT_OWNERDRAW, PANE_TAPE);
}

/*
 *	`
 */
void FASTCALL DrawStatus(void)
{
	/* EChE`FbN */
	if (!hMainWnd) {
		return;
	}

	DrawMainCaption();
	CheckIcon();

	/* SʁAXe[^Xo[`FbN */
	if (bFullScreen || !hStatusBar) {
		return;
	}

	DrawCAP();
	DrawKANA();
	DrawINS();
#ifdef XM7DASH
 #if XM7_VER == 1 && defined(SFDC)
	DrawDrive(FDC_M, 0, PANE_DRIVE0);
	DrawDrive(FDC_M, 1, PANE_DRIVE1);
	DrawDrive(FDC_M, 2, PANE_DRIVE2);
	DrawDrive(FDC_M, 3, PANE_DRIVE3);
	DrawDrive(FDC_S, 0, PANE_SDRIVE0);
	DrawDrive(FDC_S, 1, PANE_SDRIVE1);
	DrawDrive(FDC_S, 2, PANE_SDRIVE2);
	DrawDrive(FDC_S, 3, PANE_SDRIVE3);
 #else	/* XM7_VER == 1 && defined(SFDC) */
	DrawDrive(0, PANE_DRIVE0);
	DrawDrive(1, PANE_DRIVE1);
	DrawDrive(2, PANE_DRIVE2);
	DrawDrive(3, PANE_DRIVE3);
 #endif	/* XM7_VER == 1 && defined(SFDC) */
#else
	DrawDrive(0, PANE_DRIVE0);
	DrawDrive(1, PANE_DRIVE1);
#endif
	DrawTape();
}

/*
 *	ĕ`
 */
void FASTCALL PaintStatus(void)
{
#ifdef XM7DASH
	int i;
#endif
	/* L[NׂăNA */
	szCaption[0] = '\0';
	nCAP = -1;
	nKANA = -1;
	nINS = -1;
#ifdef XM7DASH
	for (i = 0; i < 4; i ++) {
 #if XM7_VER == 1 && defined(SFDC)
		nDrive[FDC_M][i] = -1;
		nDrive[FDC_S][i] = -1;
		szDrive[FDC_M][i][0] = '\0';
		szDrive[FDC_S][i][0] = '\0';
 #else	/* XM7_VER == 1 && defined(SFDC) */
		nDrive[i] = -1;
		szDrive[i][0] = '\0';
 #endif	/* XM7_VER == 1 && defined(SFDC) */
	}
#else
	nDrive[0] = -1;
	nDrive[1] = -1;
	szDrive[0][0] = '\0';
	szDrive[1][0] = '\0';
#endif
	nTape = -1;

	/* ` */
	DrawStatus();
}

#ifndef XM7DASH
/*
 *	LN^`
 */
static void FASTCALL DrawChar(HDC hDC, BYTE c, int x, int y, UINT color)
{
	int i;
	int j;
	BYTE *p;
	BYTE dat;

	/* TuROM(C)̃tHgAhX𓾂 */
	p = &subrom_c[c * 8];

	/* y[v */
	for (i=0; i<8; i++) {
		/* f[^擾 */
		dat = *p;
		p++;

		/* x[v */
		for (j=0; j<8; j++) {
			if (dat & 0x80) {
				SetPixelV(hDC, x, y, color);
			}
			else {
				SetPixelV(hDC, x, y, RGB(0, 0, 0));
			}
			dat <<= 1;
			x++;
		}

		/* y */
		x -= 8;
		y++;
	}
}
#endif

/*
 *	I[i[h[
 */
void FASTCALL OwnerDrawStatus(DRAWITEMSTRUCT *pDI)
{
	HBRUSH hBrush;
	COLORREF fColor;
	COLORREF bColor;
	RECT srect;
	char string[_MAX_FNAME + _MAX_EXT + 4];
	int drive;
#if XM7_VER == 1 && defined(XM7DASH)
	int type;
#endif	/* XM7_VER == 1 && defined(XM7DASH) */
#ifdef XM7DASH
	int ndrive;
	char *szdrive;
#endif

	ASSERT(pDI);

	/* AF */
	switch (pDI->itemData) {
		/* tbs[fBXN */
#ifdef XM7DASH
		case PANE_DRIVE3:
		case PANE_DRIVE2:
		case PANE_DRIVE1:
		case PANE_DRIVE0:
 #if XM7_VER == 1 && defined(SFDC)
		case PANE_SDRIVE3:
		case PANE_SDRIVE2:
		case PANE_SDRIVE1:
		case PANE_SDRIVE0:
 #endif	/* XM7_VER == 1 && defined(SFDC) */
			switch (pDI->itemData) {
			case PANE_DRIVE3:
				drive = 3;
 #if XM7_VER == 1 && defined(SFDC)
				type = FDC_M;
 #endif	/* XM7_VER == 1 && defined(SFDC) */
				break;
			case PANE_DRIVE2:
				drive = 2;
 #if XM7_VER == 1 && defined(SFDC)
				type = FDC_M;
 #endif	/* XM7_VER == 1 && defined(SFDC) */
				break;
			case PANE_DRIVE1:
				drive = 1;
 #if XM7_VER == 1 && defined(SFDC)
				type = FDC_M;
 #endif	/* XM7_VER == 1 && defined(SFDC) */
				break;
			case PANE_DRIVE0:
				drive = 0;
 #if XM7_VER == 1 && defined(SFDC)
				type = FDC_M;
 #endif	/* XM7_VER == 1 && defined(SFDC) */
				break;
 #if XM7_VER == 1 && defined(SFDC)
			case PANE_SDRIVE3:
				drive = 3;
				type = FDC_S;
				break;
			case PANE_SDRIVE2:
				drive = 2;
				type = FDC_S;
				break;
			case PANE_SDRIVE1:
				drive = 1;
				type = FDC_S;
				break;
			case PANE_SDRIVE0:
				drive = 0;
				type = FDC_S;
				break;
 #endif	/* XM7_VER == 1 && defined(SFDC) */
			}
 #if XM7_VER == 1 && defined(SFDC)
			ndrive  = nDrive[type][drive];
			szdrive = szDrive[type][drive];
 #else	/* XM7_VER == 1 && defined(SFDC) */
			ndrive  = nDrive[drive];
			szdrive = szDrive[drive];
 #endif	/* XM7_VER == 1 && defined(SFDC) */
			if (ndrive == FDC_ACCESS_NOTREADY) {
				strncpy(string, "", sizeof(string));
			}
			else {
				strncpy(string, szdrive, sizeof(string));
			}
			fColor = RGB(255, 255, 255);
			if ((ndrive == FDC_ACCESS_NOTREADY) ||
				(ndrive == FDC_ACCESS_TEJECT)) {
				bColor = RGB(0, 0, 0);
			}
			else if (ndrive == FDC_ACCESS_READ) {
				bColor = RGB(191, 0, 0);
			}
			else if (ndrive == FDC_ACCESS_WRITE) {
				bColor = RGB(0, 0, 191);
			}
			else {
				bColor = RGB(63, 63, 63);
			}
			break;
#else
		case PANE_DRIVE1:
		case PANE_DRIVE0:
			if (pDI->itemData == PANE_DRIVE0) {
				drive = 0;
			}
			else {
				drive = 1;
			}
			if ((nDrive[drive] == FDC_ACCESS_NOTREADY) &&
				(!fdc_teject[drive])) {
				strncpy(string, "", sizeof(string));
			}
			else {
				strncpy(string, szDrive[drive], sizeof(string));
			}
			fColor = RGB(255, 255, 255);
			bColor = RGB(63, 63, 63);
			if ((nDrive[drive] == FDC_ACCESS_NOTREADY) ||
				(fdc_teject[drive])) {
				bColor = RGB(0, 0, 0);
			}
			if (nDrive[drive] == FDC_ACCESS_READ) {
				bColor = RGB(191, 0, 0);
			}
			if (nDrive[drive] == FDC_ACCESS_WRITE) {
				bColor = RGB(0, 0, 191);
			}
			break;
#endif

		/* e[v */
		case PANE_TAPE:
			if (nTape >= 30000) {
				string[0] = '\0';
			}
			else {
				_snprintf(string, sizeof(string), "%04d", nTape % 10000);
			}
			fColor = RGB(255, 255, 255);
			bColor = RGB(63, 63, 63);
			if (nTape >= 10000) {
				if (nTape >= 30000) {
					bColor = RGB(0, 0, 0);
				}
				else if (nTape >= 20000) {
					bColor = RGB(0, 0, 191);
				}
				else {
					bColor = RGB(191, 0, 0);
				}
			}
			break;

		/* CAP */
		case PANE_CAP:
			fColor = RGB(255, 255, 255);
			strncpy(string, szCAPMessage, sizeof(string));
			if (nCAP) {
				bColor = RGB(255, 0, 0);
			}
			else {
				bColor = RGB(0, 0, 0);
			}
			break;

		/*  */
		case PANE_KANA:
			fColor = RGB(255, 255, 255);
			strncpy(string, szKANAMessage, sizeof(string));
			if (nKANA) {
				bColor = RGB(255, 0, 0);
			}
			else {
				bColor = RGB(0, 0, 0);
			}
			break;

		/* INS */
		case PANE_INS:
			fColor = RGB(255, 255, 255);
			strncpy(string, szINSMessage, sizeof(string));
			if (nINS) {
				bColor = RGB(255, 0, 0);
			}
			else {
				bColor = RGB(0, 0, 0);
			}
			break;

		/* ȊO */
		default:
			ASSERT(FALSE);
			return;
	}

	/* uVœh */
	hBrush = CreateSolidBrush(bColor);
	if (hBrush) {
		FillRect(pDI->hDC, &(pDI->rcItem), hBrush);
		DeleteObject(hBrush);
	}

	/* eLXg̉e` */
	srect.left = pDI->rcItem.left + 1;
	srect.right = pDI->rcItem.right + 1;
	srect.top = pDI->rcItem.top + 1;
	srect.bottom = pDI->rcItem.bottom + 1;
	SetTextColor(pDI->hDC, RGB(0, 0, 0));
	SetBkMode(pDI->hDC, TRANSPARENT);
	DrawText(pDI->hDC, string, strlen(string), &srect,
				DT_CENTER | DT_VCENTER | DT_SINGLELINE | DT_NOPREFIX);

	/* eLXg` */
	SetTextColor(pDI->hDC, fColor);
	SetBkMode(pDI->hDC, TRANSPARENT);	/* for WinXP Luna */
	DrawText(pDI->hDC, string, strlen(string), &(pDI->rcItem),
				DT_CENTER | DT_VCENTER | DT_SINGLELINE | DT_NOPREFIX);

	/* hCuԍ` */
#ifdef XM7DASH
	if ((pDI->itemData == PANE_DRIVE0) || (pDI->itemData == PANE_DRIVE1) ||
#if XM7_VER == 1 && defined(SFDC)
		(pDI->itemData == PANE_SDRIVE0) || (pDI->itemData == PANE_SDRIVE1) ||
		(pDI->itemData == PANE_SDRIVE2) || (pDI->itemData == PANE_SDRIVE3) ||
#endif	/* XM7_VER == 1 && defined(SFDC) */
		(pDI->itemData == PANE_DRIVE2) || (pDI->itemData == PANE_DRIVE3)) {
		ndrive = (PANE_DRIVE0 - pDI->itemData) % 4;
		SetDIBitsToDevice(pDI->hDC, pDI->rcItem.right - 8, pDI->rcItem.bottom - 8, 8, 8, 0, 0, 0, 8,
							&bmpDrive[ndrive][sizeof(BITMAPINFOHEADER)],
							(BITMAPINFO*)&bmpDrive[ndrive][0],
							DIB_RGB_COLORS);
#if XM7_VER == 1 && defined(SFDC)
		if (type == FDC_S) {
#if 1
			SetDIBitsToDevice(pDI->hDC, pDI->rcItem.left, pDI->rcItem.top, 15, 6, 0, 0, 0, 6,
								&bmp2HD[sizeof(BITMAPINFOHEADER)],
								(BITMAPINFO*)&bmp2HD[0],
								DIB_RGB_COLORS);
#else
			const int nums[] = {2, 4, 5};
			for (drive = 0; drive <= 2; drive ++) {
				SetDIBitsToDevice(pDI->hDC, pDI->rcItem.left + drive * 8, pDI->rcItem.top, 8, 8, 0, 0, 0, 8,
									&bmpDrive[nums[drive]][sizeof(BITMAPINFOHEADER)],
									(BITMAPINFO*)&bmpDrive[nums[drive]][0],
									DIB_RGB_COLORS);
			}
#endif
		}

#endif	/* XM7_VER == 1 && defined(SFDC) */
	}
#else
	if ((pDI->itemData == PANE_DRIVE1) || (pDI->itemData == PANE_DRIVE0)) {
		DrawChar(pDI->hDC, (BYTE)(0x30 + drive),
				 pDI->rcItem.right - 8, pDI->rcItem.bottom - 8,
				 RGB(255, 255, 255));
	}
#endif
}

/*
 *	TCYύX
 */
void FASTCALL SizeStatus(LONG cx)
{
	HDC hDC;
	TEXTMETRIC tm;
	LONG cw;
#ifdef XM7DASH
	UINT uPane[PANE_MAX];
	BOOL bsize;
#else
	UINT uPane[7];
#endif

	ASSERT(cx > 0);
	ASSERT(hStatusBar);

	/* eLXggbN擾 */
	hDC = GetDC(hStatusBar);
	GetTextMetrics(hDC, &tm);
	ReleaseDC(hStatusBar, hDC);
	cw = tm.tmAveCharWidth;

	/* yCTCY(yCE[̈ʒuݒ) */
	uPane[PANE_INS] = cx;
	uPane[PANE_KANA] = uPane[PANE_INS] - cw * 4;
	uPane[PANE_CAP] = uPane[PANE_KANA] - cw * 4;
	uPane[PANE_TAPE] = uPane[PANE_CAP] - cw * 4;
	uPane[PANE_DRIVE0] = uPane[PANE_TAPE] - cw * 5;
#ifdef XM7DASH
#ifdef FILTERDLL
	bsize = ((nScalingSize > 0) && (nScalingSize != 3) && (nScalingSize != 5));
#else
	bsize = bDoubleSize;
#endif
 #if XM7_VER == 1 && defined(SFDC)
	if (sfdc_enable && (fm_subtype != FMSUB_FM7)) {
		if (fdc_ready[FDC_M][2] != FDC_TYPE_NOTREADY ||
			fdc_ready[FDC_M][3] != FDC_TYPE_NOTREADY ||
			fdc_ready[FDC_S][2] != FDC_TYPE_NOTREADY ||
			fdc_ready[FDC_S][3] != FDC_TYPE_NOTREADY) {
#ifdef FILTERDLL
			if (nScalingSize == 3) {
				nDcw = 4;
			}
			else if (nScalingSize == 2) {
				nDcw = 14;
			}
			else if (nScalingSize == 4) {
				nDcw = 12;
			}
			else if (nScalingSize == 1) {
				nDcw = 9;
			}
			else if (nScalingSize == 5) {
				nDcw = 6;
			}
			else {
				nDcw = 4;
			}
#else
			if (bDoubleSize) {
				nDcw = 14;
			}
			else {
				nDcw = 4;
			}
#endif
			uPane[PANE_DRIVE1] = uPane[PANE_DRIVE0] - cw * nDcw;
			uPane[PANE_DRIVE2] = uPane[PANE_DRIVE1] - cw * nDcw;
			uPane[PANE_DRIVE3] = uPane[PANE_DRIVE2] - cw * nDcw;
			uPane[PANE_SDRIVE0] = uPane[PANE_DRIVE3] - cw * nDcw;
			uPane[PANE_SDRIVE1] = uPane[PANE_SDRIVE0] - cw * nDcw;
			uPane[PANE_SDRIVE2] = uPane[PANE_SDRIVE1] - cw * nDcw;
			uPane[PANE_SDRIVE3] = uPane[PANE_SDRIVE2] - cw * nDcw;
			uPane[PANE_DEFAULT] = uPane[PANE_SDRIVE3] - cw * nDcw;
		}
		else {
#ifdef FILTERDLL
			if (nScalingSize == 3) {
				nDcw = 4;
			}
			else if (nScalingSize == 5) {
				nDcw = 12;
			}
			else if (bsize) {
				nDcw = 16;
			}
			else {
				nDcw = 8;
			}
#else
			if (bsize) {
				nDcw = 16;
			}
			else {
				nDcw = 8;
			}
#endif
			uPane[PANE_DRIVE1] = uPane[PANE_DRIVE0] - cw * nDcw;
			uPane[PANE_DRIVE2] = uPane[PANE_DRIVE1] - cw * nDcw;
			uPane[PANE_DRIVE3] = uPane[PANE_DRIVE2];
			uPane[PANE_SDRIVE0] = uPane[PANE_DRIVE3];
			uPane[PANE_SDRIVE1] = uPane[PANE_SDRIVE0] - cw * nDcw;
			uPane[PANE_SDRIVE2] = uPane[PANE_SDRIVE1] - cw * nDcw;
			uPane[PANE_SDRIVE3] = uPane[PANE_SDRIVE2];
			uPane[PANE_DEFAULT] = uPane[PANE_SDRIVE3];
		}
	}
	else {
		if (fdc_ready[FDC_M][2] != FDC_TYPE_NOTREADY ||
			fdc_ready[FDC_M][3] != FDC_TYPE_NOTREADY) {
#ifdef FILTERDLL
			if (nScalingSize == 3) {
				nDcw = 4;
			}
			else if (nScalingSize == 5) {
				nDcw = 12;
			}
			else if (bsize) {
				nDcw = 16;
			}
			else {
				nDcw = 8;
			}
#else
			if (bsize) {
				nDcw = 16;
			}
			else {
				nDcw = 8;
			}
#endif
			uPane[PANE_DRIVE1] = uPane[PANE_DRIVE0] - cw * nDcw;
			uPane[PANE_DRIVE2] = uPane[PANE_DRIVE1] - cw * nDcw;
			uPane[PANE_DRIVE3] = uPane[PANE_DRIVE2] - cw * nDcw;
			uPane[PANE_SDRIVE0] = uPane[PANE_DRIVE3] - cw * nDcw;
			uPane[PANE_SDRIVE1] = uPane[PANE_SDRIVE0];
			uPane[PANE_SDRIVE2] = uPane[PANE_SDRIVE1];
			uPane[PANE_SDRIVE3] = uPane[PANE_SDRIVE2];
			uPane[PANE_DEFAULT] = uPane[PANE_SDRIVE3];
		}
		else {
#ifdef FILTERDLL
			if (nScalingSize == 3) {
				nDcw = 4;
			}
			else {
				nDcw = 16;
			}
#else
			nDcw = 16;
#endif
			uPane[PANE_DRIVE1] = uPane[PANE_DRIVE0] - cw * nDcw;
			uPane[PANE_DRIVE2] = uPane[PANE_DRIVE1] - cw * nDcw;
			uPane[PANE_DRIVE3] = uPane[PANE_DRIVE2];
			uPane[PANE_SDRIVE0] = uPane[PANE_DRIVE3];
			uPane[PANE_SDRIVE1] = uPane[PANE_SDRIVE0];
			uPane[PANE_SDRIVE2] = uPane[PANE_SDRIVE1];
			uPane[PANE_SDRIVE3] = uPane[PANE_SDRIVE2];
			uPane[PANE_DEFAULT] = uPane[PANE_SDRIVE3];
		}
	}
 #else	/* XM7_VER == 1 && defined(SFDC) */
	if (fdc_ready[2] != FDC_TYPE_NOTREADY ||
		fdc_ready[3] != FDC_TYPE_NOTREADY) {
#ifdef FILTERDLL
			if (nScalingSize == 3) {
				nDcw = 4;
			}
			else if (nScalingSize == 5) {
				nDcw = 12;
			}
			else if (bsize) {
				nDcw = 16;
			}
			else {
				nDcw = 8;
			}
#else
			if (bsize) {
				nDcw = 16;
			}
			else {
				nDcw = 8;
			}
#endif
		uPane[PANE_DRIVE1] = uPane[PANE_DRIVE0] - cw * nDcw;
		uPane[PANE_DRIVE2] = uPane[PANE_DRIVE1] - cw * nDcw;
		uPane[PANE_DRIVE3] = uPane[PANE_DRIVE2] - cw * nDcw;
		uPane[PANE_DEFAULT] = uPane[PANE_DRIVE3] - cw * nDcw;
	}
	else {
#ifdef FILTERDLL
		if (nScalingSize == 3) {
			nDcw = 4;
		}
		else {
			nDcw = 16;
		}
#else
		nDcw = 16;
#endif
		uPane[PANE_DRIVE1] = uPane[PANE_DRIVE0] - cw * nDcw;
		uPane[PANE_DRIVE2] = uPane[PANE_DRIVE1] - cw * nDcw;
		uPane[PANE_DRIVE3] = uPane[PANE_DRIVE2];
		uPane[PANE_DEFAULT] = uPane[PANE_DRIVE3];
	}
 #endif	/* XM7_VER == 1 && defined(SFDC) */
#else	/* XM7DASH */
	uPane[PANE_DRIVE1] = uPane[PANE_DRIVE0] - cw * 16;
	uPane[PANE_DEFAULT] = uPane[PANE_DRIVE1] - cw * 16;
#endif	/* XM7DASH */

	/* Drag&DroppyCWݒ */
#ifdef XM7DASH
 #if XM7_VER == 1 && defined(SFDC)
	uPaneX[0] = uPane[PANE_DEFAULT];
	uPaneX[1] = uPane[PANE_SDRIVE3];
	uPaneX[2] = uPane[PANE_SDRIVE2];
	uPaneX[3] = uPane[PANE_SDRIVE1];
	uPaneX[4] = uPane[PANE_SDRIVE0];
	uPaneX[5] = uPane[PANE_DRIVE3];
	uPaneX[6] = uPane[PANE_DRIVE2];
	uPaneX[7] = uPane[PANE_DRIVE1];
	uPaneX[8] = uPane[PANE_DRIVE0];
 #else	/* XM7_VER == 1 && defined(SFDC) */
	uPaneX[0] = uPane[PANE_DEFAULT];
	uPaneX[1] = uPane[PANE_DRIVE3];
	uPaneX[2] = uPane[PANE_DRIVE2];
	uPaneX[3] = uPane[PANE_DRIVE1];
	uPaneX[4] = uPane[PANE_DRIVE0];
 #endif	/* XM7_VER == 1 && defined(SFDC) */
#else	/* XM7DASH */
	uPaneX[0] = uPane[PANE_DEFAULT];
	uPaneX[1] = uPane[PANE_DRIVE1];
	uPaneX[2] = uPane[PANE_DRIVE0];
#endif	/* XM7DASH */

	/* yCTCYݒ */
	Status_SetParts(hStatusBar, sizeof(uPane)/sizeof(UINT), uPane);

	/* ĕ` */
	PaintStatus();
}

/*
 *	Xe[^Xo[TCY
 */
void FASTCALL ResizeStatus(HWND hwnd, HWND hstatus)
{
	RECT rect;
	int height;

	/* wiFύX */
	SendMessage(hstatus, SB_SETBKCOLOR, 0, GetSysColor(COLOR_3DFACE));

	/* ␳ */
	GetWindowRect(hstatus, &rect);
#if defined(XM7DASH) && defined(FILTERDLL)
	switch (nScalingSize) {
		case 0:						/* x1.0(640x400) */
		default:
			height = 400;
			break;

		case 1:						/* x1.5(960x600) */
			height = 600;
			break;

		case 2:						/* x2.0(1280x800) */
			height = 800;
			break;

		case 3:						/* x0.5(320x200) */
			height = 200;
			break;

		case 4:						/* x1.8(1152x720) */
			height = 720;
			break;

		case 5:						/* x1.2(768x480) */
			height = 480;
			break;
	}
#else
	if (bDoubleSize) {
		height = 800;
	}
	else {
		height = 400;
	}
#endif
	MoveWindow(hstatus, 0, height, (rect.right - rect.left),
			   GetSystemMetrics(SM_CYMENU), TRUE);

	/* t[EChẼTCY␳ */
	GetClientRect(hwnd, &rect);
	PostMessage(hwnd, WM_SIZE, 0, MAKELPARAM(rect.right, rect.bottom));
}

/*
 *	Xe[^XbZ[W\
 */
void FASTCALL SetStatusMessage(UINT ID)
{
	ASSERT(hStatusBar);

	/* Xe[^Xo[\ĂȂ΁AȂ */
	if (!IsWindowVisible(hStatusBar)) {
		return;
	}

	/* wID̕񃊃\[X[h݂ */
	if (LoadString(hResInstance, ID, szStatusMessage, sizeof(szStatusMessage)) != 0) {
		/* Xe[^XbZ[WZbg */
		Status_SetText(hStatusBar, 0, nStatusBorder, szStatusMessage);

		/* Xe[^XbZ[Wp^C}ݒ肷 */
		if (bStatusMessage) {
			KillTimer(hMainWnd, ID_STATUS_BAR);
		}
		SetTimer(hMainWnd, ID_STATUS_BAR, 1500, NULL);

		/* Xe[^XbZ[W\tO𗧂Ă */
		bStatusMessage = TRUE;
	}
	else {
		/* \[X[hɎsꍇA\tO~낷 */
		bStatusMessage = FALSE;
	}
}

/*
 *	Xe[^XbZ[WI
 */
void FASTCALL EndStatusMessage(void)
{
	char buffer[128];

	ASSERT(hStatusBar);

	/* ƂƃXe[^XbZ[W\ĂȂ΁AȂ */
	if (!bStatusMessage) {
		return;
	}

	/* Xe[^XbZ[W\tO~낷 */
	bStatusMessage = FALSE;

	/* Xe[^Xo[\ĂȂ΁AȂ */
	if (!IsWindowVisible(hStatusBar)) {
		return;
	}

	if (uResID != 0) {
		/* 񃊃\[X[h݂ */
		if (LoadString(hResInstance, uResID, buffer, sizeof(buffer)) == 0) {
			buffer[0] = '\0';
		}
	}
	else {
		/* AChbZ[WRs[ */
		strncpy(buffer, szIdleMessage, sizeof(buffer));
	}

	/* Zbg */
	Status_SetText(hStatusBar, 0, nStatusBorder, buffer);
}

/*
 *	j[ZNg
 */
void FASTCALL OnMenuSelect(WPARAM wParam)
{
	char buffer[128];
	UINT uID;

	ASSERT(hStatusBar);

	/* Xe[^Xo[\ĂȂ΁AȂ */
	if (!IsWindowVisible(hStatusBar)) {
		return;
	}

	/* [h郊\[XID */
	uID = (UINT)LOWORD(wParam);
	if (((uID >= IDM_D0MEDIA00) && (uID <= IDM_D0MEDIA15)) ||
#ifdef XM7DASH
		((uID >= IDM_D2MEDIA00) && (uID <= IDM_D2MEDIA15)) ||
		((uID >= IDM_D3MEDIA00) && (uID <= IDM_D3MEDIA15)) ||
#endif	/* XM7DASH */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
		((uID >= IDM_D4MEDIA00) && (uID <= IDM_D4MEDIA15)) ||
		((uID >= IDM_D5MEDIA00) && (uID <= IDM_D5MEDIA15)) ||
		((uID >= IDM_D6MEDIA00) && (uID <= IDM_D6MEDIA15)) ||
		((uID >= IDM_D7MEDIA00) && (uID <= IDM_D7MEDIA15)) ||
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
#if XM7_VER == 1 && defined(BUBBLE) && defined(XM7DASH)
		((uID >= IDM_B0MEDIA00) && (uID <= IDM_B0MEDIA15)) ||
		((uID >= IDM_B1MEDIA00) && (uID <= IDM_B1MEDIA15)) ||
		((uID >= IDM_B2MEDIA00) && (uID <= IDM_B2MEDIA15)) ||
		((uID >= IDM_B3MEDIA00) && (uID <= IDM_B3MEDIA15)) ||
#endif	/* XM7_VER == 1 && defined(BUBBLE) && defined(XM7DASH) */
		((uID >= IDM_D1MEDIA00) && (uID <= IDM_D1MEDIA15))) {
		/* fBA */
		uID = IDS_MEDIA_CHANGE;
	}
#ifdef XM7DASH
	if ((uID >= IDM_STATE_FILE0) && (uID <= IDM_STATE_FILE9)) {
		/* z}VXe[gt@CJ */
		uID = IDM_OPEN;
	}
	if ((uID >= IDM_D0_FILE0) && (uID <= IDM_D0_FILE9)) {
		/* fBXNC[W}Eg */
		uID = IDM_D0OPEN;
	}
	if ((uID >= IDM_D1_FILE0) && (uID <= IDM_D1_FILE9)) {
		/* fBXNC[W}Eg */
		uID = IDM_D1OPEN;
	}
	if ((uID >= IDM_D2_FILE0) && (uID <= IDM_D2_FILE9)) {
		/* fBXNC[W}Eg */
		uID = IDM_D2OPEN;
	}
	if ((uID >= IDM_D3_FILE0) && (uID <= IDM_D3_FILE9)) {
		/* fBXNC[W}Eg */
		uID = IDM_D3OPEN;
	}
#if XM7_VER == 1 && defined(SFDC)
	if ((uID >= IDM_D4_FILE0) && (uID <= IDM_D4_FILE9)) {
		/* fBXNC[W}Eg */
		uID = IDM_D4OPEN;
	}
	if ((uID >= IDM_D5_FILE0) && (uID <= IDM_D5_FILE9)) {
		/* fBXNC[W}Eg */
		uID = IDM_D5OPEN;
	}
	if ((uID >= IDM_D6_FILE0) && (uID <= IDM_D6_FILE9)) {
		/* fBXNC[W}Eg */
		uID = IDM_D6OPEN;
	}
	if ((uID >= IDM_D7_FILE0) && (uID <= IDM_D7_FILE9)) {
		/* fBXNC[W}Eg */
		uID = IDM_D7OPEN;
	}
#endif	/* XM7_VER == 1 && defined(SFDC) */
	if ((uID >= IDM_T_FILE0) && (uID <= IDM_T_FILE9)) {
		/* e[vC[W}Eg */
		uID = IDM_TOPEN;
	}
#if XM7_VER == 1 && defined(BUBBLE)
	if ((uID >= IDM_B0_FILE0) && (uID <= IDM_B0_FILE9)) {
		/* ouJZbgC[W}Eg */
		uID = IDM_B0OPEN;
	}
	if ((uID >= IDM_B1_FILE0) && (uID <= IDM_B1_FILE9)) {
		/* ouJZbgC[W}Eg */
		uID = IDM_B1OPEN;
	}
	if ((uID >= IDM_B2_FILE0) && (uID <= IDM_B2_FILE9)) {
		/* ouJZbgC[W}Eg */
		uID = IDM_B2OPEN;
	}
	if ((uID >= IDM_B3_FILE0) && (uID <= IDM_B3_FILE9)) {
		/* ouJZbgC[W}Eg */
		uID = IDM_B3OPEN;
	}
#endif	/* XM7_VER == 1 && defined(BUBBLE) */
#ifdef FMDLL
	if ((uID >= IDM_EXTSND1) && (uID <= IDM_EXTSND9)) {
		/* ODLLύX */
		uID = IDM_EXT_SOUND_DLL;
	}
#endif
#ifdef FILTERDLL
	if ((uID >= IDM_EXTFLT1) && (uID <= IDM_EXTFLT9)) {
		/* O摜tB^DLLύX */
		uID = IDM_EXT_FILTER_DLL;
	}
#endif
#endif

	/* 񃊃\[X[h݂ */
	if (LoadString(hResInstance, uID, buffer, sizeof(buffer)) == 0) {
		buffer[0] = '\0';
	}

	/* Zbg */
	Status_SetText(hStatusBar, 0, nStatusBorder, buffer);

	/* \[XID([htO)ۑ */
	uResID = uID;
}

/*
 *	j[I
 */
void FASTCALL OnExitMenuLoop(void)
{
	ASSERT(hStatusBar);

	/* Xe[^Xo[\ĂȂ΁AȂ */
	if (!IsWindowVisible(hStatusBar)) {
		return;
	}

	/* AChbZ[W\ */
	if (bStatusMessage) {
		Status_SetText(hStatusBar, 0, nStatusBorder, szStatusMessage);
	}
	else {
		Status_SetText(hStatusBar, 0, nStatusBorder, szIdleMessage);
	}

	/* \[XID([htO)ۑ */
	uResID = 0;
}

/*-[ WindowsXPΉ ]----------------------------------------------------*/

/*
 *	WindowsXP rWAX^CΉp 08/14
 *	UXTHEME.DLL
 */
void FASTCALL InitThemeDLL(void)
{
	/* uxtheme.dll[h */
	hInstTheme = LoadLibrary("uxtheme.dll");

	/* ֐̐擪AhXݒ */
	if (hInstTheme) {
		IsAppThemed = (BOOL(*)(void))GetProcAddress(hInstTheme, "IsAppThemed");

		if (!IsAppThemed) {
			/* s */
			CleanThemeDLL();
		}
	}
}

/*
 *	WindowsXP rWAX^CΉp
 *	UXTHEME.DLLN[Abv
 */
void FASTCALL CleanThemeDLL(void)
{
	/* DLLǂݍ܂ĂJ */
	if (hInstTheme) {
		FreeLibrary(hInstTheme);
		IsAppThemed = NULL;
		hInstTheme = NULL;
	}
}

/*
 *	WindowsXP rWAX^CΉp
 *	Xe[^XbZ[W{[_[`ԕύX
 */
void FASTCALL ChangeStatusBorder(HWND hwnd)
{
	/* e[}KpԂł͘g`悷 */
	if (hInstTheme && IsAppThemed) {
		if (!IsAppThemed()) {
			nStatusBorder = SBT_NOBORDERS;
			bThemed = FALSE;
		}
		else {
			nStatusBorder = 0;
			bThemed = TRUE;
		}
	}
	else {
		nStatusBorder = SBT_NOBORDERS;
		bThemed = FALSE;
	}

	/* AChbZ[W\ */
	if (bStatusMessage) {
		Status_SetText(hwnd, 0, nStatusBorder, szStatusMessage);
	}
	else {
		Status_SetText(hwnd, 0, nStatusBorder, szIdleMessage);
	}
}

#endif	/* _WIN32 */
