/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2014 ohD(yasushi@tanaka.net)
 *	Copyright (C) 2001-2014 Ryu Takegami
 *	Copyright (C) 2010-2014 Toma
 *
 *	[ Win32API TuEChE ]
 */

#ifdef _WIN32

#ifndef _w32_sub_h_
#define _w32_sub_h_

/*
 *	TuEChE`
 */
#ifdef XM7DASH
enum {
	SWND_BREAKPOINT = 0,				/* u[N|Cg */
	SWND_SCHEDULER,						/* XPW[ */
	SWND_CPUREG_MAIN,					/* CPUWX^ C */
	SWND_CPUREG_SUB,					/* CPUWX^ Tu */
#ifdef JSUB
	SWND_CPUREG_JSUB,					/* CPUWX^ {Tu */
#endif
	SWND_DISASM_MAIN,					/* tAZu C */
	SWND_DISASM_SUB,					/* tAZu Tu */
#ifdef JSUB
	SWND_DISASM_JSUB,					/* tAZu {Tu */
#endif
	SWND_MEMORY_MAIN,					/* _v C */
	SWND_MEMORY_SUB,					/* _v Tu */
#ifdef JSUB
	SWND_MEMORY_JSUB,					/* _v {Tu */
#endif
	SWND_FDC,							/* FDC */
	SWND_OPNREG,						/* OPNWX^ */
	SWND_OPNDISP,						/* OPNfBXvC */
	SWND_SUBCTRL,						/* TuCPURg[ */
#if XM7_VER >= 2
	SWND_ALULINE,						/* _Z/ */
#endif
	SWND_KEYBOARD,						/* L[{[h */
	SWND_MMR,							/* MMR */
#if XM7_VER >= 3 || (XM7_VER == 1 && defined(SFDC) && defined(XM7DASH))
	SWND_DMAC,							/* DMAC */
#endif
	SWND_IRQ,							/* IRQ */
#if XM7_VER == 1 && defined(BUBBLE)
	SWND_BMC,							/* ouRg[ */
#endif	/* XM7_VER == 1 && defined(BUBBLE) */
#ifdef DBGLOG
	SWND_LOG,							/* O */
#endif
	SWND_MAXNUM,						/* őTuEChE */
};
#else
#define SWND_BREAKPOINT			0		/* u[N|Cg */
#define SWND_SCHEDULER			1		/* XPW[ */
#if XM7_VER == 1
#define SWND_CPUREG_MAIN		2		/* CPUWX^ C */
#define SWND_CPUREG_SUB			3		/* CPUWX^ Tu */
#define SWND_CPUREG_JSUB		4		/* CPUWX^ {Tu */
#define SWND_DISASM_MAIN		5		/* tAZu C */
#define SWND_DISASM_SUB			6		/* tAZu Tu */
#define SWND_DISASM_JSUB		7		/* tAZu {Tu */
#define SWND_MEMORY_MAIN		8		/* _v C */
#define SWND_MEMORY_SUB			9		/* _v Tu */
#define SWND_MEMORY_JSUB		10		/* _v {Tu */
#define SWND_FDC				11		/* FDC */
#define SWND_OPNREG				12		/* OPNWX^ */
#define SWND_OPNDISP			13		/* OPNfBXvC */
#define SWND_SUBCTRL			14		/* TuCPURg[ */
#define SWND_KEYBOARD			15		/* L[{[h */
#define SWND_MMR				16		/* MMR */
#if defined(BUBBLE)
#define SWND_BMC				17		/* ouRg[ */
#define SWND_MAXNUM				18
#else
#define SWND_MAXNUM				17		/* őTuEChE */
#endif
#else
#define SWND_CPUREG_MAIN		2		/* CPUWX^ C */
#define SWND_CPUREG_SUB			3		/* CPUWX^ Tu */
#define SWND_DISASM_MAIN		4		/* tAZu C */
#define SWND_DISASM_SUB			5		/* tAZu Tu */
#define SWND_MEMORY_MAIN		6		/* _v C */
#define SWND_MEMORY_SUB			7		/* _v Tu */
#define SWND_FDC				8		/* FDC */
#define SWND_OPNREG				9		/* OPNWX^ */
#define SWND_OPNDISP			10		/* OPNfBXvC */
#define SWND_SUBCTRL			11		/* TuCPURg[ */
#define SWND_ALULINE			12		/* _Z/ */
#define SWND_KEYBOARD			13		/* L[{[h */
#define SWND_MMR				14		/* MMR */
#if XM7_VER >= 3
#define	SWND_DMAC				15		/* DMAC */
#define SWND_MAXNUM				16		/* őTuEChE */
#else
#define SWND_MAXNUM				15		/* őTuEChE */
#endif
#endif
#endif

#ifdef XM7DASH
/*
 *	TuEChE֐^`
 */
typedef HWND (FASTCALL *CREATESWNDFUNC)(HWND, int);
#endif

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
void FASTCALL InitSubWndWork(void);
										/* TuEBhE[N */

HWND FASTCALL CreateBreakPoint(HWND hParent, int index);
										/* u[N|CgEChE 쐬 */
void FASTCALL RefreshBreakPoint(void);
										/* u[N|CgEChE tbV */
HWND FASTCALL CreateScheduler(HWND hParent, int index);
										/* XPW[EChE 쐬 */
void FASTCALL RefreshScheduler(void);
										/* XPW[EChE tbV */
HWND FASTCALL CreateCPURegister(HWND hParent, BYTE nCPU, int index);
										/* CPUWX^EChE 쐬 */
#ifdef XM7DASH
HWND FASTCALL CreateCPURegisterMain(HWND hParent, int index);
										/* CPUWX^EChE 쐬(CCPU) */
HWND FASTCALL CreateCPURegisterSub(HWND hParent, int index);
										/* CPUWX^EChE 쐬(TuCPU) */
#ifdef JSUB
HWND FASTCALL CreateCPURegisterJSub(HWND hParent, int index);
										/* CPUWX^EChE 쐬({TuCPU) */
#endif
#endif
void FASTCALL RefreshCPURegister(void);
										/* CPUWX^EChE tbV */
HWND FASTCALL CreateDisAsm(HWND hParent, BYTE nCPU, int index);
										/* tAZuEChE 쐬 */
#ifdef XM7DASH
HWND FASTCALL CreateDisAsmMain(HWND hParent, int index);
										/* tAZuEChE 쐬(CCPU) */
HWND FASTCALL CreateDisAsmSub(HWND hParent, int index);
										/* tAZuEChE 쐬(TuCPU) */
#ifdef JSUB
HWND FASTCALL CreateDisAsmJSub(HWND hParent, int index);
										/* tAZuEChE 쐬({TuCPU) */
#endif
#endif
void FASTCALL RefreshDisAsm(void);
										/* tAZuEChE tbV */
void FASTCALL AddrDisAsm(BYTE nCPU, WORD wAddr);
										/* tAZuEChE AhXw */
HWND FASTCALL CreateMemory(HWND hParent, BYTE nCPU, int index);
										/* _vEChE 쐬 */
#ifdef XM7DASH
HWND FASTCALL CreateMemoryMain(HWND hParent, int index);
										/* _vEChE 쐬(CCPU) */
HWND FASTCALL CreateMemorySub(HWND hParent, int index);
										/* _vEChE 쐬(TuCPU) */
#ifdef JSUB
HWND FASTCALL CreateMemoryJSub(HWND hParent, int index);
										/* _vEChE 쐬({TuCPU) */
#endif
#endif
void FASTCALL RefreshMemory(void);
										/* _vEChE tbV */
void FASTCALL AddrMemory(BYTE nCPU, WORD wAddr);
										/* _vEChE AhXw */

HWND FASTCALL CreateFDC(HWND hParent, int index);
										/* FDCEChE 쐬 */
void FASTCALL RefreshFDC(void);
										/* FDCEChE tbV */
#if XM7_VER == 1 && defined(SFDC) && defined(XM7DASH)
void FASTCALL ReSizeFDC(void);
										/* FDCEChE TCY */
#endif	/* XM7_VER == 1 && defined(SFDC) && defined(XM7DASH) */
#if XM7_VER == 1 && defined(BUBBLE)
HWND FASTCALL CreateBMC(HWND hParent, int index);
										/* BMCEChE 쐬 */
void FASTCALL RefreshBMC(void);
										/* BMCEChE tbV */
#ifdef XM7DASH
void FASTCALL ReSizeBMC(void);
										/* BMCEChE TCY */
#endif
#endif
HWND FASTCALL CreateOPNReg(HWND hParent, int index);
										/* OPNWX^EChE 쐬 */
void FASTCALL RefreshOPNReg(void);
										/* OPNWX^EChE tbV */
void FASTCALL ReSizeOPNReg(void);
										/* OPNWX^EChE TCY */
HWND FASTCALL CreateSubCtrl(HWND hParent, int index);
										/* TuCPURg[EChE 쐬 */
void FASTCALL RefreshSubCtrl(void);
										/* TuCPURg[EChE tbV */
HWND FASTCALL CreateALULine(HWND hParent, int index);
										/* _Z/ԃEChE 쐬 */
void FASTCALL RefreshALULine(void);
										/* _Z/ԃEChE tbV */
HWND FASTCALL CreateOPNDisp(HWND hParent, int index);
										/* OPNfBXvCEChE 쐬 */
void FASTCALL RefreshOPNDisp(void);
										/* OPNfBXvCEChE tbV */
void FASTCALL ReSizeOPNDisp(void);
										/* OPNfBXvCEChE TCY */
HWND FASTCALL CreateKeyboard(HWND hParent, int index);
										/* L[{[hEChE 쐬 */
void FASTCALL RefreshKeyboard(void);
										/* L[{[hEChE tbV */
HWND FASTCALL CreateMMR(HWND hParent, int index);
										/* MMREChE 쐬 */
void FASTCALL RefreshMMR(void);
										/* MMREChE tbV */
#if XM7_VER != 2 && defined(XM7DASH)
void FASTCALL ReSizeMMR(void);
										/* MMREChE TCY */
#endif
#if XM7_VER >= 3 || (XM7_VER == 1 && defined(SFDC) && defined(XM7DASH))
HWND FASTCALL CreateDMAC(HWND hParent, int index);
										/* DMACEChE 쐬 */
void FASTCALL RefreshDMAC(void);
										/* DMACEChE tbV */
#endif
#ifdef XM7DASH
HWND FASTCALL CreateIRQ(HWND hParent, int index);
										/* IRQEChE 쐬 */
void FASTCALL RefreshIRQ(void);
										/* IRQEChE tbV */
#endif
#if defined(XM7DASH) && defined(DBGLOG)
HWND FASTCALL CreateLog(HWND hParent, int index);
										/* OEChE 쐬 */
void FASTCALL RefreshLog(void);
										/* OEChE tbV */
#endif

/*
 *	ėp[`
 */
void FASTCALL DrawWindowText(HDC hDC, BYTE *ptr, int x, int y);
										/* eLXg` */
void FASTCALL DrawWindowText2(HDC hDC, BYTE *ptr, int x, int y);
										/* eLXg`(]t) */
void FASTCALL DestroySubWindow(HWND hWnd, BYTE **pBuf, HMENU hmenu);
										/* TuEChEDestroy */
#ifdef XM7DASH
void FASTCALL PositioningSubWindow(HWND hParent, LPRECT rect, int index);
										/* TuEChEʒuZo */
void FASTCALL RestoreSubWindow(void);
										/* TuEBhE𕜌 */
void FASTCALL MoveSubWindow(HWND hWnd);
										/* TuEChEWM_SIZE */
#endif

/*
 *	v[N
 */
extern HWND hSubWnd[SWND_MAXNUM];
										/* TuEChE */
extern BOOL bShowSubWindow[SWND_MAXNUM];
										/* TuEChE\ */
#ifdef XM7DASH
extern BOOL bSwndVisible;
										/* TuEBhE\tO */
extern BOOL bPopupSwnd;
										/* TuEBhE|bvAbv */
extern BOOL bResumeSwnd;
										/* TuEBhEԂۑ */
extern BOOL bResumeBootSwnd;
										/* NɃTuEBhEԂ𕜋A */
extern int nSwndFlag[SWND_MAXNUM];
										/* TuEBhE\ */
extern RECT stSwndRect[SWND_MAXNUM];
										/* TuEBhEʒu */
extern WORD wDisAsm[MAXCPU];
										/* tAZu AhX */
extern BYTE nHeightDisAsm[MAXCPU];
										/* tAZu EBhEcTCY */
extern BYTE nAddrSegDisAsm;
										/* tAZuZOg */
extern int nAddrModeDisAsm;
										/* tAZuAhX[h */
extern WORD wMemory[MAXCPU];
										/* _v AhX */
extern BYTE nHeightMemory[MAXCPU];
										/* _v EBhEcTCY */
extern BOOL bAsciiDump[MAXCPU];
										/* _v ASCII\ */
extern BOOL bKanjiDump[MAXCPU];
										/* _v \ */
extern BYTE nAddrSegDump;
										/* _vZOg */
extern int nAddrModeDump;
										/* _vAhX[h */
#ifdef DBGLOG
extern LONG lLogHeight;
										/* O EBhEcTCY */
extern LONG lLogWidth;
										/* O EBhETCY */
#endif
#endif
#ifdef __cplusplus
}
#endif

#endif	/* _w32_sub_h_ */
#endif	/* _WIN32 */
