/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2014 ohD(yasushi@tanaka.net)
 *	Copyright (C) 2001-2014 Ryu Takegami
 *	Copyright (C) 2010-2014 Toma
 *
 *	[ Win32API TuEBhEP ]
 */

#ifdef _WIN32

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <mmsystem.h>
#include <assert.h>
#include <stdlib.h>
#include "xm7.h"
#include "event.h"
#ifdef XM7DASH
#include "mmr.h"
#endif
#include "jsubsys.h"
#include "mouse.h"
#include "w32.h"
#include "w32_res.h"
#include "w32_sch.h"
#include "w32_sub.h"
#include "w32_kbd.h"

/*
 *	O[o [N
 */
HWND hSubWnd[SWND_MAXNUM];				/* TuEChE */
BOOL bShowSubWindow[SWND_MAXNUM];		/* TuEBhE\ */
#ifdef XM7DASH
BOOL bSwndVisible;						/* TuEBhE\tO */
BOOL bPopupSwnd;						/* TuEBhE|bvAbv */
BOOL bResumeSwnd;						/* TuEBhEԂۑ */
BOOL bResumeBootSwnd;					/* NɃTuEBhEԂ𕜋A */
int nSwndFlag[SWND_MAXNUM];				/* TuEBhE */
RECT stSwndRect[SWND_MAXNUM];			/* TuEBhEʒu */
WORD wDisAsm[MAXCPU];					/* tAZu AhX */
BYTE nHeightDisAsm[MAXCPU];				/* tAZu EBhEcTCY */
BYTE nAddrSegDisAsm;					/* tAZuZOg */
int nAddrModeDisAsm;					/* tAZuAhX[h */
WORD wMemory[MAXCPU];					/* _v AhX */
BYTE nHeightMemory[MAXCPU];				/* _v EBhEcTCY */
BOOL bAsciiDump[MAXCPU];				/* _v ASCII\ */
BOOL bKanjiDump[MAXCPU];				/* _v \ */
BYTE nAddrSegDump;						/* _vZOg */
int nAddrModeDump;						/* _vAhX[h */
#ifdef DBGLOG
LONG lLogHeight;						/* O EBhEcTCY */
LONG lLogWidth;							/* O EBhETCY */
#endif
#endif

/*
 *	X^eBbN [N
 */
static WORD AddrHistory[16];			/* AhXqXg */
static WORD AddrBuf;					/* AhXobt@ */
static int AddrNum;						/* AhXqXg */
static BYTE nBreakCPU;					/* u[N|Cg ݒΏCPU */
static BYTE *pBreakPoint;				/* u[N|Cg Drawobt@ */
static HMENU hBreakPoint;				/* u[N|Cg j[nh */
static POINT PosBreakPoint;				/* u[N|Cg }EXʒu */
static BYTE *pScheduler;				/* XPW[ Drawobt@ */
static DWORD dwSchedulerTime[2];		/* XPW[  */
static DWORD dwSchedulerFrame[2];		/* XPW[ t[ */
static BYTE *pCPURegister[MAXCPU];		/* CPUWX^ Drawobt@ */
static HMENU hCPURegister[MAXCPU];		/* CPUWX^ j[nh */
static BYTE *pDisAsm[MAXCPU];			/* tAZu Drawobt@ */
#ifndef XM7DASH
static WORD wDisAsm[MAXCPU];			/* tAZu AhX */
#endif
static HMENU hDisAsm[MAXCPU];			/* tAZu j[nh */
static POINT PosDisAsmPoint;			/* tAZu }EXʒu */
#ifndef XM7DASH
static BYTE nHeightDisAsm[MAXCPU];		/* tAZu EBhEcTCY */
#endif
static BYTE *pMemory[MAXCPU];			/* _v Drawobt@ */
#ifndef XM7DASH
static WORD wMemory[MAXCPU];			/* _v AhX */
#endif
static HMENU hMemory[MAXCPU];			/* _v j[nh */
#ifndef XM7DASH
static BYTE nHeightMemory[MAXCPU];		/* _v EBhEcTCY */
static BOOL bAsciiDump[MAXCPU];			/* _v ASCII\ */
static BOOL bKanjiDump[MAXCPU];			/* _v \ */
#endif
static BYTE nMemDlgCPU;					/* ύX ύXΏCPU */
static WORD wMemDlgAddr;				/* ύX AhX */
static WORD nMemDlgByte;				/* ύX AhXe */
static BYTE nRegDlgCPU;					/* WX^ύX ύXΏCPU */
static BYTE nRegDlgNo;					/* WX^ύX ύXΏۃWX^ */
static BYTE nMemSrchCPU;				/*  ΏCPU */
static WORD wMemSrchAddr;				/*  JnAhX */
static WORD wMemSrchAddrSave[MAXCPU];	/*  JnAhX main */
static char szMemSrchString[128];		/*  Ώۃf[^ */
static WORD wStackAddr[16];				/* VXeX^bNWvAhX */
static WORD wBreakAddr[16];				/* u[N|CgWvAhX */


#if defined(XM7DASH) && defined(DBGLOG)
/*
 *	fobOOǗ\
 */
typedef struct {
	DWORD number;						/* ʂԍ(ZbgŃNA) */
	DWORD time;							/* z */
	DWORD pc;							/* vOJE^ */
	char *string;						/*  */
} logdata_t;

enum {
	LogMax = 0x4000						/* OőL^(2̔{ł邱) */
};

/*
 *	fobOOǗX^eBbN [N
 */
static HWND hLogWnd;
static int nLogTop = 0;					/* 擪|C^(łÂ) */
static int nLogNum = 0;					/* OL^ */
static int nLogCnt = 1;					/* OJEg */
static int nLogDsp = 0;					/* O\Jnԍ */
static logdata_t *stLogData[LogMax]		/* O|C^ */
								= {0};
#endif


/*
 *	VtgJIS}N+ӂ
 */
#define isKanji(p)	((BYTE)((p ^ 0x20) - 0xa1) <= 0x3b)
#define isKanji2(p)	(((BYTE)(p + 3) >= 0x43) && (p != 0x7f))
#ifdef XM7DASH
#define isJapanese	(!bLanguageMode)
#else
#define isJapanese	(PRIMARYLANGID(GetUserDefaultLangID()) == LANG_JAPANESE)
#endif

#ifdef XM7DASH
#if XM7_VER >= 3
#define	IDM_DIS_MAX	(IDM_DIS_SEG00 + 0x07)
#define	IDM_DMP_MAX	(IDM_DMP_SEG00 + 0x07)
#elif XM7_VER >= 2
#define	IDM_DIS_MAX	(IDM_DIS_SEG00 + 0x03)
#define	IDM_DMP_MAX	(IDM_DMP_SEG00 + 0x03)
#else
#define	IDM_DIS_MAX	(IDM_DIS_SEG00 + 0x3f)
#define	IDM_DMP_MAX	(IDM_DMP_SEG00 + 0x3f)
#endif

/*
 *	TuEChE쐬֐e[u
 */
static const CREATESWNDFUNC	CreateSwndFunc[SWND_MAXNUM] = {
	CreateBreakPoint,					/* u[N|Cg */
	CreateScheduler,					/* XPW[ */
	CreateCPURegisterMain,				/* CPUWX^ C */
	CreateCPURegisterSub,				/* CPUWX^ Tu */
#ifdef JSUB
	CreateCPURegisterJSub,				/* CPUWX^ {Tu */
#endif
	CreateDisAsmMain,					/* tAZu C */
	CreateDisAsmSub,					/* tAZu Tu */
#ifdef JSUB
	CreateDisAsmJSub,					/* tAZu {Tu */
#endif
	CreateMemoryMain,					/* _v C */
	CreateMemorySub,					/* _v Tu */
#ifdef JSUB
	CreateMemoryJSub,					/* _v {Tu */
#endif
	CreateFDC,							/* FDC */
	CreateOPNReg,						/* OPNWX^ */
	CreateOPNDisp,						/* OPNfBXvC */
	CreateSubCtrl,						/* TuCPURg[ */
#if XM7_VER >= 2
	CreateALULine,						/* _Z/ */
#endif
	CreateKeyboard,						/* L[{[h */
	CreateMMR,							/* MMR */
#if XM7_VER >= 3 || (XM7_VER == 1 && defined(SFDC) && defined(XM7DASH))
	CreateDMAC,							/* DMAC */
#endif
	CreateIRQ,							/* IRQ */
#if XM7_VER == 1 && defined(BUBBLE)
	CreateBMC,							/* ouRg[ */
#endif	/* XM7_VER == 1 && defined(BUBBLE) */
#ifdef DBGLOG
	CreateLog,							/* O */
#endif
};
#endif

/*-[ ėpEBhE ]----------------------------------------------------*/

/*
 *	TuEBhE
 *	TCYύX
 */
static void FASTCALL WindowSizing(HWND hWnd, LPRECT rect)
{
	RECT wrect;
	POINT tpoint;
	POINT bpoint;
	int tframe;
	int bframe;

	/* t[E^Cgo[̃TCY擾 */
	bframe = GetSystemMetrics(SM_CYSIZEFRAME);
	tframe = GetSystemMetrics(SM_CYCAPTION) + bframe;

	/* VNCAg̈vZ */
	tpoint.x = 0;
	tpoint.y = rect->top + tframe;
	bpoint.x = 0;
	bpoint.y = rect->bottom - bframe;
	ScreenToClient(hWnd, &tpoint);
	ScreenToClient(hWnd, &bpoint);

	/* NCAg̈𕶎̔{ɍ킹 */
	tpoint.y = (tpoint.y / lCharHeight) * lCharHeight;
	bpoint.y = (bpoint.y / lCharHeight) * lCharHeight;

	/* XN[W֕ϊ */
	ClientToScreen(hWnd, &tpoint);
	ClientToScreen(hWnd, &bpoint);

	/* EBhETCY𒲐 */
	GetWindowRect(hWnd, &wrect);
	rect->left = wrect.left;
	rect->top = tpoint.y - tframe;
	rect->right = wrect.right;
	rect->bottom = bpoint.y + bframe;
}

/*
 *	TuEBhE
 *	eLXg`
 */
void FASTCALL DrawWindowText(HDC hDC, BYTE *ptr, int x, int y)
{
	BYTE *p;
	BYTE *q;
	int xx, yy;
	HFONT hBackup;

	/* tHgZNg */
	hBackup = SelectObject(hDC, hFont);

	/* r` */
	p = ptr;
	q = &p[x * y];
	for (yy=0; yy<y; yy++) {
		for (xx=0; xx<x; xx++) {
			if (ptr) {
				if (*p != *q) {
					TextOut(hDC, xx * lCharWidth, yy * lCharHeight,
						(LPCTSTR)p, 1);
					*q = *p;
				}
				p++;
				q++;
			}
		}
	}

	/* I */
	SelectObject(hDC, hBackup);
}

/*
 *	TuEBhE
 *	eLXg` (\Ή)
 */
void FASTCALL DrawWindowTextKanji(HDC hDC, BYTE *ptr, int x, int y)
{
	BYTE *p;
	BYTE *q;
	int xx, yy;
	HFONT hBackup;

	/* tHgZNg */
	hBackup = SelectObject(hDC, hFont);

	/* r` */
	for (yy=0; yy<y; yy++) {
		for (xx=0; xx<x; xx++) {
			p = &ptr[x * yy + xx];
			q = &p[x * y];
			if (ptr) {
				if (isKanji(*p)) {
					if (*(WORD *)p != *(WORD *)q) {
						TextOut(hDC, xx * lCharWidth, yy * lCharHeight,
							(LPCTSTR)p, 2);
						*(WORD *)q = *(WORD *)p;
					}
					xx++;
				}
				else {
					if (*p != *q) {
						TextOut(hDC, xx * lCharWidth, yy * lCharHeight,
							(LPCTSTR)p, 1);
						*q = *p;
					}
				}
			}
		}
	}

	/* I */
	SelectObject(hDC, hBackup);
}

/*
 *	TuEBhE
 *	eLXg`(]t)
 */
void FASTCALL DrawWindowText2(HDC hDC, BYTE *ptr, int x, int y)
{
	BYTE *p;
	BYTE *q;
	int xx, yy;
	HFONT hBackup;
	COLORREF tcolor, bcolor;
	char dat;

	/* tHgZNg */
	hBackup = SelectObject(hDC, hFont);

	/* r` */
	p = ptr;
	q = &p[x * y];
	for (yy=0; yy<y; yy++) {
		for (xx=0; xx<x; xx++) {
			if (ptr) {
				if (*p != *q) {
					if (*p & 0x80) {
						/* ]\ */
						dat = (char)(*p & 0x7f);
						bcolor = GetBkColor(hDC);
						tcolor = GetTextColor(hDC);
						SetTextColor(hDC, bcolor);
						SetBkColor(hDC, tcolor);
						TextOut(hDC, xx * lCharWidth, yy * lCharHeight, &dat, 1);
						SetTextColor(hDC, tcolor);
						SetBkColor(hDC, bcolor);
					}
					else {
						/* ʏ\ */
						TextOut(hDC, xx * lCharWidth, yy * lCharHeight,
							(LPCTSTR)p, 1);
					}
					*q = *p;
				}
				p++;
				q++;
			}
		}
	}

	/* I */
	SelectObject(hDC, hBackup);
}

/*
 *	TuEChE
 *	WM_DESTROY
 */
void FASTCALL DestroySubWindow(HWND hWnd, BYTE **pBuf, HMENU hmenu)
{
	int i;
#ifdef XM7DASH
	WINDOWPLACEMENT wndpl;
	RECT rect;
#endif

#ifdef XM7DASH
	GetWindowRect(hDrawWnd, &rect);
#endif

	/* CEChE֎ʒm */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			hSubWnd[i] = NULL;

#ifdef XM7DASH
			wndpl.length = sizeof(WINDOWPLACEMENT);
			GetWindowPlacement(hWnd, &wndpl);
			if (wndpl.showCmd != SW_SHOWMINIMIZED && bResumeSwnd) {
				/* |bvAbvTuEBhEҔ */
				GetWindowRect(hWnd, &stSwndRect[i]);
				if (!bPopupSwnd) {
					stSwndRect[i].left -= rect.left;
					stSwndRect[i].top -= rect.top;
				}
			}
			nSwndFlag[i] = 0;
#endif

			/* j[폜 */
			if (hmenu) {
				DestroyMenu(hmenu);
			}

			/* Drawobt@폜 */
			if (pBuf && *pBuf) {
				free(*pBuf);
				*pBuf = NULL;
			}
		}
	}

	/* h[EChEĕ` */
	InvalidateRect(hDrawWnd, NULL, FALSE);
}

#ifdef XM7DASH
/*
 *	TuEBhE
 *	ʒuZo
 */
void FASTCALL PositioningSubWindow(HWND hParent, LPRECT rect, int index)
{
	RECT wrect;

	/* TuEBhEʒuZo */
	if (bResumeSwnd && (nSwndFlag[index] >= 0)) {
		*rect = stSwndRect[index];
		while (rect->left > GetSystemMetrics(SM_CXSCREEN) - 80) {
			rect->left -= 40;
		}
		while (rect->top > GetSystemMetrics(SM_CYSCREEN) - 20) {
			rect->top -= 40;
		}
	}
	else {
		rect->left = lCharWidth * index;
		rect->top = lCharHeight * index;
		rect->right = 0;
		rect->bottom = 0;
		if (rect->top >= 380) {
			rect->top -= 380;
		}
		if (bPopupSwnd) {
			GetWindowRect(hParent, (LPRECT)&wrect);
			rect->left += wrect.left;
			rect->top += wrect.top;
		}
	}
	if (bResumeSwnd) {
		nSwndFlag[index] = 1;
	}
}

/*
 *	TuEBhE
 *	
 */
void FASTCALL RestoreSubWindow(void)
{
	int i;
	WORD wAddr;

	if (!bResumeSwnd) {
		return;
	}

	/* Misc */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i]) {
			continue;
		}
		if (nSwndFlag[i] > 0) {
			/* EChE쐬 */
			switch (i) {
			case SWND_DISASM_MAIN:		/* tAZu C */
			case SWND_DISASM_SUB:		/* tAZu Tu */
#ifdef JSUB
			case SWND_DISASM_JSUB:		/* tAZu {Tu */
#endif
				wAddr = wDisAsm[i - SWND_DISASM_MAIN];
				break;
			case SWND_MEMORY_MAIN:		/* _v C */
			case SWND_MEMORY_SUB:		/* _v Tu */
#ifdef JSUB
			case SWND_MEMORY_JSUB:		/* _v {Tu */
#endif
				wAddr = wMemory[i - SWND_MEMORY_MAIN];
				break;
			}
			hSubWnd[i] = (CreateSwndFunc[i])(hDrawWnd, i);
			switch (i) {
			case SWND_DISASM_MAIN:		/* tAZu C */
			case SWND_DISASM_SUB:		/* tAZu Tu */
#ifdef JSUB
			case SWND_DISASM_JSUB:		/* tAZu {Tu */
#endif
				AddrDisAsm(i - SWND_DISASM_MAIN, wAddr);
				break;
			case SWND_MEMORY_MAIN:		/* _v C */
			case SWND_MEMORY_SUB:		/* _v Tu */
#ifdef JSUB
			case SWND_MEMORY_JSUB:		/* _v {Tu */
#endif
				AddrMemory(i - SWND_MEMORY_MAIN, wAddr);
				break;
			}
		}
	}
	if (hMainWnd) {
		SetForegroundWindow(hMainWnd);
	}
}

/*
 *	TuEChE
 *	WM_SIZE
 */
void FASTCALL MoveSubWindow(HWND hWnd)
{
	int i;
	RECT rect;

	/* |bvAbvEۑ */
	GetWindowRect(hDrawWnd, &rect);
	if (bResumeSwnd &&
		(!(GetWindowLong(hWnd, GWL_STYLE) & (WS_MAXIMIZE | WS_MINIMIZE)))) {

		/* CEChE֎ʒm */
		for (i=0; i<SWND_MAXNUM; i++) {
			if (hSubWnd[i] == hWnd) {
				/* |bvAbvTuEBhEҔ */
				GetWindowRect(hWnd, &stSwndRect[i]);
				if (!bPopupSwnd) {
					stSwndRect[i].left -= rect.left;
					stSwndRect[i].top -= rect.top;
				}
			}
		}
	}
}
#endif

/*-[ EBhE[N ]------------------------------------------------*/

/*
 *	TuEBhE
 *	[N
 */
void FASTCALL InitSubWndWork(void)
{
	int i;

	for (i=0; i<MAXCPU; i++) {
		nHeightDisAsm[i] = 8;			/* tAZu EBhEcTCY */
		nHeightMemory[i] = 8;			/* _v EBhEcTCY */
		bAsciiDump[i] = FALSE;			/* _v ASCII\ */
		bKanjiDump[i] = FALSE;			/* _v \ */
		wMemSrchAddrSave[i] = 0;		/*  JnAhX */
	}

#ifdef XM7DASH
	nAddrSegDisAsm = 0;					/* tAZuZOg */
	nAddrModeDisAsm = 0;				/* tAZuAhXtO */
	nAddrSegDump = 0;					/* _vZOg */
	nAddrModeDump = 0;					/* _vAhXtO */

	/* TuEBhE */
	for (i=0; i<SWND_MAXNUM; i++) {
		nSwndFlag[i] = -1;
		memset(&stSwndRect[i], 0, sizeof(RECT));
	}
#endif
}

/*-[ AhXqXg ]------------------------------------------------------*/

/*
 *	AhXqXg
 *	R{{bNXւ̑}
 */
static void FASTCALL InsertHistory(HWND hWnd)
{
	int i;
	char string[128];

	/* qXg} */
	(void)ComboBox_ResetContent(hWnd);
	for (i=AddrNum; i>0; i--) {
		_snprintf(string, 128, "%04X", AddrHistory[i - 1]);
		(void)ComboBox_AddString(hWnd, string);
	}
}

/*
 *	AhXqXg
 *	ǉ
 */
static void FASTCALL AddAddrHistory(WORD addr)
{
	int i;

	/* do^`FbN */
	for (i=0; i<AddrNum; i++) {
		if (AddrHistory[i] == addr) {
			return;
		}
	}

	/* qXgVtgA}AJEgAbv */
	for (i=14; i>=0; i--) {
		AddrHistory[i + 1] = AddrHistory[i];
	}
	AddrHistory[0] = addr;
	if (AddrNum < 16) {
		AddrNum++;
	}
}

/*-[ AhX̓_CAO ]------------------------------------------------*/

/*
 *	AhX̓_CAO
 *	_CAO
 */
static BOOL FASTCALL AddrDlgInit(HWND hDlg)
{
	HWND hWnd;
	RECT prect;
	RECT drect;
	char string[128];

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_ADDRCOMBO);
	ASSERT(hWnd);
	InsertHistory(hWnd);

	/* AhXݒ */
	_snprintf(string, 128, "%04X", AddrBuf);
	ComboBox_SetText(hWnd, string);

	return TRUE;
}

/*
 *	AhX̓_CAO
 *	_CAOOK
 */
static void FASTCALL AddrDlgOK(HWND hDlg)
{
	HWND hWnd;
	char string[128];

	ASSERT(hDlg);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_ADDRCOMBO);
	ASSERT(hWnd);

	/* ݂̒l擾 */
	ComboBox_GetText(hWnd, string, sizeof(string) - 1);
	AddrBuf = (WORD)strtol(string, NULL, 16);

	/* qXgǉ */
	AddAddrHistory(AddrBuf);
}

/*
 *	AhX̓_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK AddrDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return AddrDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						AddrDlgOK(hDlg);
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	AhX
 */
static BOOL FASTCALL AddrDlg(HWND hWnd, WORD *pAddr)
{
	int ret;

	ASSERT(hWnd);
	ASSERT(pAddr);

	/* AhXZbg */
	AddrBuf = *pAddr;

	/* [__CAOs */
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_ADDRDLG), hWnd, AddrDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}

	/* AhXZbgAA */
	*pAddr = AddrBuf;
	return TRUE;
}

/*-[ u[N|Cgݒ_CAO ]----------------------------------------*/

/*
 *	u[N|Cgݒ_CAO
 *	_CAO
 */
static BOOL FASTCALL BreakPointDlgInit(HWND hDlg)
{
	HWND hWnd;
	RECT prect;
	RECT drect;
	char string[128];

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_BREAKP_ADDRCOMBO);
	ASSERT(hWnd);
	InsertHistory(hWnd);

	/* AhXݒ */
	_snprintf(string, 128, "%04X", AddrBuf);
	ComboBox_SetText(hWnd, string);

	/* ΏCPUݒ */
	switch (nBreakCPU) {
		case MAINCPU :	CheckDlgButton(hDlg, IDC_BREAKP_CPU_MAIN, BST_CHECKED);
						break;
		case SUBCPU :	CheckDlgButton(hDlg, IDC_BREAKP_CPU_SUB, BST_CHECKED);
						break;
#ifdef JSUB
		case JSUBCPU :	CheckDlgButton(hDlg, IDC_BREAKP_CPU_JSUB, BST_CHECKED);
						break;
#endif
	}

	return TRUE;
}

/*
 *	u[N|Cgݒ_CAO
 *	_CAOOK
 */
static void FASTCALL BreakPointDlgOK(HWND hDlg)
{
	HWND hWnd;
	char string[128];

	ASSERT(hDlg);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_BREAKP_ADDRCOMBO);
	ASSERT(hWnd);

	/* ݂̒l擾 */
	ComboBox_GetText(hWnd, string, sizeof(string) - 1);
	AddrBuf = (WORD)strtol(string, NULL, 16);

	/* qXgǉ */
	AddAddrHistory(AddrBuf);

	/* ΏCPU擾 */
	if (IsDlgButtonChecked(hDlg, IDC_BREAKP_CPU_MAIN) == BST_CHECKED) {
		nBreakCPU = MAINCPU;
	}
#ifdef JSUB
	else if (IsDlgButtonChecked(hDlg, IDC_BREAKP_CPU_JSUB) == BST_CHECKED) {
		nBreakCPU = JSUBCPU;
	}
#endif
	else {
		nBreakCPU = SUBCPU;
	}
}

/*
 *	u[N|Cgݒ_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK BreakPointDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return BreakPointDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						BreakPointDlgOK(hDlg);
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	u[N|Cgݒ
 */
static BOOL FASTCALL BreakPointDlg(HWND hWnd, int num)
{
	int ret;

	ASSERT(hWnd);

	/* AhXZbg */
	if (breakp[num].flag != BREAKP_NOTUSE) {
		AddrBuf = breakp[num].addr;
		nBreakCPU = (BYTE)breakp[num].cpu;
	}
	else {
		AddrBuf = 0;
		nBreakCPU = MAINCPU;
	}

	/* [__CAOs */
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_BREAKPDLG), hWnd, BreakPointDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}

	/* AhXZbgAA */
	schedule_setbreak2(num, nBreakCPU, AddrBuf);
	return TRUE;
}

/*-[ u[N|Cg ]------------------------------------------------------*/

/*
 *	u[N|CgEChE
 *	ZbgAbv
 */
static void FASTCALL SetupBreakPoint(BYTE *p, int x, int y)
{
	int i;
	char string[128];
	char tmp[128];

	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);

	/* u[N|Cg[v */
	for (i=0; i<BREAKP_MAXNUM; i++) {
		/* 쐬 */
		string[0] = '\0';
		if (breakp[i].flag == BREAKP_NOTUSE) {
			_snprintf(string, 128, "%2d ------------------", i + 1);
		}
		else {
			switch (breakp[i].cpu) {
				case MAINCPU :	strncpy(tmp, "Main", 128);
								break;
				case SUBCPU :	strncpy(tmp, "Sub ", 128);
								break;
#ifdef JSUB
				case JSUBCPU :	strncpy(tmp, "Jsub", 128);
								break;
#endif
			}
			_snprintf(string, 128, "%2d %s %04X ", i + 1, tmp, breakp[i].addr);
			switch (breakp[i].flag) {
				case BREAKP_ENABLED:
					strncat(string, " Enabled", 128 - strlen(string) - 1);
					break;
				case BREAKP_DISABLED:
					strncat(string, "Disabled", 128 - strlen(string) - 1);
					break;
			}
		}

		/* Rs[ */
		memcpy(&p[x * i], string, strlen(string));
	}
}

/*
 *	u[N|CgEChE
 *	`
 */
static void FASTCALL DrawBreakPoint(HWND hWnd, HDC hDC)
{
	RECT rect;
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	if (!pBreakPoint) {
		return;
	}
	SetupBreakPoint(pBreakPoint, x, y);

	/* ` */
	DrawWindowText(hDC, pBreakPoint, x, y);
}

/*
 *	u[N|CgEChE
 *	tbV
 */
void FASTCALL RefreshBreakPoint(void)
{
	HWND hWnd;
	HDC hDC;

	/* ɌĂ΂̂ŁA݃`FbN邱 */
	if (hSubWnd[SWND_BREAKPOINT] == NULL) {
		return;
	}

	/* ` */
	hWnd = hSubWnd[SWND_BREAKPOINT];
	hDC = GetDC(hWnd);
	DrawBreakPoint(hWnd, hDC);
	ReleaseDC(hWnd, hDC);
}

/*
 *	u[N|CgEChE
 *	ĕ`
 */
static void FASTCALL PaintBreakPoint(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* |C^ݒ(݂ȂΉȂ) */
	p = pBreakPoint;
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawBreakPoint(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	u[N|Cg
 *	R}h
 */
static void FASTCALL CmdBreakPoint(HWND hWnd, WORD wID)
{
	int num;
	POINT point;

	ASSERT(hWnd);

	/* CfbNXԍ擾 */
	point = PosBreakPoint;
	num = point.y / lCharHeight;
	if ((num < 0) || (num >= BREAKP_MAXNUM)) {
		return;
	}

	/* R}h */
	switch (wID) {
		/* Wv */
		case IDM_BREAKP_JUMP:
			if (breakp[num].flag != BREAKP_NOTUSE) {
				AddrDisAsm((BYTE)breakp[num].cpu, breakp[num].addr);
			}
			break;

		/* ݒ */
		case IDM_BREAKP_SET:
			BreakPointDlg(hWnd, num);
			break;

		/* Cl[u */
		case IDM_BREAKP_ENABLE:
			if (breakp[num].flag == BREAKP_DISABLED) {
				breakp[num].flag = BREAKP_ENABLED;
				InvalidateRect(hWnd, NULL, FALSE);
				RefreshDisAsm();
			}
			break;

		/* fBZ[u */
		case IDM_BREAKP_DISABLE:
			if (breakp[num].flag == BREAKP_ENABLED) {
				breakp[num].flag = BREAKP_DISABLED;
				InvalidateRect(hWnd, NULL, FALSE);
				RefreshDisAsm();
			}
			break;

		/* NA */
		case IDM_BREAKP_CLEAR:
			if (breakp[num].flag != BREAKP_NOTUSE) {
				schedule_setbreak(breakp[num].cpu, breakp[num].addr);
			}
			InvalidateRect(hWnd, NULL, FALSE);
			RefreshDisAsm();
			break;

		/* SăNA */
		case IDM_BREAKP_ALL:
			for (num=0; num<BREAKP_MAXNUM; num++) {
				if (breakp[num].flag != BREAKP_NOTUSE) {
					schedule_setbreak(breakp[num].cpu, breakp[num].addr);
				}
			}
			InvalidateRect(hWnd, NULL, FALSE);
			RefreshDisAsm();
			break;
	}
}

/*
 *	u[N|CgEChE
 *	EChEvV[W
 */
static LRESULT CALLBACK BreakPointProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	POINT point;
	int i;
	HMENU hMenu;

	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintBreakPoint(hWnd);
			UnlockVM();
			return 0;

		/* NbN */
		case WM_LBUTTONDOWN:
		case WM_LBUTTONDBLCLK:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* J[\ʒuA */
			i = HIWORD(lParam) / lCharHeight;
			if ((i >= 0) && (i < BREAKP_MAXNUM)) {
				if (breakp[i].flag != BREAKP_NOTUSE) {
					AddrDisAsm((BYTE)breakp[i].cpu, breakp[i].addr);
				}
			}
			return 0;

		/* ReLXgj[ */
		case WM_RBUTTONDOWN:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			PosBreakPoint = point;
			hMenu = GetSubMenu(hBreakPoint, 0);
			ClientToScreen(hWnd, &point);
			TrackPopupMenu(hMenu, 0, point.x, point.y, 0, hWnd, NULL);
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* j[폜 */
			DestroyMenu(hBreakPoint);

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pBreakPoint, NULL);

			UnlockVM();
			break;

		/* R}h */
		case WM_COMMAND:
			CmdBreakPoint(hWnd, LOWORD(wParam));
			break;

#ifdef XM7DASH
		/* EBhEړ */
		case WM_MOVE:
			/* ŏ̃TuEBhEҔ */
			MoveSubWindow(hWnd);
			break;
#endif
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	u[N|CgEChE
 *	EChE쐬
 */
HWND FASTCALL CreateBreakPoint(HWND hParent, int index)
{
	WNDCLASSEX wcex;
	char szClassName[] = "XM7_BreakPoint";
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
#ifdef XM7DASH
	DWORD dwExStyle;
#endif

	ASSERT(hParent);

	/* EChE`vZ */
#ifdef XM7DASH
	PositioningSubWindow(hParent, &rect, index);
#else
	rect.left = lCharWidth * index;
	rect.top = lCharHeight * index;
	if (rect.top >= 380) {
		rect.top -= 380;
	}
#endif
	rect.right = lCharWidth * 21;
	rect.bottom = lCharHeight * BREAKP_MAXNUM;

	/* EChE^CgAobt@m */
	LoadString(hResInstance, IDS_SWND_BREAKPOINT,
				szWndName, sizeof(szWndName));
	pBreakPoint = malloc(2 * (rect.right / lCharWidth) *
								(rect.bottom / lCharHeight));

	/* j[[h */
	hBreakPoint = LoadMenu(hResInstance, MAKEINTRESOURCE(IDR_BREAKPOINTMENU));

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW;
	wcex.lpfnWndProc = BreakPointProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
#ifdef XM7DASH
	if (bPopupSwnd) {
		dwExStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_BORDER;
	}
	else {
		dwExStyle = WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_CLIPSIBLINGS;
	}
	if (bSwndVisible) {
		dwExStyle |= WS_VISIBLE;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwExStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#else
	hWnd = CreateWindow(szClassName,
						szWndName,
						WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
						| WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#endif

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);
	}

	/* ʂA */
	return hWnd;
}

/*-[ XPW[EChE ]------------------------------------------------*/

static char *pszSchedulerTitle[] = {
	"Main Timer",
	"Sub  Timer",
	"OPN Timer A",
	"OPN Timer B",
	"Key Repeat",
	"BEEP",
	"V-SYNC",
	"V/H-BLANK",
#if XM7_VER >= 2
	"Line LSI",
	"RTC Clock",	/* V3.2L02` */
#else
	"Text Blink",
	"(Reserved)",
#endif
	"WHG Timer A",
	"WHG Timer B",
	"THG Timer A",
	"THG Timer B",
#if XM7_VER == 1 && defined(XM7DASH) && defined(SFDC)
	"MFDC(M.Sec)",
	"MFDC(Lost)",
	"MFDD(Seek)",
#else
	"FDC (M.Sec)",
	"FDC (Lost)",
	"FDD (Seek)",
#endif	/* XM7_VER == 1 && defined(XM7DASH) && defined(SFDC) */
	"Tape Sound",
#ifdef MOUSE
	"Mouse Lost",
#else
	"(Reserved)",
#endif
#if XM7_VER >= 3 || (XM7_VER == 1 && defined(SFDC) && defined(XM7DASH))
	"DMA Start",
#else
	"(Reserved)",
#endif
#if XM7_VER >= 2
	"KeyEnc ACK",
#elif XM7_VER == 1 && defined(XM7DASH) && defined(SFDC)
	"SFDC NMI",
#else
	"(Reserved)",
#endif
#ifdef RSC
	"RS TxTiming",
	"RS RxTiming",
#else
	"(Reserved)",
	"(Reserved)",
#endif
#if XM7_VER == 1 && defined(XM7DASH)
#ifdef SFDC
	"SFDC(M.Sec)",
	"SFDC(Lost)",
	"SFDD(Seek)",
#else
	"(Reserved)",
	"(Reserved)",
	"(Reserved)",
#endif
#endif	/* XM7_VER == 1 && defined(XM7DASH) */
	"(Reserved)",
};

/*
 *	XPW[EChE
 *	ZbgAbv
 */
static void FASTCALL SetupScheduler(BYTE *p, int x, int y)
{
	int i;
	int j;
	char string[128];
	DWORD dwFrame;
	DWORD dwTime;

	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* VMbN */
	LockVM();

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);

	/* s */
	_snprintf(string, 128, "Execute Time %12d ms", dwExecTotal / 1000);
	memcpy(p, string, strlen(string));

	/* t[g[^ */
	dwFrame = dwDrawTotal - dwSchedulerFrame[0];
	dwTime = timeGetTime() - dwSchedulerTime[0];
	if (dwTime > 0) {
		dwFrame = dwFrame * 100000 / dwTime;
	}
	else {
		dwSchedulerTime[0] = timeGetTime();
		dwFrame = 0;
	}
	_snprintf(string, 128, "Frame Rate (Total) %3d.%02d fps", dwFrame / 100, dwFrame % 100);
	memcpy(&p[x * 1], string, strlen(string));

	/* t[2sec */
	dwTime = timeGetTime() - dwSchedulerTime[1];
	if (dwTime > 0) {
		dwFrame = dwDrawTotal - dwSchedulerFrame[1];
		dwFrame = dwFrame * 100000 / dwTime;
	}
	else {
		dwFrame = 0;
	}
	if ((dwTime < 0) || (dwTime > 2000)) {
		dwSchedulerTime[1] = timeGetTime();
		dwSchedulerFrame[1] = dwDrawTotal;
	}
	_snprintf(string, 128, "Frame Rate (Latest)%3d.%02d fps", dwFrame / 100, dwFrame % 100);
	memcpy(&p[x * 2], string, strlen(string));

	/* [v */
	j = 4;
	for (i=0; i<EVENT_MAXNUM; i++) {
		/* ^Cg */
		memcpy(&p[x * j], pszSchedulerTitle[i], strlen(pszSchedulerTitle[i]));

		/* JgA[h */
		if (event[i].flag != EVENT_NOTUSE) {
			_snprintf(string, 128, "%4d.%03dms",   event[i].current / 1000,
											event[i].current % 1000);
			memcpy(&p[x * j + 12], string, strlen(string));

			_snprintf(string, 128, "(%4d.%03dms)", event[i].reload / 1000,
											event[i].reload % 1000);
			memcpy(&p[x * j + 23], string, strlen(string));

			/* Xe[^X */
			switch (event[i].flag) {
				case EVENT_ENABLED:
					strncpy(string, " Enabled", 128);
					break;

				case EVENT_DISABLED:
					strncpy(string, "Disabled", 128);
					break;

				default:
					ASSERT(FALSE);
					break;
			}
		}
		else {
			strncpy(string, "", 128);
		}

		memcpy(&p[x * j + 36], string, strlen(string));
		j++;
	}

	/* I[o[TCN */
	strncpy(string,  "|  Over Cycle", 128);
	memcpy(&p[x * 0 + 30], string, strlen(string));
	_snprintf(string, 128, "| Main %7d", main_overcycles);
	memcpy(&p[x * 1 + 30], string, strlen(string));
	_snprintf(string, 128, "| Sub  %7d", sub_overcycles);
	memcpy(&p[x * 2 + 30], string, strlen(string));

#ifdef DEBUG
	if (dwFrame == 0) {
		dwTime = 100000;
	}
	else {
		dwTime = 100000 / dwFrame;
	}

	/* (ł΂΁`p) */
#ifdef XM7DASH
	_snprintf(string, sizeof(string), "Exec Time (CPU)  %4d.%03d ms (%3d%%)", dwCpuExecTime / 1000, dwCpuExecTime % 1000, dwCpuExecTime / dwTime);
#else
	_snprintf(string, sizeof(string), "Exec Time (CPU)  %4d.%03d ms (%3d\%)", dwCpuExecTime / 1000, dwCpuExecTime % 1000, dwCpuExecTime / dwTime);
#endif
	memcpy(&p[x * (j + 1)], string, strlen(string));

#ifdef XM7DASH
	_snprintf(string, sizeof(string), "Exec Time (DRAW) %4d.%03d ms (%3d%%)", dwDrawExecTime / 1000, dwDrawExecTime % 1000, dwDrawExecTime / dwTime);
#else
	_snprintf(string, sizeof(string), "Exec Time (DRAW) %4d.%03d ms (%3d\%)", dwDrawExecTime / 1000, dwDrawExecTime % 1000, dwDrawExecTime / dwTime);
#endif
	memcpy(&p[x * (j + 2)], string, strlen(string));

#ifdef XM7DASH
	_snprintf(string, sizeof(string), "Exec Time (POLL) %4d.%03d ms (%3d%%)", dwPollExecTime / 1000, dwPollExecTime % 1000, dwPollExecTime / dwTime);
#else
	_snprintf(string, sizeof(string), "Exec Time (POLL) %4d.%03d ms (%3d\%)", dwPollExecTime / 1000, dwPollExecTime % 1000, dwPollExecTime / dwTime);
#endif
	memcpy(&p[x * (j + 3)], string, strlen(string));

	i = (dwTime * 100) - (dwCpuExecTime + dwDrawExecTime + dwPollExecTime);
	if (i < 0) {
		i = 0;
	}
#ifdef XM7DASH
	_snprintf(string, sizeof(string), "Idle Time        %4d.%03d ms (%3d%%)", i / 1000, i % 1000, i / dwTime);
#else
	_snprintf(string, sizeof(string), "Idle Time        %4d.%03d ms (%3d\%)", i / 1000, i % 1000, i / dwTime);
#endif
	memcpy(&p[x * (j + 4)], string, strlen(string));
#endif

	/* VMAbN */
	UnlockVM();
}

/*
 *	XPW[EChE
 *	`
 */
static void FASTCALL DrawScheduler(HWND hWnd, HDC hDC)
{
	RECT rect;
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	if (!pScheduler) {
		return;
	}
	SetupScheduler(pScheduler, x, y);

	/* ` */
	DrawWindowText(hDC, pScheduler, x, y);
}

/*
 *	XPW[EChE
 *	tbV
 */
void FASTCALL RefreshScheduler(void)
{
	HWND hWnd;
	HDC hDC;

	/* ɌĂ΂̂ŁA݃`FbN邱 */
	if (hSubWnd[SWND_SCHEDULER] == NULL) {
		return;
	}

	/* ` */
	hWnd = hSubWnd[SWND_SCHEDULER];
	hDC = GetDC(hWnd);
	DrawScheduler(hWnd, hDC);
	ReleaseDC(hWnd, hDC);
}

/*
 *	XPW[EChE
 *	ĕ`
 */
static void FASTCALL PaintScheduler(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* |C^ݒ(݂ȂΉȂ) */
	p = pScheduler;
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawScheduler(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	XPW[EChE
 *	EChEvV[W
 */
static LRESULT CALLBACK SchedulerProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintScheduler(hWnd);
			UnlockVM();
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pScheduler, NULL);

			UnlockVM();
			break;

#ifdef XM7DASH
		/* EBhEړ */
		case WM_MOVE:
			/* ŏ̃TuEBhEҔ */
			MoveSubWindow(hWnd);
			break;
#endif
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	XPW[EChE
 *	EChE쐬
 */
HWND FASTCALL CreateScheduler(HWND hParent, int index)
{
	WNDCLASSEX wcex;
	char szClassName[] = "XM7_Scheduler";
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
#ifdef XM7DASH
	DWORD dwExStyle;
#endif

	ASSERT(hParent);

	/* EChE`vZ */
#ifdef XM7DASH
	PositioningSubWindow(hParent, &rect, index);
#else
	rect.left = lCharWidth * index;
	rect.top = lCharHeight * index;
	if (rect.top >= 380) {
		rect.top -= 380;
	}
#endif
	rect.right = lCharWidth * 44;
#ifdef DEBUG
	rect.bottom = lCharHeight * (EVENT_MAXNUM + 9);
#else
	rect.bottom = lCharHeight * (EVENT_MAXNUM + 4);
#endif

	/* EChE^CgAobt@m */
	LoadString(hResInstance, IDS_SWND_SCHEDULER,
				szWndName, sizeof(szWndName));
	pScheduler = malloc(2 * (rect.right / lCharWidth) *
								(rect.bottom / lCharHeight));

	/* ԁAt[ */
	dwSchedulerTime[0] = timeGetTime();
	dwSchedulerTime[1] = dwSchedulerTime[0];
	dwSchedulerFrame[0] = dwDrawTotal;
	dwSchedulerFrame[1] = dwSchedulerFrame[0];

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW;
	wcex.lpfnWndProc = SchedulerProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
#ifdef XM7DASH
	if (bPopupSwnd) {
		dwExStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_BORDER;
	}
	else {
		dwExStyle = WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_CLIPSIBLINGS;
	}
	if (bSwndVisible) {
		dwExStyle |= WS_VISIBLE;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwExStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#else
	hWnd = CreateWindow(szClassName,
						szWndName,
						WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
						| WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#endif

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);
	}

	/* ʂA */
	return hWnd;
}

/*-[ WX^eύX_CAO ]--------------------------------------------*/

/*
 *	WX^eύX_CAO
 *	_CAO
 */
static BOOL FASTCALL CPURegDlgInit(HWND hDlg)
{
	static const char *RegName[10] = {
		"CC", "A", "B", "DP", "D", "X", "Y", "U", "S", "PC"
	};

	HWND hWnd;
	RECT prect;
	RECT drect;
	cpu6809_t *pReg;
	char tmp[16];
	char tmp2[128];
	char string[128];
	WORD dat;
	UINT id;

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* ݒ */
	switch (nRegDlgCPU) {
		case MAINCPU :	id = IDS_SWND_CPU_MAIN;
						pReg = &maincpu;
						break;
		case SUBCPU :	id = IDS_SWND_CPU_SUB;
						pReg = &subcpu;
						break;
#ifdef JSUB
		case JSUBCPU :	id = IDS_SWND_CPU_JSUB;
						pReg = &jsubcpu;
						break;
#endif
	}
	LoadString(hResInstance, id, tmp, sizeof(tmp));

	/* AhXݒ */
	hWnd = GetDlgItem(hDlg, IDC_REGLABEL);
	ASSERT(hWnd);
	if (LoadString(hResInstance, IDS_SWND_REG_MESSAGE,
					tmp2, sizeof(tmp2)) == 0) {
		_snprintf(string, 128, "%sWX^ (%s)", RegName[nRegDlgNo], tmp);
	}
	else {
		_snprintf(string, 128, tmp2, RegName[nRegDlgNo], tmp);
	}
	SetWindowText(hWnd, string);

	/* f[^ݒ */
	hWnd = GetDlgItem(hDlg, IDC_REGEDIT);
	ASSERT(hWnd);
	switch (nRegDlgNo) {
		case 0:	/* CC */
				dat = pReg -> cc;
				break;
		case 1:	/* A */
				dat = pReg -> acc.h.a;
				break;
		case 2:	/* B */
				dat = pReg -> acc.h.b;
				break;
		case 3:	/* DP */
				dat = pReg -> dp;
				break;
		case 4:	/* D */
				dat = pReg -> acc.d;
				break;
		case 5:	/* X */
				dat = pReg -> x;
				break;
		case 6:	/* Y */
				dat = pReg -> y;
				break;
		case 7:	/* U */
				dat = pReg -> u;
				break;
		case 8:	/* S */
				dat = pReg -> s;
				break;
		case 9:	/* PC */
				dat = pReg -> pc;
				break;
	}
	if (nRegDlgNo < 4) {
		/* 8rbgWX^ */
		_snprintf(string, 128, "%02X", dat);
	}
	else {
		/* 16rbgWX^ */
		_snprintf(string, 128, "%04X", dat);
	}
	SetWindowText(hWnd, string);

	return TRUE;
}

/*
 *	WX^eύX_CAO
 *	_CAOOK
 */
static void FASTCALL CPURegDlgOK(HWND hDlg)
{
	HWND hWnd;
	cpu6809_t *pReg;
	char string[128];
	WORD dat;

	ASSERT(hDlg);
	LockVM();

	/* ݒ */
	switch (nRegDlgCPU) {
		case MAINCPU :	pReg = &maincpu;
						break;
		case SUBCPU :	pReg = &subcpu;
						break;
#ifdef JSUB
		case JSUBCPU :	pReg = &jsubcpu;
						break;
#endif
	}

	/* ݂̒l擾 */
	hWnd = GetDlgItem(hDlg, IDC_REGEDIT);
	ASSERT(hWnd);
	GetWindowText(hWnd, string, sizeof(string) - 1);
	dat = (WORD)strtol(string, NULL, 16);

	/* f[^ݒ */
	switch (nRegDlgNo) {
		case 0:	/* CC */
				pReg -> cc = (BYTE)dat;
				break;
		case 1:	/* A */
				pReg -> acc.h.a = (BYTE)dat;
				break;
		case 2:	/* B */
				pReg -> acc.h.b = (BYTE)dat;
				break;
		case 3:	/* DP */
				pReg -> dp = (BYTE)dat;
				break;
		case 4:	/* D */
				pReg -> acc.d = dat;
				break;
		case 5:	/* X */
				pReg -> x = dat;
				break;
		case 6:	/* Y */
				pReg -> y = dat;
				break;
		case 7:	/* U */
				pReg -> u = dat;
				break;
		case 8:	/* S */
				pReg -> s = dat;
				break;
		case 9:	/* PC */
				pReg -> pc = dat;
				break;
	}

	UnlockVM();
}

/*
 *	WX^eύX_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK CPURegDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return CPURegDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						CPURegDlgOK(hDlg);
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	WX^eύX
 */
static BOOL FASTCALL CPURegDlg(HWND hWnd, BYTE nCPU, int x, int y)
{
	int ret;

	ASSERT(hWnd);

	/* p[^ۑEݒ */
	nRegDlgCPU = nCPU;

	/* WX^ԍZbg */
	nRegDlgNo = (BYTE)(((x / 10) * 5) + y);

	/* IRWX^EW`FbN */
	if ((nRegDlgNo == 4) || ((x % 10) >= 7)) {
		return FALSE;
	}

	/* [__CAOs */
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_REGDLG), hWnd, CPURegDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}
	return TRUE;
}

/*-[ CPUWX^EChE ]-------------------------------------------------*/

/*
 *	CPUWX^EChE
 *	ZbgAbv
 */
static void FASTCALL SetupCPURegister(BYTE nCPU, BYTE *p, int x, int y)
{
	char buf[128];
	cpu6809_t *pReg;

	ASSERT(nCPU < MAXCPU);
	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);

	/* WX^obt@𓾂 */
	switch (nCPU) {
		case MAINCPU :	pReg = &maincpu;
						break;
		case SUBCPU :	pReg = &subcpu;
						break;
#ifdef JSUB
		case JSUBCPU :	pReg = &jsubcpu;
						break;
#endif
	}

	/* Zbg */
	_snprintf(buf, 128, "CC   %02X   X  %04X", pReg->cc, pReg->x);
	memcpy(&p[0 * x + 0], buf, strlen(buf));
	_snprintf(buf, 128, "A    %02X   Y  %04X", pReg->acc.h.a, pReg->y);
	memcpy(&p[1 * x + 0], buf, strlen(buf));
	_snprintf(buf, 128, "B    %02X   U  %04X", pReg->acc.h.b, pReg->u);
	memcpy(&p[2 * x + 0], buf, strlen(buf));
	_snprintf(buf, 128, "DP   %02X   S  %04X", pReg->dp, pReg->s);
	memcpy(&p[3 * x + 0], buf, strlen(buf));
	_snprintf(buf, 128, "IR %04X   PC %04X", pReg->intr, pReg->pc);
	memcpy(&p[4 * x + 0], buf, strlen(buf));
}

/*
 *	CPUWX^EChE
 *	`
 */
static void FASTCALL DrawCPURegister(HWND hWnd, HDC hDC)
{
	int i;
	BYTE nCPU;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			nCPU = (BYTE)((i - SWND_CPUREG_MAIN) % MAXCPU);
			p = pCPURegister[nCPU];
			break;
		}
	}
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	SetupCPURegister(nCPU, p, x, y);

	/* ` */
	DrawWindowText(hDC, p, x, y);
}

/*
 *	CPUWX^EChE
 *	tbV
 */
void FASTCALL RefreshCPURegister(void)
{
	HWND hWnd;
	HDC hDC;

	/* CCPU */
	if (hSubWnd[SWND_CPUREG_MAIN]) {
		hWnd = hSubWnd[SWND_CPUREG_MAIN];
		hDC = GetDC(hWnd);
		DrawCPURegister(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

	/* TuCPU */
	if (hSubWnd[SWND_CPUREG_SUB]) {
		hWnd = hSubWnd[SWND_CPUREG_SUB];
		hDC = GetDC(hWnd);
		DrawCPURegister(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

#ifdef JSUB
	/* {TuCPU */
	if (hSubWnd[SWND_CPUREG_JSUB]) {
		hWnd = hSubWnd[SWND_CPUREG_JSUB];
		hDC = GetDC(hWnd);
		DrawCPURegister(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}
#endif
}

/*
 *	CPUWX^EChE
 *	ĕ`
 */
static void FASTCALL PaintCPURegister(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	int i;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			p = pCPURegister[((i - SWND_CPUREG_MAIN) % MAXCPU)];
			break;
		}
	}

	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawCPURegister(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	CPUWX^EChE
 *	EChEvV[W
 */
static LRESULT CALLBACK CPURegisterProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	HMENU hMenu;
	POINT point;
	BYTE nCPU;

	if (hSubWnd[SWND_CPUREG_MAIN] == hWnd) {
		nCPU = MAINCPU;
	}
#ifdef JSUB
	else if (hSubWnd[SWND_CPUREG_JSUB] == hWnd) {
		nCPU = JSUBCPU;
	}
#endif
	else {
		nCPU = SUBCPU;
	}

	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintCPURegister(hWnd);
			UnlockVM();
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pCPURegister[nCPU], hCPURegister[nCPU]);

			UnlockVM();
			break;

		/* WX^eύX */
		case WM_LBUTTONDBLCLK:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* J[\ʒuA */
			point.x = LOWORD(lParam) / lCharWidth;
			point.y = HIWORD(lParam) / lCharHeight;
			CPURegDlg(hWnd, nCPU, point.x, point.y);
			return 0;

		/* ReLXgj[ */
		case WM_CONTEXTMENU:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* ReLXgj[[h */
			hMenu = GetSubMenu(hCPURegister[nCPU], 0);

			/* ReLXgj[s */
			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			TrackPopupMenu(hMenu, 0, point.x, point.y, 0, hWnd, NULL);
			return 0;

		/* R}h */
		case WM_COMMAND:
			CPURegDlg(hWnd, nCPU, -1, LOWORD(wParam) - IDM_REG_CC);
			break;

#ifdef XM7DASH
		/* EBhEړ */
		case WM_MOVE:
			/* ŏ̃TuEBhEҔ */
			MoveSubWindow(hWnd);
			break;
#endif
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	CPUWX^EChE
 *	EChE쐬
 */
HWND FASTCALL CreateCPURegister(HWND hParent, BYTE nCPU, int index)
{
	WNDCLASSEX wcex;
	char szClassNameMain[] = "XM7_CPURegisterMain";
	char szClassNameSub[] = "XM7_CPURegisterSub";
#ifdef JSUB
	char szClassNameJsub[] = "XM7_CPURegisterJsub";
#endif
	char *szClassName;
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
	UINT id;
#ifdef XM7DASH
	DWORD dwExStyle;
#endif

	ASSERT(hParent);

	/* EChE`vZ */
#ifdef XM7DASH
	PositioningSubWindow(hParent, &rect, index);
#else
	rect.left = lCharWidth * index;
	rect.top = lCharHeight * index;
	if (rect.top >= 380) {
		rect.top -= 380;
	}
#endif
	rect.right = lCharWidth * 17;
	rect.bottom = lCharHeight * 5;

	/* EChE^CgAobt@m */
	switch (nCPU) {
		case MAINCPU :	id = IDS_SWND_CPUREG_MAIN;
						szClassName = szClassNameMain;
						break;
		case SUBCPU :	id = IDS_SWND_CPUREG_SUB;
						szClassName = szClassNameSub;
						break;
#ifdef JSUB
		case JSUBCPU :	id = IDS_SWND_CPUREG_JSUB;
						szClassName = szClassNameJsub;
						break;
#endif
	}
	LoadString(hResInstance, id, szWndName, sizeof(szWndName));
	pCPURegister[nCPU] = malloc(2 * (rect.right / lCharWidth) *
							(rect.bottom / lCharHeight));
	hCPURegister[nCPU] = LoadMenu(hResInstance,
							MAKEINTRESOURCE(IDR_CPUREGMENU));

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS;
	wcex.lpfnWndProc = CPURegisterProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
#ifdef XM7DASH
	if (bPopupSwnd) {
		dwExStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_BORDER;
	}
	else {
		dwExStyle = WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_CLIPSIBLINGS;
	}
	if (bSwndVisible) {
		dwExStyle |= WS_VISIBLE;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwExStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#else
	hWnd = CreateWindow(szClassName,
						szWndName,
						WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
						| WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#endif

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);
	}

	/* ʂA */
	return hWnd;
}

#ifdef XM7DASH
HWND FASTCALL CreateCPURegisterMain(HWND hParent, int index)
{
	return	CreateCPURegister(hParent, MAINCPU, index);
}

HWND FASTCALL CreateCPURegisterSub(HWND hParent, int index)
{
	return	CreateCPURegister(hParent, SUBCPU, index);
}

#ifdef JSUB
HWND FASTCALL CreateCPURegisterJSub(HWND hParent, int index)
{
	return	CreateCPURegister(hParent, JSUBCPU, index);
}
#endif
#endif

/*-[ X^bNEu[N|CgWv ]------------------------------------*/

/*
 *	X^bNWvj[}
 */
static void FASTCALL InsertStackJumpMenu(HMENU hMenu, BYTE nCPU, UINT id)
{
	BYTE (FASTCALL *readbnio)(WORD addr);
	MENUITEMINFO mii;
	char string[128];
	WORD addr;
	int i;

	/* j[\̏ */
	memset(&mii, 0, sizeof(mii));
	mii.cbSize = 44;
	mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
	mii.fType = MFT_STRING;
	mii.fState = MFS_ENABLED;

	/* j[ׂč폜 */
	while (GetMenuItemCount(hMenu) > 0) {
		DeleteMenu(hMenu, 0, MF_BYPOSITION);
	}

	/* ڂǉ */
	for (i=15; i>=0; i--) {
		mii.wID = id + i;
		switch (nCPU) {
			case MAINCPU :	readbnio = mainmem_readbnio;
							break;
			case SUBCPU :	readbnio = submem_readbnio;
							break;
#ifdef JSUB
			case JSUBCPU :	readbnio = jsubmem_readbnio;
							break;
#endif
		}
		addr = (WORD)(readbnio((WORD)(maincpu.s + i)) << 8);
		addr |= (WORD)readbnio((WORD)(maincpu.s + i + 1));

		wStackAddr[i] = addr;
		_snprintf(string, 128, "%d,S ($%04X)", i, addr);
		mii.dwTypeData = string;
		mii.cch = strlen(string);
		InsertMenuItem(hMenu, 0, TRUE, &mii);
	}
}

/*
 *	u[N|CgWvj[}
 */
static void FASTCALL InsertBreakPointMenu(HMENU hMenu, BYTE nCPU, UINT id)
{
	MENUITEMINFO mii;
	char string[128];
	int no;
	int i;

	/* j[\̏ */
	memset(&mii, 0, sizeof(mii));
	mii.cbSize = 44;
	mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
	mii.fType = MFT_STRING;
	mii.fState = MFS_ENABLED;

	/* j[ׂč폜 */
	while (GetMenuItemCount(hMenu) > 0) {
		DeleteMenu(hMenu, 0, MF_BYPOSITION);
	}

	/* ڂǉ */
	no = 0;
	for (i=15; i>=0; i--) {
		if ((breakp[i].flag != BREAKP_NOTUSE) && (breakp[i].cpu == nCPU)) {
			mii.wID = id + no;
			wBreakAddr[no++] = breakp[i].addr;
			_snprintf(string, 128, "%d : $%04X", i+1, breakp[i].addr);
			mii.dwTypeData = string;
			mii.cch = strlen(string);
			InsertMenuItem(hMenu, 0, TRUE, &mii);
		}
	}
	if (no == 0) {
		/* 1u[N|CgȂꍇ */
		mii.wID = id;
		mii.fState = MFS_GRAYED;
		LoadString(hResInstance, IDS_SWND_BREAKPOINT_NONE,
				string, sizeof(string));
		mii.dwTypeData = string;
		mii.cch = strlen(string);
		InsertMenuItem(hMenu, 0, TRUE, &mii);
	}
}

#ifdef XM7DASH
/*
 *	AhXj[ݒ
 */
static void FASTCALL InsertPysicAddrMenu(HMENU hMenu, BYTE nCPU, UINT id)
{
	MENUITEMINFO mii;
	char string[128];
	int no;
	int i;

	UNUSED(nCPU);

	/* j[\̏ */
	memset(&mii, 0, sizeof(mii));
	mii.cbSize = 44;
	mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
	mii.fType = MFT_STRING;
	mii.fState = MFS_ENABLED;

	/* j[ׂč폜 */
	while (GetMenuItemCount(hMenu) > 0) {
		DeleteMenu(hMenu, 0, MF_BYPOSITION);
	}

	/* ڂǉ */
#if XM7_VER >= 2
	if (fm7_ver >= 3) {
		no = 0x0f;
	}
#else
	if (mmr_extrmw == EXRAM_960KB) {
		no = 0x0f;
	}
#endif
	else {
		no = 0x03;
	}
	for (i=no; i>=0; i--) {
		mii.wID = id + i;
		_snprintf(string, 128, "$%X0000-$%XFFFF", i, i);
		mii.dwTypeData = string;
		mii.cch = strlen(string);
		InsertMenuItem(hMenu, 0, TRUE, &mii);
	}
}

/*
 *	MSRj[ݒ
 */
static void FASTCALL InsertSegmentMenu(HMENU hMenu, BYTE nCPU, UINT id)
{
	MENUITEMINFO mii;
	char string[128];
	int no;
	int i;

	UNUSED(nCPU);

	/* j[\̏ */
	memset(&mii, 0, sizeof(mii));
	mii.cbSize = 44;
	mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
	mii.fType = MFT_STRING;
	mii.fState = MFS_ENABLED;

	/* j[ׂč폜 */
	while (GetMenuItemCount(hMenu) > 0) {
		DeleteMenu(hMenu, 0, MF_BYPOSITION);
	}

	/* ڂǉ */
#if XM7_VER >= 2
	if (fm7_ver >= 3) {
		no = 0x07;
	}
#else
	if (mmr_extrmw == EXRAM_960KB) {
		no = 0x3f;
	}
#endif
	else {
		no = 0x03;
	}
	for (i=no; i>=0; i--) {
		mii.wID = id + i;
		_snprintf(string, 128, "%d", i);
		mii.dwTypeData = string;
		mii.cch = strlen(string);
		InsertMenuItem(hMenu, 0, TRUE, &mii);
	}
}
#endif

/*-[ tAZuEChE ]------------------------------------------------*/

/*
 *	tAZuEChE
 *	AhXݒ
 */
void FASTCALL AddrDisAsm(BYTE nCPU, WORD wAddr)
{
	SCROLLINFO sif;
	HWND hWnd;

	/* EChEWIg𓾂 */
	hWnd = NULL;
	switch (nCPU) {
		case MAINCPU :	hWnd = hSubWnd[SWND_DISASM_MAIN];
						break;
		case SUBCPU :	hWnd = hSubWnd[SWND_DISASM_SUB];
						break;
#ifdef JSUB
		case JSUBCPU :	hWnd = hSubWnd[SWND_DISASM_JSUB];
						break;
#endif
	}
	if (!hWnd) {
		/* EChEȂ΂̂܂܃^[ */
		return;
	}

	/* SCROLLINFO\̂̏ */
	memset(&sif, 0, sizeof(sif));
	sif.cbSize = sizeof(sif);
	sif.fMask = SIF_POS;
	sif.nPos = (int)wAddr;

	/* ݃`FbNݒ */
	wDisAsm[nCPU] = wAddr;
	SetScrollInfo(hWnd, SB_VERT, &sif, TRUE);

	/* tbV */
	RefreshDisAsm();
}

/*
 *	tAZuEBhE
 *	TCY
 */
static void FASTCALL ResizeDisAsm(HWND hWnd, WORD cx, WORD cy, BYTE nCPU)
{
	RECT crect;
	RECT wrect;
	int width;

	ASSERT(hWnd);

	/* ŏ̏ꍇ́AȂ */
	if ((cx == 0) && (cy == 0)) {
		return;
	}

	/* TCYύX */
	width = 47;
	nHeightDisAsm[nCPU] = (WORD)(cy / lCharHeight);
	if (nHeightDisAsm[nCPU] < 1) {
		nHeightDisAsm[nCPU] = 1;
	}

	/* EBhE`ύX */
	GetWindowRect(hWnd, &wrect);
	GetClientRect(hWnd, &crect);
	wrect.right -= wrect.left;
	wrect.right -= crect.right;
	wrect.right += (width * lCharWidth);
	wrect.bottom -= wrect.top;
	wrect.bottom -= crect.bottom;
	wrect.bottom += (nHeightDisAsm[nCPU] * lCharHeight);
	SetWindowPos(hWnd, HWND_TOP, 0, 0, wrect.right, wrect.bottom,
							SWP_NOZORDER | SWP_NOMOVE);
}

/*
 *	tAZuEChE
 *	ZbgAbv
 */
static void FASTCALL SetupDisAsm(BYTE nCPU, BYTE *p, int x, int y)
{
	char string[128];
	int addr;
	int i;
	int j;
	int k;
	int ret;
	WORD pc;

	ASSERT(nCPU < MAXCPU);
	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);

	/* ݒ */
	switch (nCPU) {
		case MAINCPU :	pc = maincpu.pc;
						break;
		case SUBCPU :	pc = subcpu.pc;
						break;
#ifdef JSUB
		case JSUBCPU :	pc = jsubcpu.pc;
						break;
#endif
	}
	addr = (int)wDisAsm[nCPU];

	for (i=0; i<y; i++) {
		 /* tAZu */
#ifdef XM7DASH
		ret = disline(nCPU, (WORD)addr, string, nAddrSegDisAsm, nAddrModeDisAsm);
#else
		ret = disline(nCPU, (WORD)addr, string);
#endif

		/* Zbg */
		memcpy(&p[x * i + 2], string, strlen(string));

#ifdef XM7DASH
		if (nCPU != MAINCPU || nAddrModeDisAsm == 0) {
#endif

		/* }[N */
		if (pc == addr) {
			p[x * i + 1] = '>';
		}
		for (j=0; j<BREAKP_MAXNUM; j++) {
			if (breakp[j].addr != addr) {
				continue;
			}
			if (breakp[j].cpu != nCPU) {
				continue;
			}
			if (breakp[j].flag == BREAKP_NOTUSE) {
				continue;
			}
			if (breakp[j].flag == BREAKP_DISABLED) {
				continue;
			}

			/* u[N|Cg */
			p[x * i + 0] = (BYTE)('1' + j);

			/* ] */
			for (k=0; k<x; k++) {
				 p[x * i + k] = (BYTE)(p[x * i + k] | 0x80);
			}
		}

#ifdef XM7DASH
		}
#endif

		/* ZAI[o[`FbN */
		addr += ret;
		if (addr >= 0x10000) {
			break;
		}
	}
}

/*
 *	tAZuEChE
 *	`
 */
static void FASTCALL DrawDisAsm(HWND hWnd, HDC hDC)
{
	int i;
	BYTE nCPU;
	RECT rect;
#ifdef XM7DASH
	BYTE *p = NULL;
#else
	BYTE *p;
#endif
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			nCPU = (BYTE)((i - SWND_CPUREG_MAIN) % MAXCPU);
			p = pDisAsm[nCPU];
			break;
		}
	}
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	SetupDisAsm(nCPU, p, x, y);

	/* ` */
	DrawWindowText2(hDC, p, x, y);
}

/*
 *	tAZuEChE
 *	tbV
 */
void FASTCALL RefreshDisAsm(void)
{
	HWND hWnd;
	HDC hDC;

	/* CCPU */
	if (hSubWnd[SWND_DISASM_MAIN]) {
		hWnd = hSubWnd[SWND_DISASM_MAIN];
		hDC = GetDC(hWnd);
		DrawDisAsm(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

	/* TuCPU */
	if (hSubWnd[SWND_DISASM_SUB]) {
		hWnd = hSubWnd[SWND_DISASM_SUB];
		hDC = GetDC(hWnd);
		DrawDisAsm(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

#ifdef JSUB
	/* {TuCPU */
	if (hSubWnd[SWND_DISASM_JSUB]) {
		hWnd = hSubWnd[SWND_DISASM_JSUB];
		hDC = GetDC(hWnd);
		DrawDisAsm(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}
#endif
}

/*
 *	tAZuEChE
 *	ĕ`
 */
static void FASTCALL PaintDisAsm(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	int i;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			p = pDisAsm[((i - SWND_CPUREG_MAIN) % MAXCPU)];
			break;
		}
	}

	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawDisAsm(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	tAZuEChE
 *	NbN
 */
static void FASTCALL LButtonDisAsm(HWND hWnd, POINT point, BOOL mode)
{
	char string[128];
	int addr;
	BOOL flag;
	BYTE nCPU;
	int i;
	int y;
	int ret;

	ASSERT(hWnd);

	/* sJEg𓾂 */
	y = point.y / lCharHeight;

	/* ۂɋtAZuĂ݂ */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			nCPU = (BYTE)((i - SWND_CPUREG_MAIN) % MAXCPU);
			addr = (int)wDisAsm[nCPU];
			break;
		}
	}

	/* tAZu [v */
	for (i=0; i<y; i++) {
#ifdef XM7DASH
		ret = disline(nCPU, (WORD)addr, string, nAddrSegDisAsm, nAddrModeDisAsm);
#else
		ret = disline(nCPU, (WORD)addr, string);
#endif
		addr += ret;
		if (addr >= 0x10000) {
			return;
		}
	}

	if (mode) {
		/* Wv */
		switch (nCPU) {
			case MAINCPU :	maincpu.pc = (WORD)addr;
							break;
			case SUBCPU :	subcpu.pc = (WORD)addr;
							break;
#ifdef JSUB
			case JSUBCPU :	jsubcpu.pc = (WORD)addr;
							break;
#endif
		}
	}
	else {
		/* u[N|Cg on/off */
		flag = FALSE;
		for (i=0; i<BREAKP_MAXNUM; i++) {
			if ((breakp[i].cpu == nCPU) && (breakp[i].addr == addr)) {
				if (breakp[i].flag != BREAKP_NOTUSE) {
					breakp[i].flag = BREAKP_NOTUSE;
					flag = TRUE;
					break;
				}
			}
		}
		if (!flag) {
			schedule_setbreak(nCPU, (WORD)addr);
		}

		/* u[N|CgEChEAĕ`悷 */
		if (hSubWnd[SWND_BREAKPOINT]) {
			InvalidateRect(hSubWnd[SWND_BREAKPOINT], NULL, FALSE);
		}
	}

	/* ĕ` */
	InvalidateRect(hWnd, NULL, FALSE);
}

/*
 *	tAZuEChE
 *	R}h
 */
static void FASTCALL CmdDisAsm(HWND hWnd, WORD wID, BYTE nCPU)
{
	WORD target;
	cpu6809_t *cpu;

	/* CPU\̌ */
	switch (nCPU) {
		case MAINCPU :	cpu = &maincpu;
						break;
		case SUBCPU :	cpu = &subcpu;
						break;
#ifdef JSUB
		case JSUBCPU :	cpu = &jsubcpu;
						break;
#endif
	}

	/* ^[QbgAhX */
	switch (wID) {
		case IDM_DIS_ADDR:
			target = wDisAsm[nCPU];
			if (!AddrDlg(hWnd, &target)) {
				return;
			}
			break;

		case IDM_DIS_PC:
			target = cpu->pc;
			break;
		case IDM_DIS_X:
			target = cpu->x;
			break;
		case IDM_DIS_Y:
			target = cpu->y;
			break;
		case IDM_DIS_U:
			target = cpu->u;
			break;
		case IDM_DIS_S:
			target = cpu->s;
			break;

		case IDM_DIS_RESET:
			target = (WORD)((cpu->readmem(0xfffe) << 8) | cpu->readmem(0xffff));
			break;
		case IDM_DIS_NMI:
			target = (WORD)((cpu->readmem(0xfffc) << 8) | cpu->readmem(0xfffd));
			break;
		case IDM_DIS_SWI:
			target = (WORD)((cpu->readmem(0xfffa) << 8) | cpu->readmem(0xfffb));
			break;
		case IDM_DIS_IRQ:
			target = (WORD)((cpu->readmem(0xfff8) << 8) | cpu->readmem(0xfff9));
			break;
		case IDM_DIS_FIRQ:
			target = (WORD)((cpu->readmem(0xfff6) << 8) | cpu->readmem(0xfff7));
			break;
		case IDM_DIS_SWI2:
			target = (WORD)((cpu->readmem(0xfff4) << 8) | cpu->readmem(0xfff5));
			break;
		case IDM_DIS_SWI3:
			target = (WORD)((cpu->readmem(0xfff2) << 8) | cpu->readmem(0xfff3));
			break;
		case IDM_DIS_JUMP:
			LButtonDisAsm(hWnd, PosDisAsmPoint, TRUE);
			target = cpu->pc;
			break;
		case IDM_DIS_SYNCPC:
			bSyncDisasm[nCPU] = (!bSyncDisasm[nCPU]);
			return;

#ifdef XM7DASH
		case IDM_DIS_LOGIC:
			nAddrSegDisAsm = 0;								/* tAZuZOg */
			nAddrModeDisAsm = 0;							/* tAZuAhXtO */
			return;
#endif
		default:
			if ((wID >= IDM_DIS_STACK) && (wID <= IDM_DIS_STACK + 15)) {
				target = (WORD)wStackAddr[wID - IDM_DIS_STACK];
			}
			else if ((wID >= IDM_DIS_BREAK) && (wID <= IDM_DIS_BREAK + 15)) {
				target = (WORD)wBreakAddr[wID - IDM_DIS_BREAK];
			}
#ifdef XM7DASH
			else {
				target = wDisAsm[nCPU];
				if ((wID >= IDM_DIS_PADR0) && (wID <= IDM_DIS_PADR0 + 0x0f)) {
					nAddrSegDisAsm = (wID - IDM_DIS_PADR0);	/* _vZOg */
					nAddrModeDisAsm = 1;					/* tAZuAhXtO */
				}
				else if ((wID >= IDM_DIS_SEG00) && (wID <= IDM_DIS_MAX)) {
					nAddrSegDisAsm = (wID - IDM_DIS_SEG00);	/* _vZOg */
					nAddrModeDisAsm = 2;					/* tAZuAhXtO */
				}
				else if ((wID >= IDM_DIS_LADR0) && (wID <= IDM_DIS_LADR0 + 0x0f)) {
					target = (wID - IDM_DIS_LADR0) << 12;
				}
			}
#endif
			break;
	}

	/* ݒ聕XV */
	AddrDisAsm(nCPU, target);
}

/*
 *	tAZuEChE
 *	EChEvV[W
 */
static LRESULT CALLBACK DisAsmProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam, BYTE nCPU)
{
	static BOOL bResize = FALSE;	/* 蓮TCYtO */
	WORD wAddr;
	char string[128];
	int ret;
	int i;
	POINT point;
	HMENU hMenu;
	RECT rect;
#ifdef XM7DASH
	BOOL bpysic;
#endif

	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintDisAsm(hWnd);
			UnlockVM();
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pDisAsm[nCPU], hDisAsm[nCPU]);

			UnlockVM();
			break;

		/* EChETCYύX */
		case WM_SIZE:
			if (bResize) {
				bResize = FALSE;
				ResizeDisAsm(hWnd, LOWORD(lParam), HIWORD(lParam), nCPU);
			}
			break;

		/* EChETCYύX */
		case WM_SIZING:
			WindowSizing(hWnd, (LPRECT)lParam);
			bResize = TRUE;
			break;

		/* EBhETCYύXbZ[W */
		case WM_WINDOWPOSCHANGING:
			bResize = TRUE;
			break;

		/* ŏTCY */
		case WM_GETMINMAXINFO:
			rect.left = 0;
			rect.right = 47 * lCharWidth + GetSystemMetrics(SM_CXVSCROLL);
			rect.top = 0;
			rect.bottom = lCharHeight;
			AdjustWindowRect(&rect, WS_CHILD | WS_OVERLAPPED | WS_SYSMENU |
									WS_CAPTION | WS_VISIBLE | WS_MINIMIZEBOX |
									WS_CLIPSIBLINGS | WS_SIZEBOX, FALSE);
			((LPMINMAXINFO)lParam)->ptMinTrackSize.x = rect.right - rect.left;
			((LPMINMAXINFO)lParam)->ptMaxTrackSize.x = rect.right - rect.left;
			((LPMINMAXINFO)lParam)->ptMinTrackSize.y = rect.bottom - rect.top;
			return 0;

		/* ReLXgj[ */
		case WM_RBUTTONDOWN:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* ReLXgj[[h */
			hMenu = GetSubMenu(hDisAsm[nCPU], 0);
#ifndef XM7DASH
			CheckMenuSub(hMenu, IDM_DIS_SYNCPC, bSyncDisasm[nCPU]);
			EnableMenuSub(hMenu, IDM_DIS_SYNCPC, bSync);
#endif

			/* VXeX^bNWvj[ݒ */
			InsertStackJumpMenu(GetSubMenu(hMenu, 5), nCPU, IDM_DIS_STACK);

			/* u[N|Cgj[ݒ */
			InsertBreakPointMenu(GetSubMenu(hMenu, 6), nCPU, IDM_DIS_BREAK);

#ifdef XM7DASH
			/* AhX[h`FbN */
#if XM7_VER >= 2
			bpysic = (nCPU == MAINCPU && fm7_ver >= 2);
#else
			bpysic = (nCPU == MAINCPU && fm_subtype == FMSUB_FM77);
#endif
			for (i = 1; i <= 6; i ++) {
				EnableMenuPos(hMenu, i, !bpysic || nAddrModeDisAsm == 0);
			}
			EnableMenuPos(hMenu, 4, !bpysic || nAddrModeDisAsm != 1);
			EnableMenuPos(hMenu, 9, bpysic);
			EnableMenuPos(hMenu, 10, bpysic);
			EnableMenuPos(hMenu, 11, bpysic);
			CheckMenuSub(hMenu, IDM_DIS_SYNCPC, bSyncDisasm[nCPU] && (!bpysic || nAddrModeDisAsm == 0));
			EnableMenuSub(hMenu, IDM_DIS_SYNCPC, bSync && (!bpysic || nAddrModeDisAsm == 0));
			if (bpysic) {
				/* AhXj[ݒ */
				InsertPysicAddrMenu(GetSubMenu(hMenu, 10), nCPU, IDM_DIS_PADR0);

				/* MSRj[ݒ */
				InsertSegmentMenu(GetSubMenu(hMenu, 11), nCPU, IDM_DIS_SEG00);

				if (nAddrModeDisAsm == 1) {
					CheckMenuRadioItem(GetSubMenu(hMenu, 10), 0x00, 0x0f, nAddrSegDisAsm, MF_BYPOSITION);
				}
				else if (nAddrModeDisAsm == 2) {
					CheckMenuRadioItem(GetSubMenu(hMenu, 11), 0x00, 0x3f, nAddrSegDisAsm, MF_BYPOSITION);
				}
				CheckMenuRadioItem(hMenu, 9, 11, 9 + nAddrModeDisAsm, MF_BYPOSITION);
			}
#endif

			/* ReLXgj[s */
			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			PosDisAsmPoint = point;
			ClientToScreen(hWnd, &point);
			TrackPopupMenu(hMenu, 0, point.x, point.y, 0, hWnd, NULL);
			return 0;

		/* NbNE_uNbN */
		case WM_LBUTTONDOWN:
		case WM_LBUTTONDBLCLK:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

#ifdef XM7DASH
			/* _AhX[hȊO͖ */
			if (nAddrModeDisAsm != 0) {
				return FALSE;
			}
#endif

			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			LButtonDisAsm(hWnd, point, FALSE);
			break;

		/* R}h */
		case WM_COMMAND:
			CmdDisAsm(hWnd, LOWORD(wParam), nCPU);
			break;

		/* XN[o[ */
		case WM_VSCROLL:
			/* ^Cv */
			wAddr = wDisAsm[nCPU];

			/* ANV */
			switch (LOWORD(wParam)) {
				/* gbv */
				case SB_TOP:
					wAddr = 0;
					break;
				/* I[ */
				case SB_BOTTOM:
					wAddr = 0xffff;
					break;
				/* Ps */
				case SB_LINEUP:
					if (wAddr > 0) {
						wAddr--;
					}
					break;
				/* Ps(͍Hv) */
				case SB_LINEDOWN:
#ifdef XM7DASH
					ret = disline(nCPU, wAddr, string, nAddrSegDisAsm, nAddrModeDisAsm);
#else
					ret = disline(nCPU, wAddr, string);
#endif
					i = (int)wAddr;
					i += ret;
					if (i < 0x10000) {
						wAddr += (WORD)ret;
					}
					break;
				/* y[WAbv */
				case SB_PAGEUP:
					if (wAddr < 0x80) {
						wAddr = 0;
					}
					else {
						wAddr -= (WORD)0x80;
					}
					break;
				/* y[W_E */
				case SB_PAGEDOWN:
					if (wAddr >= 0xff80) {
						wAddr = 0xffff;
					}
					else {
						wAddr += (WORD)0x80;
					}
					break;
				/* ڎw */
				case SB_THUMBTRACK:
					wAddr = HIWORD(wParam);
					if (wAddr >= 0xffff) {
						wAddr = 0xffff;
					}
					break;
			}
			AddrDisAsm(nCPU, wAddr);
			RefreshDisAsm();
			break;

#ifdef XM7DASH
		/* EBhEړ */
		case WM_MOVE:
			/* ŏ̃TuEBhEҔ */
			MoveSubWindow(hWnd);
			break;
#endif
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	tAZuEChE(C)
 *	EChEvV[W
 */
static LRESULT CALLBACK DisAsmProcMain(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return DisAsmProc(hWnd, message, wParam, lParam, MAINCPU);
}

/*
 *	tAZuEChE(Tu)
 *	EChEvV[W
 */
static LRESULT CALLBACK DisAsmProcSub(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return DisAsmProc(hWnd, message, wParam, lParam, SUBCPU);
}

#ifdef JSUB
/*
 *	tAZuEChE({Tu)
 *	EChEvV[W
 */
static LRESULT CALLBACK DisAsmProcJsub(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return DisAsmProc(hWnd, message, wParam, lParam, JSUBCPU);
}
#endif

/*
 *	tAZuEChE
 *	EChE쐬
 */
HWND FASTCALL CreateDisAsm(HWND hParent, BYTE nCPU, int index)
{
	WNDCLASSEX wcex;
	char szClassNameMain[] = "XM7_DisAsmMain";
	char szClassNameSub[] = "XM7_DisAsmSub";
#ifdef JSUB
	char szClassNameJsub[] = "XM7_DisAsmJsub";
#endif
	char *szClassName;
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
	SCROLLINFO si;
	int height;
	UINT id;
	WORD pc;
#ifdef XM7DASH
	DWORD dwExStyle;
#endif

	ASSERT(hParent);

	/* EChE`vZ */
#ifdef XM7DASH
	PositioningSubWindow(hParent, &rect, index);
#else
	rect.left = lCharWidth * index;
	rect.top = lCharHeight * index;
	if (rect.top >= 380) {
		rect.top -= 380;
	}
#endif
	rect.right = lCharWidth * 47;

#ifdef XM7DASH
	if (bPopupSwnd) {
		/* ʉ𑜓xɍ킹vZ */
		height = ((GetSystemMetrics(SM_CYSCREEN) + lCharHeight - 1) / lCharHeight) + 3;
	}
	else {
		/* NCAg̈̃TCYɍ킹vZ */
		GetClientRect(hParent, &crect);
		height = (crect.bottom + lCharHeight - 1) / lCharHeight;
	}
#else
	/* NCAg̈̃TCYɍ킹vZ */
	GetClientRect(hParent, &crect);
	height = (crect.bottom + lCharHeight - 1) / lCharHeight;
#endif

	/* EChE^CgAobt@mہAj[h */
	switch (nCPU) {
		case MAINCPU :	id = IDS_SWND_DISASM_MAIN;
						pc = maincpu.pc;
						szClassName = szClassNameMain;
						break;
		case SUBCPU :	id = IDS_SWND_DISASM_SUB;
						pc = subcpu.pc;
						szClassName = szClassNameSub;
						break;
#ifdef JSUB
		case JSUBCPU :	id = IDS_SWND_DISASM_JSUB;
						pc = jsubcpu.pc;
						szClassName = szClassNameJsub;
						break;
#endif
	}
	rect.bottom = lCharHeight * nHeightDisAsm[nCPU];
	LoadString(hResInstance, id, szWndName, sizeof(szWndName));
	pDisAsm[nCPU] = malloc(2 * (rect.right / lCharWidth) * height);
	wDisAsm[nCPU] = pc;
	hDisAsm[nCPU] = LoadMenu(hResInstance, MAKEINTRESOURCE(IDR_DISASMMENU));

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW;
	switch (nCPU) {
		case MAINCPU :	wcex.lpfnWndProc = DisAsmProcMain;
						break;
		case SUBCPU :	wcex.lpfnWndProc = DisAsmProcSub;
						break;
#ifdef JSUB
		case JSUBCPU :	wcex.lpfnWndProc = DisAsmProcJsub;
						break;
#endif
	}
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
#ifdef XM7DASH
	if (bPopupSwnd) {
		dwExStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_BORDER
					| WS_VSCROLL | WS_SIZEBOX;
	}
	else {
		dwExStyle = WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_CLIPSIBLINGS
					| WS_VSCROLL | WS_SIZEBOX;
	}
	if (bSwndVisible) {
		dwExStyle |= WS_VISIBLE;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwExStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#else
	hWnd = CreateWindow(szClassName,
						szWndName,
						WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
						| WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS
						| WS_VSCROLL | WS_SIZEBOX ,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#endif

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);

		/* XN[o[̐ݒ肪Kv */
		memset(&si, 0, sizeof(si));
		si.cbSize = sizeof(si);
		si.fMask = SIF_ALL;
		si.nMin = 0;
		si.nMax = 0x100fe;
		si.nPage = 0x100;
		si.nPos = pc;
		SetScrollInfo(hWnd, SB_VERT, &si, TRUE);
	}

	/* ʂA */
	return hWnd;
}

#ifdef XM7DASH
HWND FASTCALL CreateDisAsmMain(HWND hParent, int index)
{
	return	CreateDisAsm(hParent, MAINCPU, index);
}

HWND FASTCALL CreateDisAsmSub(HWND hParent, int index)
{
	return	CreateDisAsm(hParent, SUBCPU, index);
}

#ifdef JSUB
HWND FASTCALL CreateDisAsmJSub(HWND hParent, int index)
{
	return	CreateDisAsm(hParent, JSUBCPU, index);
}
#endif
#endif

/*-[ eύX_CAO ]----------------------------------------------*/

/*
 *	eύX_CAO
 *	_CAO
 */
static BOOL FASTCALL MemoryChangeDlgInit(HWND hDlg)
{
	HWND hWnd;
	RECT prect;
	RECT drect;
	char tmp[16];
	char string[128];
	UINT id;

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* AhXݒ */
	hWnd = GetDlgItem(hDlg, IDC_MEMLABEL);
	ASSERT(hWnd);
	switch (nMemDlgCPU) {
		case MAINCPU :	id = IDS_SWND_CPU_MAIN;
						break;
		case SUBCPU :	id = IDS_SWND_CPU_SUB;
						break;
#ifdef JSUB
		case JSUBCPU :	id = IDS_SWND_CPU_JSUB;
						break;
#endif
	}
	LoadString(hResInstance, id, tmp, sizeof(tmp));
	_snprintf(string, 128, "$%04X (%s)", wMemDlgAddr, tmp);
	SetWindowText(hWnd, string);

	/* f[^ݒ */
	hWnd = GetDlgItem(hDlg, IDC_MEMEDIT);
	ASSERT(hWnd);
	_snprintf(string, 128, "%02X", nMemDlgByte);
	SetWindowText(hWnd, string);

	return TRUE;
}

/*
 *	eύX_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK MemoryChangeDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	HWND hWnd;
	char string[128];

	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return MemoryChangeDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						/* ݂̒l擾 */
						hWnd = GetDlgItem(hDlg, IDC_MEMEDIT);
						ASSERT(hWnd);
						GetWindowText(hWnd, string, sizeof(string) - 1);
						if (string[0] == 0x27) {
							nMemDlgByte = (BYTE)string[1];
						}
						else {
							nMemDlgByte = (BYTE)strtol(string, NULL, 16);
						}
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	eύX
 */
static BOOL FASTCALL MemoryChange(HWND hWnd, BYTE nCPU, int x, int y)
{
	BYTE (FASTCALL *readbnio)(WORD addr);
	void (FASTCALL *writeb)(WORD addr, BYTE dat);
	int height;
	int ret;

	ASSERT(hWnd);

	/* p[^ۑEݒ */
	switch (nCPU) {
		case MAINCPU :	readbnio = mainmem_readbnio;
						writeb = mainmem_writeb;
						break;
		case SUBCPU :	readbnio = submem_readbnio;
						writeb = submem_writeb;
						break;
#ifdef JSUB
		case JSUBCPU :	readbnio = jsubmem_readbnio;
						writeb = jsubmem_writeb;
						break;
#endif
	}
	ASSERT(readbnio);
	ASSERT(writeb);

	nMemDlgCPU = nCPU;
	height = nHeightMemory[nCPU];
	if (bAsciiDump[nCPU]) {
		height -= 3;
	}

	/* AhXZbg */
	if ((x < 6) || (x > 53) || ((x % 3) == 2) || (y < 0) || (y >= height)) {
		/* W͈͊O */
		return FALSE;
	}
	wMemDlgAddr = (WORD)(wMemory[nCPU] & 0xfff0);
	wMemDlgAddr += (WORD)((x - 6) / 3);
	wMemDlgAddr += (WORD)(y * 16);

	/* f[^Zbg */
#ifdef XM7DASH
	if (nCPU == MAINCPU && nAddrModeDump != 0) {
		nMemDlgByte = mainmem_readbsegnio(wMemDlgAddr, nAddrSegDump, nAddrModeDump);
	}
	else {
		nMemDlgByte = readbnio(wMemDlgAddr);
	}
#else
	nMemDlgByte = readbnio(wMemDlgAddr);
#endif

	/* [__CAOs */
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_MEMDLG), hWnd, MemoryChangeDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}

	/* f[^Zbg */
	LockVM();
#ifdef XM7DASH
	if (nCPU == MAINCPU && nAddrModeDump != 0) {
		mainmem_writebseg(wMemDlgAddr, (BYTE)nMemDlgByte, nAddrSegDump, nAddrModeDump);
	}
	else {
		writeb(wMemDlgAddr, (BYTE)nMemDlgByte);
	}
#else
	writeb(wMemDlgAddr, (BYTE)nMemDlgByte);
#endif
	InvalidateRect(hWnd, NULL, FALSE);
	UnlockVM();

	return TRUE;
}

/*-[ _CAO ]--------------------------------------------------*/

/*
 *	_CAO
 *	_CAO
 */
static BOOL FASTCALL MemorySearchDlgInit(HWND hDlg)
{
	HWND hWnd;
	RECT prect;
	RECT drect;
	char string[128];
	WORD addr;

	ASSERT(hDlg);

	/* eEChE̒ɐݒ */
	hWnd = GetParent(hDlg);
	GetWindowRect(hWnd, &prect);
	GetWindowRect(hDlg, &drect);
	drect.right -= drect.left;
	drect.bottom -= drect.top;
	drect.left = (prect.right - prect.left) / 2 + prect.left;
	drect.left -= (drect.right / 2);
	drect.top = (prect.bottom - prect.top) / 2 + prect.top;
	drect.top -= (drect.bottom / 2);
	MoveWindow(hDlg, drect.left, drect.top, drect.right, drect.bottom, FALSE);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_SEARCHADDR);
	ASSERT(hWnd);
	InsertHistory(hWnd);

	/* AhXݒ */
	addr = wMemSrchAddrSave[nMemSrchCPU];
	_snprintf(string, 128, "%04X", addr);
	ComboBox_SetText(hWnd, string);

	/* ݒ */
	hWnd = GetDlgItem(hDlg, IDC_SEARCHDATA);
	ASSERT(hWnd);
	SetWindowText(hWnd, (LPSTR)szMemSrchString);

	return TRUE;
}

/*
 *	_CAO
 *	_CAOOK
 */
static void FASTCALL MemorySearchDlgOK(HWND hDlg)
{
	HWND hWnd;
	char string[128];

	ASSERT(hDlg);

	/* ݂̒l擾 */
	hWnd = GetDlgItem(hDlg, IDC_SEARCHDATA);
	ASSERT(hWnd);
	GetWindowText(hWnd, szMemSrchString, sizeof(szMemSrchString) - 1);

	/* R{{bNX */
	hWnd = GetDlgItem(hDlg, IDC_SEARCHADDR);
	ASSERT(hWnd);

	/* ݂̒l擾 */
	ComboBox_GetText(hWnd, string, sizeof(string) - 1);
	wMemSrchAddr = (WORD)strtol(string, NULL, 16);

	/* qXgǉ */
	AddAddrHistory(wMemSrchAddr);
}

/*
 *	_CAO
 *	_CAOvV[W
 */
static BOOL CALLBACK MemorySearchDlgProc(HWND hDlg, UINT iMsg,
									WPARAM wParam, LPARAM lParam)
{
	UNUSED(lParam);

	switch (iMsg) {
		/* _CAO */
		case WM_INITDIALOG:
			return MemorySearchDlgInit(hDlg);

		/* R}h */
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				/* OKELZ */
				case IDOK:
				case IDCANCEL:
					if (LOWORD(wParam) == IDOK) {
						MemorySearchDlgOK(hDlg);
					}
					EndDialog(hDlg, LOWORD(wParam));
					InvalidateRect(hDrawWnd, NULL, FALSE);
					return TRUE;
			}
			break;
	}

	/* ȊÓAFALSE */
	return FALSE;
}

/*
 *	
 */
static BOOL FASTCALL MemorySearch(HWND hWnd, BYTE nCPU)
{
	BYTE (FASTCALL *readbnio)(WORD addr);
	BYTE searchdata[128];
	char string[128];
	char tmp[128];
	char *p;
	char *q;
	BOOL flag;
	BYTE dat;
	int datasize;
	int ret;
	int i;
	int j;

	ASSERT(hWnd);

	/* [__CAOs */
	nMemSrchCPU = nCPU;
	ret = DialogBox(hResInstance, MAKEINTRESOURCE(IDD_SEARCHDLG), hWnd, MemorySearchDlgProc);
	if (ret != IDOK) {
		return FALSE;
	}

	/* [Nݒ */
	switch (nCPU) {
		case MAINCPU :	readbnio = mainmem_readbnio;
						break;
		case SUBCPU :	readbnio = submem_readbnio;
						break;
#ifdef JSUB
		case JSUBCPU :	readbnio = jsubmem_readbnio;
						break;
#endif
	}
	wMemSrchAddrSave[nCPU] = wMemSrchAddr;
	memset(searchdata, 0, sizeof(searchdata));
	memset(string, 0, sizeof(string));
	memset(tmp, 0, sizeof(tmp));

	/* ϊ */
	if (szMemSrchString[0] == '#') {
		/* 16iƂċ镶̂ݔo */
		p = &szMemSrchString[1];
		q = string;
		while (*p != '\0') {
			if ((	((*p >= '0') && (*p <= '9')) ||
					((*p >= 'A') && (*p <= 'F')) ||
					((*p >= 'a') && (*p <= 'f')))) {
				*q++ = *p;
			}
			p++;
		}

		/* f[^֕ϊ */
		datasize = 0;
		p = string;

		while (*p != '\0') {
			memcpy(tmp, p, 2);
			searchdata[datasize ++] = (BYTE)strtol(tmp, NULL, 16);
			p += 2;
		}
	}
	else {
		/* w */
		datasize = strlen(szMemSrchString);
		memcpy(searchdata, szMemSrchString, datasize);
	}

	/* f[^ȂꍇȂ */
	if (datasize == 0) {
		return FALSE;
	}

	/* f[^ */
	flag = FALSE;
	for (i=wMemSrchAddr; i<65536 - datasize; i++) {
#ifdef XM7DASH
		if (nCPU == MAINCPU && nAddrModeDump != 0) {
			dat = mainmem_readbsegnio((WORD)i, nAddrSegDump, nAddrModeDump);
		}
		else {
			dat = readbnio((WORD)i);
		}
#else
		dat = readbnio((WORD)i);
#endif

		/* 擪f[^vꍇɎc̃f[^`FbN*/
		if (searchdata[0] == dat) {
			for (j=1; j<datasize; j++) {
#ifdef XM7DASH
				if (nCPU == MAINCPU && nAddrModeDump != 0) {
					dat = mainmem_readbsegnio((WORD)(i + j), nAddrSegDump, nAddrModeDump);
				}
				else {
					dat = readbnio((WORD)(i + j));
				}
				if (searchdata[j] != dat) {
#else
				if (searchdata[j] != readbnio((WORD)(i + j))) {
#endif
					break;
				}
			}
			if (j == datasize) {
				/*  */
				LoadString(hResInstance, IDS_SWND_SRCH_FOUND, tmp, sizeof(tmp));
				_snprintf(string, 128, tmp, i);
				flag = TRUE;
				break;
			}
		}
	}

	if (!flag) {
		/* ł */
		LoadString(hResInstance, IDS_SWND_SRCH_NOTFOUND, string, sizeof(string));
	}

	/* ʂ\ */
	MessageBox(hMainWnd, string, "XM7", MB_OK | MB_ICONINFORMATION);
	SetMenuExitTimer();

	if (flag) {
		/* łꍇ͂̃AhXɔ΂ */
		AddrMemory(nCPU, (WORD)i);

		/* JnAhXXV */
		wMemSrchAddrSave[nCPU] = (WORD)(i + datasize);
	}

	return TRUE;
}

/*-[ _vEChE ]------------------------------------------------*/

/*
 *	_vEChE
 *	AhXݒ
 */
void FASTCALL AddrMemory(BYTE nCPU, WORD wAddr)
{
	SCROLLINFO sif;

	wAddr &= (WORD)(0xfff0);

	memset(&sif, 0, sizeof(sif));
	sif.cbSize = sizeof(sif);
	sif.fMask = SIF_POS;
	sif.nPos = (int)(wAddr >> 4);

	/* ݃`FbNݒ */
	wMemory[nCPU] = wAddr;
	switch (nCPU) {
		case MAINCPU :	if (hSubWnd[SWND_MEMORY_MAIN]) {
							SetScrollInfo(hSubWnd[SWND_MEMORY_MAIN], SB_VERT,
								&sif, TRUE);
						}
						break;
		case SUBCPU :	if (hSubWnd[SWND_MEMORY_SUB]) {
							SetScrollInfo(hSubWnd[SWND_MEMORY_SUB], SB_VERT,
								&sif, TRUE);
						}
						break;
#ifdef JSUB
		case JSUBCPU :	if (hSubWnd[SWND_MEMORY_JSUB]) {
							SetScrollInfo(hSubWnd[SWND_MEMORY_JSUB], SB_VERT,
								&sif, TRUE);
						}
						break;
#endif
	}

	/* tbV */
	RefreshMemory();
}

/*
 *	_vEBhE
 *	TCY
 */
static void FASTCALL ResizeMemory(HWND hWnd, WORD cx, WORD cy, BYTE nCPU)
{
	RECT crect;
	RECT wrect;
	SCROLLINFO si;
	int width;
	int height;

	ASSERT(hWnd);

	/* ŏ̏ꍇ́AȂ */
	if ((cx == 0) && (cy == 0)) {
		return;
	}

	/* cTCYύX */
	nHeightMemory[nCPU] = (WORD)(cy / lCharHeight);
	if (nHeightMemory[nCPU] < 1) {
		nHeightMemory[nCPU] = 1;
	}

	/* TCYύX */
	if (bAsciiDump[nCPU]) {
		width = 75;
	}
	else {
		width = 53;
	}

	/* EBhE`ύX */
	GetWindowRect(hWnd, &wrect);
	GetClientRect(hWnd, &crect);
	wrect.right -= wrect.left;
	wrect.right -= crect.right;
	wrect.right += (width * lCharWidth);
	wrect.bottom -= wrect.top;
	wrect.bottom -= crect.bottom;
	wrect.bottom += (nHeightMemory[nCPU] * lCharHeight);
	SetWindowPos(hWnd, HWND_TOP, 0, 0, wrect.right, wrect.bottom,
							SWP_NOZORDER | SWP_NOMOVE);

	/* XN[o[̐ݒ */
	memset(&si, 0, sizeof(si));
	height = nHeightMemory[nCPU];
	if (bAsciiDump[nCPU]) {
		height -= 3;
	}
	si.cbSize = sizeof(si);
	si.fMask = SIF_ALL;
	si.nMin = 0;
	si.nMax = 0x100f - height;
	si.nPage = 0x10;
	si.nPos = (wMemory[nCPU] >> 4);
	SetScrollInfo(hWnd, SB_VERT, &si, TRUE);
}

/*
 *	_vEBhE
 *	TCY(sw)
 */
static void FASTCALL ResizeMemoryLines(HWND hWnd, int lines, BYTE nCPU)
{
	RECT rect;

	GetWindowRect(hWnd, &rect);
	ResizeMemory(hWnd, 	(WORD)(rect.right - rect.left + 1), 
						(WORD)(lCharHeight * lines), nCPU);
}

/*
 *	_vEChE
 *	ZbgAbv
 */
static void FASTCALL SetupMemory(BYTE nCPU, BYTE *p, int x, int y)
{
	BYTE (FASTCALL *readbnio)(WORD addr);
	char string[128];
	char temp[32];
	WORD addr;
	int i;
	int j;
	int height;
	BYTE mem[16];
	BYTE tsum[16];
	BYTE sum;
	BYTE knjsave;
	int offset;
	BOOL isj;

	ASSERT(nCPU < MAXCPU);
	ASSERT(p);
	ASSERT(x > 0);
	ASSERT(y > 0);

	/* UXy[XŖ߂ */
	memset(p, 0x20, x * y);
	memset(tsum, 0, 16);

	/* [N */
	knjsave = 0;
	isj = isJapanese;

	/* AhX擾 */
	addr = (WORD)(wMemory[nCPU] & 0xfff0);
	height = nHeightMemory[nCPU];
	switch (nCPU) {
		case MAINCPU :	readbnio = mainmem_readbnio;
						break;
		case SUBCPU :	readbnio = submem_readbnio;
						break;
#ifdef JSUB
		case JSUBCPU :	readbnio = jsubmem_readbnio;
						break;
#endif
	}

	/* ASCII_v[h 㕔KCh */
	if (bAsciiDump[nCPU]) {
		strncpy(string, "Addr ", 128);
		for (j=0; j<16; j++) {
			_snprintf(temp, 32, " +%01X", j);
			strncat(string, temp, 128 - strlen(string) - 1);
		}
#ifdef XM7DASH
		strncat(string, " Sum", 128 - strlen(string) - 1);
#else
		strncat(string, " Sum", 128 - 4 - 1);
#endif

		/* Rs[ */
		memcpy(p, string, strlen(string));

		offset = 1;
		height -= 3;
	}
	else {
		offset = 0;
	}

	/* [v */
	for (i=0; i<height; i++) {
		/* 쐬 */
		_snprintf(string, 128, "%04X:", addr);
		sum = 0;
		for (j=0; j<16; j++) {
#ifdef XM7DASH
			if (nCPU == MAINCPU && nAddrModeDump != 0) {
				mem[j] = mainmem_readbsegnio((WORD)(addr + j), nAddrSegDump, nAddrModeDump);
			}
			else {
				mem[j] = readbnio((WORD)(addr + j));
			}
#else
			mem[j] = readbnio((WORD)(addr + j));
#endif
			_snprintf(temp, 32, " %02X", mem[j]);
			tsum[j] += mem[j];
			sum += mem[j];
			strncat(string, temp, 128 - strlen(string) - 1);
		}

		if (bAsciiDump[nCPU]) {
			/* `FbNT */
			_snprintf(temp, 32, " :%02X  ................", sum);
			strncat(string, temp, 128 - strlen(string) - 1);

			/* R[h2sɂ܂ꍇ̏ */
			if (isj && isKanji(knjsave)) {
				string[58] = knjsave;
				knjsave = 1;
			}

			/* ASCII_v */
			for (j=0; j<16; j++) {
				if ((mem[j] < 0x20) || (mem[j] == 0x7f) || (mem[j] >= 0xfd)) {
					/* Rg[R[h(\) */
					knjsave = 0;
				}
				else if (!isj && (mem[j] & 0x80)) {
					/* {ꃂ[h 0x80`0xFF(\) */
					knjsave = 0;
				}
				else if (bKanjiDump[nCPU] && isKanji(mem[j]) && (knjsave == 0)) {
					/*  */

					if (j == 15) {
						/* sɂ܂ꍇ͔\ */
						string[j + 59] = ' ';
						knjsave = mem[j];
					}
					else {
						if (isKanji2(mem[j + 1])) {
							/* 2oCgƂȂꍇ */
							string[j + 59] = mem[j];
							knjsave = 1;
						}
						else {
							/* R[hُ(\) */
							knjsave = 0;
						}
					}
				}
				else {
					if ((mem[j] == 0xa0) && (knjsave == 0)) {
						/* f[^$A0ŃVtgJIS2oCgłȂꍇ */
						string[j + 59] = ' ';
					}
					else if ((!isKanji(mem[j]) && (mem[j] != 0x80)) || (knjsave == 1)) {
						/* ANK ܂ VtgJIS2oCg */
						string[j + 59] = mem[j];
					}
					knjsave = 0;
				}
			}
		}

		/* Rs[ */
		memcpy(&p[x * (i + offset)], string, strlen(string));

		/*  */
		addr += (WORD)0x0010;
		if (addr == 0) {
			break;
		}
	}

	/* ASCII_v[h rEcTEubNT */
	if (bAsciiDump[nCPU]) {
		/* r쐬 */
		memset(string, '-', 75);
		memset(&string[57], ' ', 2);
		string[76] = '\0';

		/* Rs[ */
		memcpy(&p[x * (height + 1)], string, strlen(string));

		/* cT쐬 */
		_snprintf(string, 128, "Sum :", addr);
		sum = 0;
		for (j=0; j<16; j++) {
			_snprintf(temp, 32, " %02X", tsum[j]);
			sum += tsum[j];
			strncat(string, temp, 128 - strlen(string) - 1);
		}

		/* `FbNT */
		_snprintf(temp, 32, " :%02X", sum);
		strncat(string, temp, 128 - strlen(string) - 1);

		/* Rs[ */
		memcpy(&p[x * (height + 2)], string, strlen(string));
	}
}

/*
 *	_vEChE
 *	`
 */
static void FASTCALL DrawMemory(HWND hWnd, HDC hDC)
{
	int i;
	BYTE nCPU;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);
	ASSERT(hDC);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			nCPU = (BYTE)((i - SWND_CPUREG_MAIN) % MAXCPU);
			p = pMemory[nCPU];
			break;
		}
	}
	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;
	if ((x == 0) || (y == 0)) {
		return;
	}

	/* ZbgAbv */
	SetupMemory(nCPU, p, x, y);

	/* ` */
	if (bKanjiDump[nCPU] && isJapanese) {
		DrawWindowTextKanji(hDC, p, x, y);
	}
	else {
		DrawWindowText(hDC, p, x, y);
	}
}

/*
 *	_vEChE
 *	tbV
 */
void FASTCALL RefreshMemory(void)
{
	HWND hWnd;
	HDC hDC;

	/* CCPU */
	if (hSubWnd[SWND_MEMORY_MAIN]) {
		hWnd = hSubWnd[SWND_MEMORY_MAIN];
		hDC = GetDC(hWnd);
		DrawMemory(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

	/* TuCPU */
	if (hSubWnd[SWND_MEMORY_SUB]) {
		hWnd = hSubWnd[SWND_MEMORY_SUB];
		hDC = GetDC(hWnd);
		DrawMemory(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}

#ifdef JSUB
	/* {TuCPU */
	if (hSubWnd[SWND_MEMORY_JSUB]) {
		hWnd = hSubWnd[SWND_MEMORY_JSUB];
		hDC = GetDC(hWnd);
		DrawMemory(hWnd, hDC);
		ReleaseDC(hWnd, hDC);
	}
#endif
}

/*
 *	_vEChE
 *	ĕ`
 */
static void FASTCALL PaintMemory(HWND hWnd)
{
	HDC hDC;
	PAINTSTRUCT ps;
	int i;
	RECT rect;
	BYTE *p;
	int x, y;

	ASSERT(hWnd);

	/* Drawobt@𓾂(݂ȂΉȂ) */
	for (i=0; i<SWND_MAXNUM; i++) {
		if (hSubWnd[i] == hWnd) {
			p = pMemory[((i - SWND_CPUREG_MAIN) % MAXCPU)];
			break;
		}
	}

	if (!p) {
		return;
	}

	/* EChEWIg𓾂 */
	GetClientRect(hWnd, &rect);
	x = rect.right / lCharWidth;
	y = rect.bottom / lCharHeight;

	/* 㔼GAFFŖ߂ */
	if ((x > 0) && (y > 0)) {
		memset(&p[x * y], 0xff, x * y);
	}

	/* ` */
	hDC = BeginPaint(hWnd, &ps);
	ASSERT(hDC);
	DrawMemory(hWnd, hDC);
	EndPaint(hWnd, &ps);
}

/*
 *	_vEChE
 *	R}h
 */
static void FASTCALL CmdMemory(HWND hWnd, WORD wID, BYTE nCPU)
{
	WORD target;
	cpu6809_t *cpu;
	BYTE height;

	/* CPU\̌ */
	switch (nCPU) {
		case MAINCPU :	cpu = &maincpu;
						break;
		case SUBCPU :	cpu = &subcpu;
						break;
#ifdef JSUB
		case JSUBCPU :	cpu = &jsubcpu;
						break;
#endif
	}

	/* ^[QbgAhX */
	switch (wID) {
		case IDM_DMP_ADDR:
#ifdef XM7DASH
			target = wMemory[nCPU];
#else
			target = wDisAsm[nCPU];
#endif
			if (!AddrDlg(hWnd, &target)) {
				return;
			}
			break;

		case IDM_DMP_BLK128:
		case IDM_DMP_BLK256:
			if (wID == IDM_DMP_BLK128) {
				height = 8;
			}
			else if (wID == IDM_DMP_BLK256) {
				height = 16;
			}
			if (bAsciiDump[nCPU]) {
				height += (BYTE)3;
			}
			ResizeMemoryLines(hWnd, height, nCPU);
			return;

		case IDM_DMP_ASCII:
			bAsciiDump[nCPU] = !bAsciiDump[nCPU];

			/* cTCYύX */
			height = nHeightMemory[nCPU];
			if (bAsciiDump[nCPU]) {
				height += (BYTE)3;
			}
			else {
				height -= (BYTE)3;
			}
			ResizeMemoryLines(hWnd, height, nCPU);
			return;

		case IDM_DMP_KANJI:
			bKanjiDump[nCPU] = !bKanjiDump[nCPU];
			InvalidateRect(hWnd, NULL, FALSE);
			return;

		case IDM_DMP_SEARCH:
			MemorySearch(hWnd, nCPU);
			return;

		case IDM_DMP_PC:
			target = cpu->pc;
			break;
		case IDM_DMP_X:
			target = cpu->x;
			break;
		case IDM_DMP_Y:
			target = cpu->y;
			break;
		case IDM_DMP_U:
			target = cpu->u;
			break;
		case IDM_DMP_S:
			target = cpu->s;
			break;
		case IDM_DMP_DP:
			target = (WORD)(cpu->dp << 8);
			break;

		case IDM_DMP_RESET:
			target = (WORD)((cpu->readmem(0xfffe) << 8) | cpu->readmem(0xffff));
			break;
		case IDM_DMP_NMI:
			target = (WORD)((cpu->readmem(0xfffc) << 8) | cpu->readmem(0xfffd));
			break;
		case IDM_DMP_SWI:
			target = (WORD)((cpu->readmem(0xfffa) << 8) | cpu->readmem(0xfffb));
			break;
		case IDM_DMP_IRQ:
			target = (WORD)((cpu->readmem(0xfff8) << 8) | cpu->readmem(0xfff9));
			break;
		case IDM_DMP_FIRQ:
			target = (WORD)((cpu->readmem(0xfff6) << 8) | cpu->readmem(0xfff7));
			break;
		case IDM_DMP_SWI2:
			target = (WORD)((cpu->readmem(0xfff4) << 8) | cpu->readmem(0xfff5));
			break;
		case IDM_DMP_SWI3:
			target = (WORD)((cpu->readmem(0xfff2) << 8) | cpu->readmem(0xfff3));
			break;
		case IDM_DMP_IO:
			switch (nCPU) {
				case MAINCPU :	target = 0xfd00;
								break;
				case SUBCPU :	target = 0xd400;
								break;
				default :		target = 0x0000;
			}
			break;

#ifdef XM7DASH
		case IDM_DMP_LOGIC:
			nAddrSegDump = 0;							/* _vZOg */
			nAddrModeDump = 0;							/* _vAhXtO */
			return;
#endif
		default:
			if ((wID >= IDM_DMP_STACK) && (wID <= IDM_DMP_STACK + 15)) {
				target = (WORD)wStackAddr[wID - IDM_DMP_STACK];
			}
#ifdef XM7DASH
			else {
				target = wMemory[nCPU];
				if ((wID >= IDM_DMP_PADR0) && (wID <= IDM_DMP_PADR0 + 0x0f)) {
					nAddrSegDump = (wID - IDM_DMP_PADR0);	/* _vZOg */
					nAddrModeDump = 1;					/* _vAhXtO */
				}
				else if ((wID >= IDM_DMP_SEG00) && (wID <= IDM_DMP_MAX)) {
					nAddrSegDump = (wID - IDM_DMP_SEG00);	/* _vZOg */
					nAddrModeDump = 2;					/* _vAhXtO */
				}
				else if ((wID >= IDM_DMP_LADR0) && (wID <= IDM_DMP_LADR0 + 0x0f)) {
					target = (wID - IDM_DMP_LADR0) << 12;
				}
			}
#endif
			break;
	}

	/* ݒ聕XV */
	AddrMemory(nCPU, target);
}

/*
 *	_vEChE
 *	EChEvV[W
 */
static LRESULT CALLBACK MemoryProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam, BYTE nCPU)
{
	static BOOL bResize = FALSE;		/* 蓮TCYtO */
	HMENU hMenu;
	POINT point;
	WORD wAddr;
	int height;
	UINT idcheck;
	RECT rect;
#ifdef XM7DASH
	BOOL bpysic;
	int i;
#endif

	/* bZ[W */
	switch (message) {
		/* EChEĕ` */
		case WM_PAINT:
			/* bNKv */
			LockVM();
			PaintMemory(hWnd);
			UnlockVM();
			return 0;

		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, &pMemory[nCPU], hMemory[nCPU]);

			UnlockVM();
			break;

		/* EChETCYύX */
		case WM_SIZE:
			if (bResize) {
				bResize = FALSE;
				ResizeMemory(hWnd, LOWORD(lParam), HIWORD(lParam), nCPU);
			}
			break;

		/* EChETCYύX */
		case WM_SIZING:
			WindowSizing(hWnd, (LPRECT)lParam);
			bResize = TRUE;
			break;

		/* EBhETCYύXbZ[W */
		case WM_WINDOWPOSCHANGING:
			bResize = TRUE;
			break;

		/* ŏTCY */
		case WM_GETMINMAXINFO:
			rect.left = 0;
			rect.right = 53 * lCharWidth + GetSystemMetrics(SM_CXVSCROLL);
			rect.top = 0;
			rect.bottom = lCharHeight;

			/* ASCII_v[h̏cTXy[Xl */
			if (bAsciiDump[nCPU]) {
				rect.right += (22 * lCharWidth);
				rect.bottom += (lCharHeight * 3);
			}

			AdjustWindowRect(&rect, WS_CHILD | WS_OVERLAPPED | WS_SYSMENU |
									WS_CAPTION | WS_VISIBLE | WS_MINIMIZEBOX |
									WS_CLIPSIBLINGS | WS_SIZEBOX, FALSE);
			((LPMINMAXINFO)lParam)->ptMinTrackSize.x = rect.right - rect.left;
			((LPMINMAXINFO)lParam)->ptMaxTrackSize.x = rect.right - rect.left;
			((LPMINMAXINFO)lParam)->ptMinTrackSize.y = rect.bottom - rect.top;
			return 0;

		/* eύX */
		case WM_LBUTTONDBLCLK:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* J[\ʒuA */
			point.x = LOWORD(lParam) / lCharWidth;
			point.y = HIWORD(lParam) / lCharHeight;
			if (bAsciiDump[nCPU]) {
				point.y --;
			}

			MemoryChange(hWnd, nCPU, point.x, point.y);
			return 0;

		/* ReLXgj[ */
		case WM_CONTEXTMENU:
#ifdef MOUSE
			/* }EXG~[Vgp͖ */
			if (mos_capture && !stopreq_flag && run_flag) {
				return FALSE;
			}
#endif

			/* Tuj[o */
			hMenu = GetSubMenu(hMemory[nCPU], 0);
			height = nHeightMemory[nCPU];
			if (bAsciiDump[nCPU]) {
				height -= 3;
			}

			/* \TCY`FbN */
			CheckMenuSub(hMenu, IDM_DMP_BLK128, FALSE);
			CheckMenuSub(hMenu, IDM_DMP_BLK256, FALSE);
			if (height == 8) {
				idcheck = IDM_DMP_BLK128;
			}
			else if (height == 16) {
				idcheck = IDM_DMP_BLK256;
			}
			else {
				idcheck = 0;
			}
			if (idcheck > 0) {
				CheckMenuRadioItem(hMenu, IDM_DMP_BLK128, IDM_DMP_BLK256, idcheck, MF_BYCOMMAND);
			}

			/* ASCII_v`FbN */
			CheckMenuSub(hMenu, IDM_DMP_ASCII, bAsciiDump[nCPU]);

			/* \`FbN */
			if (isJapanese) {
				EnableMenuSub(hMenu, IDM_DMP_KANJI, bAsciiDump[nCPU]);
				CheckMenuSub(hMenu, IDM_DMP_KANJI, bKanjiDump[nCPU]);
			}
			else {
				EnableMenuSub(hMenu, IDM_DMP_KANJI, FALSE);
				CheckMenuSub(hMenu, IDM_DMP_KANJI, FALSE);
			}

#ifdef JSUB
			/* I/Ö`FbN */
			if (nCPU == JSUBCPU) {
				EnableMenuSub(hMenu, IDM_DMP_IO, FALSE);
			}
			else {
				EnableMenuSub(hMenu, IDM_DMP_IO, TRUE);
			}
#endif

			/* VXeX^bNWvj[ݒ */
			InsertStackJumpMenu(GetSubMenu(hMenu, 10), nCPU, IDM_DMP_STACK);

#ifdef XM7DASH
			/* AhX[h`FbN */
#if XM7_VER >= 2
			bpysic = (nCPU == MAINCPU && fm7_ver >= 2);
#else
			bpysic = (nCPU == MAINCPU && fm_subtype == FMSUB_FM77);
#endif
			EnableMenuPos(hMenu, 8, !bpysic || nAddrModeDump == 0);
			EnableMenuPos(hMenu, 9, !bpysic || nAddrModeDump != 1);
			EnableMenuPos(hMenu, 10, !bpysic || nAddrModeDump == 0);
			EnableMenuPos(hMenu, 11, !bpysic || nAddrModeDump != 1);
			EnableMenuPos(hMenu, 14, bpysic);
			EnableMenuPos(hMenu, 15, bpysic);
			EnableMenuPos(hMenu, 16, bpysic);
			if (bpysic) {
				/* AhXj[ݒ */
				InsertPysicAddrMenu(GetSubMenu(hMenu, 15), nCPU, IDM_DMP_PADR0);

				/* MSRj[ݒ */
				InsertSegmentMenu(GetSubMenu(hMenu, 16), nCPU, IDM_DMP_SEG00);

				if (nAddrModeDump == 1) {
					CheckMenuRadioItem(GetSubMenu(hMenu, 15), 0x00, 0x0f, nAddrSegDump, MF_BYPOSITION);
				}
				else if (nAddrModeDump == 2) {
					CheckMenuRadioItem(GetSubMenu(hMenu, 16), 0x00, 0x3f, nAddrSegDump, MF_BYPOSITION);
				}
				CheckMenuRadioItem(hMenu, 14, 16, 14 + nAddrModeDump, MF_BYPOSITION);
			}
#endif

			/* ReLXgj[s */
			point.x = LOWORD(lParam);
			point.y = HIWORD(lParam);
			TrackPopupMenu(hMenu, 0, point.x, point.y, 0, hWnd, NULL);
			return 0;

		/* R}h */
		case WM_COMMAND:
			CmdMemory(hWnd, LOWORD(wParam), nCPU);
			break;

		/* XN[o[ */
		case WM_VSCROLL:
			/* ^Cv */
			wAddr = wMemory[nCPU];
			height = nHeightMemory[nCPU];
			if (bAsciiDump[nCPU]) {
				height -= 3;
			}

			/* ANV */
			switch (LOWORD(wParam)) {
				/* gbv */
				case SB_TOP:
					wAddr = 0;
					break;
				/* I[ */
				case SB_BOTTOM:
					wAddr = (WORD)(0x10000 - height * 16);
					break;
				/* Ps */
				case SB_LINEUP:
					if (wAddr >= 0x0010) {
						wAddr -= (WORD)0x0010;
					}
					break;
				/* Ps */
				case SB_LINEDOWN:
					if (wAddr < 0xfff0) {
						wAddr += (WORD)0x0010;
					}
					break;
				/* y[WAbv */
				case SB_PAGEUP:
					if (wAddr <= (height * 16)) {
						wAddr = 0;
					}
					else {
						wAddr -= (WORD)(height * 0x10);
					}
					break;
				/* y[W_E */
				case SB_PAGEDOWN:
					if (wAddr >= (0xfff0 - height * 16)) {
						wAddr = 0xfff0;
					}
					else {
						wAddr += (WORD)(height * 16);
					}
					break;
				/* ڎw */
				case SB_THUMBTRACK:
					wAddr = (WORD)(HIWORD(wParam) * 16);
					break;
			}
			wAddr &= (WORD)0xfff0;
			AddrMemory(nCPU, wAddr);
			RefreshMemory();
			break;

#ifdef XM7DASH
		/* EBhEړ */
		case WM_MOVE:
			/* ŏ̃TuEBhEҔ */
			MoveSubWindow(hWnd);
			break;
#endif
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	_vEChE(C)
 *	EChEvV[W
 */
static LRESULT CALLBACK MemoryProcMain(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return MemoryProc(hWnd, message, wParam, lParam, MAINCPU);
}

/*
 *	_vEChE(Tu)
 *	EChEvV[W
 */
static LRESULT CALLBACK MemoryProcSub(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return MemoryProc(hWnd, message, wParam, lParam, SUBCPU);
}

/*
 *	_vEChE({Tu)
 *	EChEvV[W
 */
#ifdef JSUB
static LRESULT CALLBACK MemoryProcJsub(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	return MemoryProc(hWnd, message, wParam, lParam, JSUBCPU);
}
#endif

/*
 *	_vEChE
 *	EChE쐬
 */
HWND FASTCALL CreateMemory(HWND hParent, BYTE nCPU, int index)
{
	WNDCLASSEX wcex;
	char szClassNameMain[] = "XM7_MemoryMain";
	char szClassNameSub[] = "XM7_MemorySub";
#ifdef JSUB
	char szClassNameJsub[] = "XM7_MemoryJsub";
#endif
	char *szClassName;
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
	SCROLLINFO si;
	int height;
	UINT id;
	WORD pc;
#ifdef XM7DASH
	DWORD dwExStyle;
#endif

	ASSERT(hParent);

	/* EChE`vZ */
#ifdef XM7DASH
	PositioningSubWindow(hParent, &rect, index);
#else
	rect.left = lCharWidth * index;
	rect.top = lCharHeight * index;
	if (rect.top >= 380) {
		rect.top -= 380;
	}
#endif

#ifdef XM7DASH
	if (bPopupSwnd) {
		/* ʉ𑜓xɍ킹vZ */
		height = ((GetSystemMetrics(SM_CYSCREEN) + lCharHeight - 1) / lCharHeight) + 3;
	}
	else {
		/* NCAg̈̃TCYɍ킹vZ */
		GetClientRect(hParent, &crect);
		height = (crect.bottom + lCharHeight - 1) / lCharHeight;
	}
#else
	/* NCAg̈̃TCYɍ킹vZ */
	GetClientRect(hParent, &crect);
	height = ((crect.bottom + lCharHeight - 1) / lCharHeight) + 3;
#endif

	/* EChE^CgAobt@mہAj[[h */
	switch (nCPU) {
		case MAINCPU :	id = IDS_SWND_MEMORY_MAIN;
						pc = maincpu.pc;
						szClassName = szClassNameMain;
						break;
		case SUBCPU :	id = IDS_SWND_MEMORY_SUB;
						pc = subcpu.pc;
						szClassName = szClassNameSub;
						break;
#ifdef JSUB
		case JSUBCPU :	id = IDS_SWND_MEMORY_JSUB;
						pc = jsubcpu.pc;
						szClassName = szClassNameJsub;
						break;
#endif
	}
	rect.bottom = lCharHeight * nHeightMemory[nCPU];
	LoadString(hResInstance, id, szWndName, sizeof(szWndName));
	pMemory[nCPU] = malloc(2 * 75 * height);
	wMemory[nCPU] = pc;
	hMemory[nCPU] = LoadMenu(hResInstance, MAKEINTRESOURCE(IDR_MEMDMPMENU));

	/* EBhE */
	if (bAsciiDump[nCPU]) {
		rect.right = lCharWidth * 75;
	}
	else {
		rect.right = lCharWidth * 53;
	}

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS;
	switch (nCPU) {
		case MAINCPU :	wcex.lpfnWndProc = MemoryProcMain;
						break;
		case SUBCPU :	wcex.lpfnWndProc = MemoryProcSub;
						break;
#ifdef JSUB
		case JSUBCPU :	wcex.lpfnWndProc = MemoryProcJsub;
						break;
#endif
	}
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
#ifdef XM7DASH
	if (bPopupSwnd) {
		dwExStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_BORDER
					| WS_VSCROLL | WS_SIZEBOX;
	}
	else {
		dwExStyle = WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_CLIPSIBLINGS
					| WS_VSCROLL | WS_SIZEBOX;
	}
	if (bSwndVisible) {
		dwExStyle |= WS_VISIBLE;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwExStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#else
	hWnd = CreateWindow(szClassName,
						szWndName,
						WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
						| WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS
						| WS_VSCROLL | WS_SIZEBOX ,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#endif

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);

		/* XN[o[̐ݒ肪Kv */
		memset(&si, 0, sizeof(si));
		si.cbSize = sizeof(si);
		si.fMask = SIF_ALL;
		si.nMin = 0;
		si.nPage = 0x10;
		height = nHeightMemory[nCPU];
		si.nPos = (pc >> 4);
		if (bAsciiDump) {
			height -= 3;
		}
		si.nMax = 0x100f - height;
		SetScrollInfo(hWnd, SB_VERT, &si, TRUE);
	}

	/* ʂA */
	return hWnd;
}

#ifdef XM7DASH
HWND FASTCALL CreateMemoryMain(HWND hParent, int index)
{
	return	CreateMemory(hParent, MAINCPU, index);
}

HWND FASTCALL CreateMemorySub(HWND hParent, int index)
{
	return	CreateMemory(hParent, SUBCPU, index);
}

#ifdef JSUB
HWND FASTCALL CreateMemoryJSub(HWND hParent, int index)
{
	return	CreateMemory(hParent, JSUBCPU, index);
}
#endif
#endif

/*-[ OEChE ]--------------------------------------------------------*/

#if defined(XM7DASH) && defined(DBGLOG)
/*
 *	OEChE
 *	Oݒ
 */
static void FASTCALL LogAddString(const char *string)
{
	int index;

	ASSERT(string);

	/* bN */
	LockVM();

	/* ǉʒu߂ */
	if (nLogNum < LogMax) {
		ASSERT(nLogTop == 0);
		index = nLogNum;
		ASSERT(stLogData[index] == NULL);
		nLogNum++;
	}
	else {
		ASSERT(nLogNum == LogMax);
		index = nLogTop;
		nLogTop++;
		nLogTop &= (LogMax - 1);
	}

	/* ɑ݂Ή */
	if (stLogData[index]) {
		if (stLogData[index]->string) {
			/* |C^ */
			free(stLogData[index]->string);
		}
		/* f[^{̂ */
		free(stLogData[index]);

		/* NULL */
		stLogData[index] = NULL;
	}

	/* \̂zu */
	stLogData[index] = (void *)malloc(sizeof(stLogData));
	stLogData[index]->number = nLogCnt++;
	stLogData[index]->time = dwExecTotal;
	stLogData[index]->pc = maincpu.pc;

	/* 񏈗 */
	stLogData[index]->string = (char *)malloc(strlen(string) + 1);
	memcpy(stLogData[index]->string, string, strlen(string) + 1);

	/* OAIɈxNA(16ڈƂ) */
	if (nLogCnt >= 0x60000000) {
		int i;
		int index;

		index = nLogTop;
		for (i=0; i<nLogNum; i++) {
			/* f[^ */
			if (stLogData[index]) {
				if (stLogData[index]->string) {
					/* |C^ */
					free(stLogData[index]->string);
				}
				/* f[^{̂ */
				free(stLogData[index]);

				/* NULL */
				stLogData[index] = NULL;
			}

			/* CfbNXړ */
			index++;
			index &= (LogMax - 1);
		}

		/* Ǘ[NNA */
		nLogTop = 0;
		nLogNum = 0;
		nLogCnt = 1;
	}

	/* AbN */
	UnlockVM();

	if (hSubWnd[SWND_LOG]) {
		nLogDsp = index - nLogTop - lLogHeight / lCharWidth;
		if (nLogDsp < 0) {
			nLogDsp = 0;
		}
	}
}

/*
 *	tAZuEBhE
 *	TCY
 */
static void FASTCALL ResizeLog(HWND hWnd, WORD cx, WORD cy)
{
	RECT crect;
	RECT wrect;
	int width;

	ASSERT(hWnd);

	/* ŏ̏ꍇ́AȂ */
	if ((cx == 0) && (cy == 0)) {
		return;
	}

	lLogWidth = cx;							/* O EBhETCY */
	lLogHeight = cy;						/* O EBhEcTCY */
	MoveWindow(hWnd, 0, 0, cx, cy, /*TRUE*/FALSE);
}

/*
 *	OEChE
 *	tbV
 */
void FASTCALL RefreshLog(void)
{
	/* CCPU */
	if (hSubWnd[SWND_LOG]) {
		ListView_EnsureVisible(hLogWnd, nLogNum - 1, TRUE);
	}
}

/*
 *	OEChE
 *	XgRg[쐬
 */
static HWND FASTCALL CreateLogList(HWND hWnd, HINSTANCE hInst)
{
	HDC hDC;
	TEXTMETRIC tm;
	int i;
	char string[128];
	LVCOLUMN lvc;
	static struct HEADERTABLE {
		UINT id;
		int fmt;
		int cx;
	} headertable[] = {
		{IDS_SWND_LOG_NUMBER,	LVCFMT_RIGHT,	7},		/* J0(ʂԍ) */
		{IDS_SWND_LOG_TIME,		LVCFMT_RIGHT,	10},	/* J1() */
		{IDS_SWND_LOG_MSG,		LVCFMT_LEFT,	32},	/* J2(bZ[W) */
	};

	hLogWnd = CreateWindowEx(	0,
								WC_LISTVIEW,
								"",
								WS_CHILD | WS_VISIBLE | LVS_REPORT |
								LVS_OWNERDATA,
								0,
								0,
								0,
								0,
								hWnd,
								(HMENU)IDC_LOGLIST,
								hInst,
								NULL);
	ListView_SetItemCountEx(hLogWnd, LogMax, LVSICF_NOINVALIDATEALL);

	/* eLXggbN擾 */
	hDC = GetDC(hLogWnd);
	GetTextMetrics(hDC, &tm);
	ReleaseDC(hLogWnd, hDC);

	/* }[v */
	for (i=0; i<(sizeof(headertable)/sizeof(struct HEADERTABLE)); i++) {
		/* eLXg[h */
		LoadString(hResInstance, headertable[i].id, string, sizeof(string));

		/* J\̂쐬 */
		lvc.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_WIDTH | LVCF_TEXT;
		lvc.fmt = headertable[i].fmt;
		lvc.cx = headertable[i].cx * tm.tmAveCharWidth;
		lvc.pszText = string;
		lvc.cchTextMax = strlen(string);
		lvc.iSubItem = i;

		/* J} */
		ListView_InsertColumn(hLogWnd, i, &lvc);
	}

	return	hLogWnd;
}

/*
 *	W[y[W
 *	Kp
 */
static BOOL FASTCALL LogListGetDispInfo(LVITEM *pitem)
{
	int index;
	logdata_t *pstLogData;
	char string[256+1];
	char buffer[256+1];
	DWORD dwTime;

	if (!(pitem->mask & LVIF_TEXT)) {
		return	FALSE;
	}

	if (nLogNum == 0) {
		return	FALSE;
	}
	index = pitem->iItem;
	if (nLogNum == LogMax) {
		index += nLogTop;
		index &= (LogMax - 1);
	}
	pstLogData = stLogData[index];
	if (pstLogData == NULL) {
		return	FALSE;
	}

	switch(pitem->iSubItem) {
	case 0:
		/* No. */
		memset(string, 0, sizeof(string));
		_snprintf(string, sizeof(string), "%d", pstLogData->number);
		memset(pitem->pszText, 0, pitem->cchTextMax);
		strncpy(pitem->pszText, string, pitem->cchTextMax - 1);
		break;
	case 1:
		/*  */
		memset(string, 0, sizeof(string));
		dwTime = (DWORD)pstLogData->time;
		_snprintf(string, sizeof(string), "%d.", dwTime / (1000 * 1000));
		dwTime %= (1000 * 1000);
		_snprintf(buffer, sizeof(buffer), "%03d.",dwTime / 1000);
		strncat(string, buffer, sizeof(string)-strlen(string)-1);
		dwTime %= 1000;
		_snprintf(buffer, sizeof(buffer), "%03d",dwTime);
		strncat(string, buffer, sizeof(string)-strlen(string)-1);
		memset(pitem->pszText, 0, pitem->cchTextMax);
		strncpy(pitem->pszText, string, pitem->cchTextMax - 1);
		break;
	case 2:
		/* bZ[W */
		memset(pitem->pszText, 0, pitem->cchTextMax);
		strncpy(pitem->pszText, pstLogData->string, pitem->cchTextMax - 1);
		break;
	}
	return	TRUE;
}

/*
 *	OEChE
 *	EChEvV[W
 */
static LRESULT CALLBACK LogProc(HWND hWnd, UINT message,
								 WPARAM wParam, LPARAM lParam)
{
	static BOOL bResize = FALSE;	/* 蓮TCYtO */
	LPNMHDR lpNmhdr;
	NMLVDISPINFO *lpDispInfo;

	/* bZ[W */
	switch (message) {
		/* EChE폜 */
		case WM_DESTROY:
			LockVM();

			/* CEChE֎ʒm */
			DestroySubWindow(hWnd, NULL, NULL);

			UnlockVM();
			break;

		/* EChE쐬 */
		case WM_CREATE:
			CreateLogList(hWnd, ((LPCREATESTRUCT)lParam)->hInstance);
			return	0;

		/* EChE */
		case WM_CLOSE:
			/* OEBhE폜 */
			DestroyWindow(hLogWnd);
			hLogWnd = NULL;
			break;

		/* EChETCYύX */
		case WM_SIZE:
			if (bResize) {
				bResize = FALSE;
				ResizeLog(hLogWnd, LOWORD(lParam), HIWORD(lParam));
			}
			break;

		/* EChETCYύX */
		case WM_SIZING:
			bResize = TRUE;
			break;

		/* EBhETCYύXbZ[W */
		case WM_WINDOWPOSCHANGING:
			bResize = TRUE;
			break;

#ifdef XM7DASH
		/* EBhEړ */
		case WM_MOVE:
			/* ŏ̃TuEBhEҔ */
			MoveSubWindow(hWnd);
			break;
#endif

		/* ʒm */
		case WM_NOTIFY:
			if (wParam == (WPARAM)IDC_LOGLIST) {
				lpNmhdr = (LPNMHDR)lParam;
				if (lpNmhdr->code == LVN_GETDISPINFO) {
					lpDispInfo = (NMLVDISPINFO*)lParam;
					if (LogListGetDispInfo(&lpDispInfo->item)) {
						return TRUE;
					}
				}
			}
			break;
	}

	/* ftHg EChEvV[W */
	return DefWindowProc(hWnd, message, wParam, lParam);
}

/*
 *	OEChE
 *	EChE쐬
 */
HWND FASTCALL CreateLog(HWND hParent, int index)
{
	WNDCLASSEX wcex;
	char szClassName[] = "XM7_Log";
	char szWndName[128];
	RECT rect;
	RECT crect, wrect;
	HWND hWnd;
	SCROLLINFO si;
#ifdef XM7DASH
	DWORD dwExStyle;
#endif

	ASSERT(hParent);

	/* EChE`vZ */
#ifdef XM7DASH
	PositioningSubWindow(hParent, &rect, index);
#else
	rect.left = lCharWidth * index;
	rect.top = lCharHeight * index;
	if (rect.top >= 380) {
		rect.top -= 380;
	}
#endif
	rect.right = lLogWidth;
	rect.bottom = lLogHeight;

	/* EChE^CgAobt@m */
	LoadString(hResInstance, IDS_SWND_LOG, szWndName, sizeof(szWndName));

	/* EChENX̓o^ */
	memset(&wcex, 0, sizeof(wcex));
	wcex.cbSize = sizeof(wcex);
	wcex.style = CS_VREDRAW | CS_HREDRAW;
	wcex.lpfnWndProc = LogProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hResInstance;
	wcex.hIcon = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = szClassName;
	wcex.hIconSm = LoadIcon(hAppInstance, MAKEINTRESOURCE(IDI_WNDICON));
	RegisterClassEx(&wcex);

	/* EChE쐬 */
#ifdef XM7DASH
	if (bPopupSwnd) {
		dwExStyle =	WS_POPUP | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_BORDER
					| WS_SIZEBOX;
	}
	else {
		dwExStyle = WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
					| WS_MINIMIZEBOX | WS_CLIPSIBLINGS
					| WS_SIZEBOX;
	}
	if (bSwndVisible) {
		dwExStyle |= WS_VISIBLE;
	}
	hWnd = CreateWindow(szClassName,
						szWndName,
						dwExStyle,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#else
	hWnd = CreateWindow(szClassName,
						szWndName,
						WS_CHILD | WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION
						| WS_VISIBLE | WS_MINIMIZEBOX | WS_CLIPSIBLINGS
						| WS_SIZEBOX,
						rect.left,
						rect.top,
						rect.right,
						rect.bottom,
						hParent,
						NULL,
						hResInstance,
						NULL);
#endif

	/* LȂATCY␳ĎOɒu */
	if (hWnd) {
		GetWindowRect(hWnd, &wrect);
		GetClientRect(hWnd, &crect);
		wrect.right += (rect.right - crect.right);
		wrect.bottom += (rect.bottom - crect.bottom);
		SetWindowPos(hWnd, HWND_TOP, wrect.left, wrect.top,
			wrect.right - wrect.left, wrect.bottom - wrect.top, SWP_NOMOVE);
	}

	/* ʂA */
	return hWnd;
}

/*
 *	OEChE
 *	tH[}bg
 */
void AddLogPrintf(const char *format, ...)
{
	char buffer[0x200];
	va_list args;
	va_start(args, format);

	/* tH[}bg */
	vsprintf(buffer, format, args);

	/* ϒI */
	va_end(args);

	/* bZ[Wǉ */
	LogAddString(buffer);
}
#endif

#endif	/* _WIN32 */
